var img_popup_close_button = pathConverter('images/btn_close.png');

var default_zIndex = 10000;
var move_zIndex = 10001;
var popup_zIndex = 15000;
var last_zIndex = 15001;
var close_btn_pos = 1;

if(window['_component'] == undefined) {	window._component = new Array(); };

var div_component = function()
{		
	this.constructor = function(){ return 'div_component' };

	var _div = document.createElement('div');
	_div.style.position = 'absolute';
	_div.style.left = '0px';
	_div.style.right = '0px';
	_div.style.top = '0px';
	_div.style.bottom = '0px';

	return _div;
}

var image_component = function(_src, _width, _height, _callback_loaded)
{	
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'image_component' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this._parent = div_component();
	this._parent.className = 'component';
	this._parent.style.zIndex = default_zIndex;
	this._parent.style.display = 'none';
	this._img = document.createElement('img');

/*
	if(_width != undefined && !isNaN(_width))
			this._img.width = _width;
	if(_height != undefined && !isNaN(_height))
			this._img.height = _height;
*/
	this._img.src = _src;

	this._img.onload = function () {

		//console.log('image loaded : ' + _src);

		self._parent.style.display = 'block';

		if(_width == undefined )
			self._parent.style.width  = ((this.width != 0) ? this.width : this.naturalWidth)   + 'px';
		else if(isNaN(_width) && _width.toLowerCase() == 'adjust')
			self._parent.style.width  = clientWidth + 'px';
   		else if(_width != undefined && isNaN(_width) && _width.indexOf('%') != -1)
			//self._parent.style.width = (this.width * Number(_width.replace('%', '')) / 100) + 'px';
			self._parent.style.width = (clientWidth * Number(_width.replace('%', '')) / 100) + 'px';
		else
	   		self._parent.style.width  =  ((isNaN(_width)) ? this.width : _width) + 'px';

		if(_height == undefined )
			self._parent.style.height  = ((this.height != 0) ? this.height : this.naturalHeight) + 'px';
		else if(isNaN(_height) && _height.toLowerCase() == 'adjust')
			self._parent.style.height  = clientHeight + 'px';
		else if(_height != undefined && isNaN(_height) && _height.indexOf('%') != -1)
			//self._parent.style.height = (this.height * Number(_height.replace('%','')) / 100) + 'px';
			self._parent.style.height = (clientHeight * Number(_height.replace('%','')) / 100) + 'px';
		else
	   		self._parent.style.height  = ((isNaN(_height)) ? this.height : _height ) + 'px';

	   	log('imgage : ' + clientWidth + ',' + clientHeight);

		this.setAttribute('width', '100%');
		this.setAttribute('height', '100%');

		if(_callback_loaded != undefined)
			_callback_loaded(self, self._parent);
	}

	this.element = this._parent;
	this.elementChild = this._img;

	this._parent.appendChild(this._img);
	document.body.appendChild(this._parent);

	return this;
}

var video_component = function(_src, _width, _height, _callback_loaded)
{	
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'video_component' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this._parent = div_component();
	this._parent.className = 'component';
	this._parent.style.zIndex = default_zIndex;
	this._parent.style.display = 'block';
	this._parent.style.background = '#000000';

	this._video = document.createElement('video');
	this._video.setAttribute('controls', true);
	this._video.src = _src;

    this._video.addEventListener("loadstart", function (evt) {
		self._parent.style.display = 'none';
    });

   this._video.addEventListener("loadedmetadata", function (evt) {
	
		log('video oadedmetadata 00');

		if(_width == undefined )
			self._parent.style.width  = this.clientWidth + 'px';
		else if(isNaN(_width) && _width.toLowerCase() == 'adjust')
			self._parent.style.width  = clientWidth + 'px';
   		else if(_width != undefined && isNaN(_width) && _width.indexOf('%') != -1)
//			self._parent.style.width = (this.clientWidth * Number(_width.replace('%', '')) / 100) + 'px';
			self._parent.style.width = (clientWidth * Number(_width.replace('%', '')) / 100) + 'px';
		else
	   		self._parent.style.width  = ((isNaN(_width)) ? this.clientWidth : _width) + 'px';

		if(_height == undefined )
			self._parent.style.height  = this.clientHeight + 'px';
		else if(isNaN(_height) && _height.toLowerCase() == 'adjust')
			self._parent.style.height  = clientHeight + 'px';
		else if(_height != undefined && isNaN(_height) && _height.indexOf('%') != -1)
			//self._parent.style.height = (this.clientHeight * Number(_height.replace('%','')) / 100) + 'px';
			self._parent.style.height = (clientHeight * Number(_height.replace('%','')) / 100) + 'px';
		else
	   		self._parent.style.height  = ((isNaN(_height)) ? this.clientHeight : _height ) + 'px';

		if(IsExcept != undefined)
		{
			this.style.width = self._parent.style.width;
			this.style.height = self._parent.style.height;
		}
		else
		{
			this.setAttribute('width', '100%');
			this.setAttribute('height', '100%');
		}

		self._parent.style.background = '#000000';

		self.centerPos(true);

		self._parent.style.display = 'block';

    });

    this._video.addEventListener("canplay", function (evt) {
        log('_video : ' + _src + ' / canplay');
    });

    this._video.addEventListener("progress", function (e) {
            //console.log('progress : ' + self.id);
        log('_video : ' + _src + ' / progress');
    });

     this._video.addEventListener('stalled', function() {
		log('_video : ' + _src + ' / stalled');

    }, false);

     this._video.addEventListener('suspend', function() {
		log('_video : ' + _src + ' / suspend');
    }, false);

     this._video.addEventListener('abort', function() {
		log('_video : ' + _src + ' / abort');
    }, false);

     this._video.addEventListener('error', function() {
		log('_video : ' + _src + ' / error');
    }, false);

     this._video.addEventListener('loadend', function() {
		log('_video : ' + _src + ' / loadend');
    }, false);

    this.show = function()
    {
    	this._parent.style.display = 'block';
    }

    this.hide = function()
    {
    	this._parent.style.display = 'none';
    }

    this.isVisible = function()
    {
    	return (this._parent.style.display != 'none');
    }

    this.play = function()
    {
    	self._video.play();
    }

    this.pause = function()
    {
    	self._video.pause();
    }

    this.stop = function()
    {
    	self._video.pause();
    	self._video.currentTime = 0;
    }

	this.element = this._parent;
	this.elementChild = this._video;

	this._parent.appendChild(this._video);

	document.body.appendChild(this._parent);

	if(_callback_loaded != undefined)
   		_callback_loaded(self, self._video);
   	var v_this = this;
   	document.addEventListener("keydown", function(e) {
	    if (e.keyCode == 13) {
	        toggleFullScreen(v_this);
	    }
	}, false);

	return this;
}

function toggleFullScreen(ele) {
    /*var _ele = document.getElementsByTagName('video');
    if (_ele.requestFullscreen) {
	  _ele.requestFullscreen();
	} else if (_ele.mozRequestFullScreen) {
	  _ele.mozRequestFullScreen();
	} else if (_ele.webkitRequestFullscreen) {
	  _ele.webkitRequestFullscreen();
	}*/
    if (!document.fullscreenElement && // alternative standard method
        !document.mozFullScreenElement && !document.webkitFullscreenElement) { // current working methods
        if (document.documentElement.requestFullscreen) {
            document.documentElement.requestFullscreen();
        } else if (document.documentElement.mozRequestFullScreen) {
            document.documentElement.mozRequestFullScreen();
        } else if (document.documentElement.webkitRequestFullscreen) {
            document.documentElement.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
        }
    } else {
        if (document.cancelFullScreen) {
            document.cancelFullScreen();
        } else if (document.mozCancelFullScreen) {
            document.mozCancelFullScreen();
        } else if (document.webkitCancelFullScreen) {
            document.webkitCancelFullScreen();
        }
    }
}

function supportedAudioFormat(audio) {
	var returnExtension = "";

	if(audio.canPlayType("audio/mpeg") == "probably" || audio.canPlayType("audio/mpeg") == "maybe") {
		returnExtension = "mpeg";
	}
	else {
		if (audio.canPlayType("audio/ogg") =="probably" || audio.canPlayType("audio/ogg") == "maybe") {
			returnExtension = "ogg";
		}
		else if(audio.canPlayType("audio/wav") =="probably" || audio.canPlayType("audio/wav") == "maybe") {
			returnExtension = "wav";
		}
	}

	return returnExtension;
}

var audio_component = function(_id, _src, _width, _height, _callback_loaded)
{	
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'audio_component' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this._parent = div_component();
	this._parent.className = 'component';
	this._parent.style.zIndex = default_zIndex;
	this._parent.style.background = '#000000';
	this._parent.style.display = 'none';
	this._audio = document.createElement('audio');
   	this._audio.setAttribute('controls', true);
    this._audio.src = _src;

	var audioType = supportedAudioFormat(this._audio);

	this.element = this._parent;
	this.elementChild = this._audio;

	this.elementChild.id = 'audio_'+_id;
	this.elementChild.className = 'component';
	this.elementChild.setAttribute('preload', 'auto');
	this.elementChild.setAttribute('type', 'audio/mpeg');
	this.elementChild.style.zIndex = default_zIndex;
	this.elementChild.style.background = '#000000';
	this.elementChild.style.display = 'none';
	this.elementChild.style.position = 'asolute';
	this.element.appendChild(this.elementChild);
	/*var target = document.getElementById('audio_'+_id);
	var toppx = _id.split('_')[1] +'00px';
	target.style.margin = toppx + ' 0 0 0';*/

	this._audio.onloadeddata = function(e){
		if (ios && userAgent.indexOf('os 9') != -1)
		{
			self._audio.play();
		}
    };

    this._audio.addEventListener("loadstart", function (evt) {
		self._parent.style.display = 'none';
    });

   this._audio.addEventListener("loadedmetadata", function (evt) {
		try{
			if(_width == undefined )
				//self._parent.style.width  = this.clientWidth + 'px';
			self._parent.style.width  = (clientWidth * 0.7)+ 'px';
			else if(isNaN(_width) && _width.toLowerCase() == 'adjust')
				self._parent.style.width  = clientWidth + 'px';
	   		else if(_width != undefined && isNaN(_width) && _width.indexOf('%') != -1)
	//			self._parent.style.width = (this.clientWidth * Number(_width.replace('%', '')) / 100) + 'px';
				self._parent.style.width = (clientWidth * Number(_width.replace('%', '')) / 100) + 'px';
			else
		   		self._parent.style.width  = ((isNaN(_width)) ? this.clientWidth : _width) + 'px';

			if(_height == undefined )
				self._parent.style.height  = this.clientHeight + 'px';
			else if(isNaN(_height) && _height.toLowerCase() == 'adjust')
				self._parent.style.height  = clientHeight + 'px';
			else if(_height != undefined && isNaN(_height) && _height.indexOf('%') != -1)
	//			self._parent.style.height = (this.clientHeight * Number(_height.replace('%','')) / 100) + 'px';
				self._parent.style.height = (clientHeight * Number(_height.replace('%','')) / 100) + 'px';
			else
		   		self._parent.style.height  = ((isNaN(_height)) ? this.clientHeight : _height ) + 'px';
			}
		catch(e)
		{
			alert('audio exception : ' + e.toString());
		}

		if(IsExcept != undefined)
		{
			this.style.width = self._parent.style.width;
			this.style.height = self._parent.style.height;
		}
		else
		{
			this.setAttribute('width', '100%');
			this.setAttribute('height', '100%');
		}

		self._parent.style.background = UTIL.color2rgba('#000000', 0.5);
		this.style.float = 'left';
		this.style.position = 'absolute';
		this.style.width = '100%';
		this.style.top = '45%';
		//this.style.top = 'calc(' + self._parent.style.height + '/2 - 15px)';
//		this.style.left = 'calc(50% - (' +  this.offsetWidth/2 + 'px )';

		self.centerPos(true);

		self._parent.style.display = 'block';
    });

    this._audio.addEventListener("canplay", function (evt) {
    });

    this._audio.addEventListener("progress", function (e) {
            //console.log('progress : ' + self.id);
    });

     this._audio.addEventListener('stalled', function() {
		log('audio : ' + _src + ' / stalled');

    }, false);

     this._audio.addEventListener('suspend', function() {
		log('audio : ' + _src + ' / suspend');
    }, false);

     this._audio.addEventListener('abort', function() {
		log('audio : ' + _src + ' / abort');
    }, false);

     this._audio.addEventListener('error', function() {
		log('audio : ' + _src + ' / error');
    }, false);

     this._audio.addEventListener('loadend', function() {
		log('audio : ' + _src + ' / loadend');
    }, false);

    this.show = function()
    {
    	this._parent.style.display = 'block';
    }

    this.hide = function()
    {
    	this._parent.style.display = 'none';
    }

    this.isVisible = function()
    {
    	return (this._parent.style.display != 'none');
    }

    this.load = function()
    {
    	self._audio.load();
    }

    this.play = function()
    {
    	self._audio.play();
    }

    this.pause = function()
    {
    	self._audio.pause();
    }

    this.stop = function()
    {
    	self._audio.pause();
    	self._audio.currentTime = 0;
    }

    this.isPlayed = function()
    {
    	return !self._audio.paused;	
    }

	if(_callback_loaded != undefined)
		_callback_loaded(self, self._audio);				

	return this;
}


var popup_image = function(_image_src, _width, _height, _callback_loaded, _callback_opened, _callback_closed)
{
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'popup_image' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this.popup = div_component();
	this.popup.style.display = 'none';
	this.popup.style.zIndex = popup_zIndex;
/*	this.popup.style.position = 'absolute'; */
	clientWidth = document.body.clientWidth;
	clientHeight = document.body.clientHeight;

	this.init_popup_view = function()
	{
		var background = div_component();
	/*	background.style.position = 'absolute'; */
		background.style.width = clientWidth + 'px';
		background.style.height = clientHeight + 'px';
		background.style.background = '#000000';
		background.style.opacity = '0.5';
		self.popup.appendChild(background);

		self.close_button = new image_component(img_popup_close_button, undefined, undefined, function(undefined, _element)
		{
			_element.style = null;
			_element.style.cursor = 'pointer';
			_element.style.position = 'absolute';
			_element.style.left = '20px';//(clientWidth / 2 - 45) + 'px';
			//_element.style.right = (clientWidth / 2 - 15) + 'px';
			_element.style.top = '20px';
			//_element.style.bottom = '5px';
			_element.style.zIndex = '10001';

			var button_pos = function()
			{
				_element.style.top = '20px';
				//_element.style.bottom = '5px';
			}

			_element.addEventListener(StartEventType, function()
			{
				self.hide();
			});

			window.addEventListener('resize', function()
			{
				button_pos();
			});

			button_pos();
		});

		self.popup.appendChild(self.sub_object.element);
		self.popup.appendChild(self.close_button.element);
	}

	this.sub_object = new image_component(_image_src, _width, _height, function(_this)
	{
		self.popup.style.display = 'none';
		self.init_popup_view();
		_this.centerPos(true);
		if(_callback_loaded != undefined)
			_callback_loaded();
	});

	document.body.appendChild(this.popup);

// 	window.onresize = function()
// 	{
// //		log('resize width_ : ' + document.documentElement.clientWidth);
// //		log('resize height_ : ' + document.documentElement.clientHeight);
// 		log('doc : ' + document.documentElement.clientWidth + ',' + document.documentElement.clientHeight);
// 		//log('parent : ' + self.sub_object._parent.style.width + ',' + self.sub_object._parent.style.height);
// 		log('background : ' + background.style.width + ',' + background.style.height);
// //		self.sub_object._parent.style.width = clientWidth + 'px';
// //		self.sub_object._parent.style.height = clientHeight+ 'px';
// 	}				

	this.show = function()
	{
		this.popup.style.display = 'block';

  		if(last_zIndex != Number(self.popup.style.zIndex))
			self.popup.style.zIndex = last_zIndex+1;

		if(_callback_opened != undefined)
			_callback_opened(self);
	};

	this.hide = function()
	{
		this.popup.style.display = 'none';

		self.popup.style.zIndex = Number(self.popup.style.zIndex)-1;

		if(_callback_closed != undefined)
			_callback_closed(self);
	};

	this.setPosition = function(_align)
	{
		this.align = _align;
	};

	this.isVisible = function()
	{
		return (this.popup.style.display == 'block') ? true : false;
	};

	this.element = this.popup;

	return this;
}

var popup_video = function(_video_src, _width, _height, _callback_loaded, _callback_opened, _callback_closed)
{
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'popup_video' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this.popup = div_component();
	this.popup.style.display = 'none';
	this.popup.style.zIndex = popup_zIndex;
/*	this.popup.style.position = 'absolute'; */
	clientWidth = document.body.clientWidth;
	clientHeight = document.body.clientHeight;
	
	this.button_pos = null;
	this.init_popup_view = function()
	{
		var background = div_component();
	/*	background.style.position = 'absolute'; */
		background.style.width = clientWidth + 'px';
		background.style.height = clientHeight + 'px';
		background.style.background = '#000000';
		background.style.opacity = '1';
		self.popup.appendChild(background);

		self.close_button = new image_component(img_popup_close_button, undefined, undefined, function(undefined, _element)
		{
			_element.style = null;
			_element.style.cursor = 'pointer';
			_element.style.position = 'absolute';
			_element.style.left = '20px';//(clientWidth / 2 - 45) + 'px';
			//_element.style.right = (clientWidth / 2 - 15) + 'px';
			_element.style.top = '20px';
			//_element.style.bottom = '5px';
			_element.style.zIndex = '10001';

			self.popup.appendChild(self.close_button.element);

			self.button_pos = function()
			{
				log('popup button pos : ' + _element.style.zIndex);
				_element.style.left = '20px';
			}

			_element.addEventListener(StartEventType, function()
			{
//				alert('stop');
				self.stop();
				self.hide();
			});

			window.button_pos = self.button_pos;

			window.addEventListener('resize', function()
			{
				self.button_pos();
			});

			self.button_pos();
		});

	}

	this.sub_object = new video_component(_video_src, _width, _height, function(_this)
	{
		self.popup.style.display = 'none';

		self.init_popup_view();

		self.popup.appendChild(_this.element);

		if(_callback_loaded != undefined)
			_callback_loaded();
	});

	document.body.appendChild(this.popup);

	this.show = function()
	{
		self.popup.style.display = 'block';

  		if(last_zIndex != Number(self.popup.style.zIndex))
			self.popup.style.zIndex = last_zIndex+1;

		if(_callback_opened != undefined)
			_callback_opened(self);
	};

	this.hide = function()
	{
		this.popup.style.display = 'none';

		self.popup.style.zIndex = Number(self.popup.style.zIndex)-1;

		if(_callback_closed != undefined)
			_callback_closed(self);
	};

	this.setPosition = function(_align)
	{
		this.align = _align;
	};

	this.isVisible = function()
	{
		return (this.popup.style.display == 'block') ? true : false;
	};

	  this.play = function()
    {
    	self.sub_object._video.play();
    }

    this.pause = function()
    {
    	self.sub_object._video.pause();
    }

    this.stop = function()
    {
    	try{
    		self.sub_object._video.pause();
    		self.sub_object._video.currentTime = 0.1;
	    }catch(e)
	    {
	    	alert('stop Exception : ' + e.toString());
	    }
    }

	this.element = this.popup;

	return this;
}

var popup_audio = function(_target_id, _audio_src, _width, _height, _callback_loaded, _callback_opened, _callback_closed)
{
    /*Append Function*/
	if(IsExcept == undefined)
	    addFunction(this.__proto__, common_func);
	else
		addFunction(this, common_func);

	this.constructor = function(){ return 'popup_audio' };

	if(_width <= 0 )
		_width = undefined;

	if(_height <= 0 )
		_height = undefined;

	var self = this;
	this.popup = div_component();
	this.popup.style.display = 'none';
	this.popup.style.zIndex = popup_zIndex;
/*	this.popup.style.position = 'absolute'; */
	clientWidth = document.body.clientWidth;
	clientHeight = document.body.clientHeight;

	this.init_popup_view = function()
	{
		var background = div_component();
	/*	background.style.position = 'absolute'; */
		background.style.width = clientWidth + 'px';
		background.style.height = clientHeight + 'px';
		background.style.background = '#000000';
		background.style.opacity = '0.5';
		self.popup.appendChild(background);

		self.close_button = new image_component(img_popup_close_button, undefined, undefined, function(undefined, _element)
		{
			_element.style = null;
			_element.style.cursor = 'pointer';
			_element.style.position = 'absolute';
			_element.style.left = '20px';//(clientWidth / 2 - 45) + 'px';
			//_element.style.right = (clientWidth / 2 - 15) + 'px';
			_element.style.top = '20px';
			//_element.style.bottom = '5px';
			_element.style.zIndex = '10001';

			self.popup.appendChild(self.close_button.element);

			var button_pos = function()
			{
				//_element.style.bottom = '5px';
				_element.style.left = '20px';
			}

			_element.addEventListener(StartEventType, function()
			{
				self.stop();
				self.hide();
			});

			window.addEventListener('resize', function()
			{
				button_pos();
			});

			button_pos();
		});
	}

	this.sub_object = new audio_component(_target_id, _audio_src, _width, _height, function(_this)
	{
		self.popup.style.display = 'none';

		self.init_popup_view();

		self.popup.appendChild(_this.element);

		if(_callback_loaded != undefined)
			_callback_loaded();
	});

	document.body.appendChild(this.popup);

	this.show = function()
	{
		self.popup.style.display = 'block';
		self.sub_object._audio.style.display = 'block';
		
  		if(last_zIndex != Number(self.popup.style.zIndex))
			self.popup.style.zIndex = last_zIndex+1;

		if(_callback_opened != undefined)
			_callback_opened(self);
	};

	this.hide = function()
	{
		this.popup.style.display = 'none';
		self.sub_object._audio.style.display = 'none';

		self.popup.style.zIndex = Number(self.popup.style.zIndex)-1;

		if(_callback_closed != undefined)
			_callback_closed(self);
	};

	this.setPosition = function(_align)
	{
		this.align = _align;
	};

	this.isVisible = function()
	{
		return (this.popup.style.display == 'block') ? true : false;
	};

	  this.play = function()
    {
    	self.sub_object._audio.play();
    }

    this.pause = function()
    {
    	self.sub_object._audio.pause();
    }

    this.stop = function()
    {
    	self.sub_object._audio.pause();
    	self.sub_object._audio.currentTime = 0;
    }

	this.element = this.popup;

	return this;
}


/*

javascript로 비디오/오디오 제어
▶ 미디어 재생 API
• src : src 속성 값
• currentSrc : 실제로 읽어 들여 재생 중인 미디어 데이터의 URL
• currentTime : 현재 재생 위치(시간)
• startTime : 재생할 위치(시간)
• duration : 미디어 데이터의 길이(시간)
• paused : 일시 정시 상태 여부를 반환
• defaultPlaybackRate : 기본 재생 속도, 기본 값은 1.0
• playbackRate : 재생 속도, 기본 값은 1.0, -일 경우 역재생
• ended : 재생 종료 여부를 반환
• muted : 음소거 여부를 반환
• volume : 음량(0.0~1.0)
• load() : 동영상을 다시 읽어 들임
• play() : 동영상을 재생
            • pause() : 재생 중인 동영상을 일시 정지        
        ▶ 미디어 요소의 이벤트 처리(데이터 로딩 시)
• emptied : 이전의 데이터 비움
• loadstart : 데이터 로딩 시작
• progress : 데이터 로딩 중(간헐적으로 발생)
• loadedmetadata : 미디어의 메타데이터를 읽음
• loadeddata : 데이터 로딩 완료
• canplay : 재생을 시작할 수 있음
• canplaythrough : 다운로드가 유지된다면 마지막 까지 재생할 수 있는 시점에 발생
• load : 데이터 다운로드 완료
• stalled : 데이터 다운로드가 느려짐
• suspend : 데이터 다운로드가 중지됨(에러 아님)
• abort : 데이터 다운로드가 중지됨(에러 발생)
• error : 에러 발생
            • loadend : 데이터 로딩 완료(load, abort, error 뒤에 발생)
        ▶ 미디어 요소의 이벤트 처리(미디어 재생 시)
• play : 재생 시작 알림
• playing : 재생이 시작됨
• pause : 재생 일시 정지
• timeupdate : 재생 중(여러 번 발생)
• waiting : 다음 프레임의 다운로드 대기 중
• ended : 재생 종료

*/