//------------- local page loading -----------------------------
var localPageLoaing = function(_c) {
	if (parent.ViewerManager != null && parent.ViewerManager.isEPUBMAKER3VIEWER) {
		parent.ViewerManager.PAGE_CURRENT_NUMBER = _c;
		parent.ViewerManager.sliderValue = _c;
		parent.ViewerManager.pageLoading(_c, parent.ViewerManager.PAGE_TOTAL_NUMBER);
	}
	else {
		var userAgent = navigator.userAgent.toLowerCase();
		var ios = (/iPhone/i).test(userAgent) || (/iPod/i).test(userAgent) || (/iPad/i).test(userAgent);
		var android = (/(?=.*\bAndroid\b)(?=.*\bMobile\b)/i).test(userAgent) || (/Android/i).test(userAgent);

		/*var tempPath;
		switch (_c) {
		case _c <= 9: {tempPath = "page0000" + _c + ".xhtml"; }
		case _c > 9 : {tempPath = "page000" + _c + ".xhtml"; }
		case _c > 99 : {tempPath = "page00" + _c + ".xhtml"; }
		case _c > 999 : {tempPath = "page0" + _c + ".xhtml"; }
		case _c > 9999 : {tempPath = "page" + _c + ".xhtml"; break; }
		}*/

		if (android)
		{
			window.open("epub://pageOpen/" + _c);
		}
		else
		{
			window.location = "epub://pageOpen/" + _c;
		}
	}
},
//--------------------------------------------------------------

pathConverter = function(_path) {
	var convertPath;
	if (parent.ViewerManager != null && parent.ViewerManager.isEPUBMAKER3VIEWER) {
		if(_path.indexOf("http") === -1) {
			convertPath = parent.ViewerManager.Path.cntsDirPath + parent.ViewerManager.Path.cntsFilePath + parent.ViewerManager.ePub.ops_name[0] + "/content/" + _path;
		}
		else {
			convertPath = _path;
		}
	}
	else {
		convertPath = _path;
	}
	return convertPath;
};


//------------- youtube api call -----------------------------
var onYouTubeIframeAPIReady = function() {
	var i;
	for (i = 1; document.getElementById('vida_' + i) != null; i++)
	{
		var this_id = 'vida_' + i;
		var this_sel = document.getElementById(this_id);
		var this_width = String(this_sel.clientWidth);
		var this_height = String(this_sel.clientHeight);

		if (document.getElementById('vidactl_' + i) == null || document.getElementById('vidactl_' + i).getAttribute('src') == undefined){ break; }
		var this_vid = String(document.getElementById('vidactl_' + i).getAttribute('src').split('embed/')[1].split('?')[0]);

		player = new YT.Player(String(this_id), {
		height: this_height,
			width : this_width,
				videoId : this_vid,
					  events : {
			'onReady': onPlayerReady,
				'onError' : onPlayerError,
				'onStateChange' : onPlayerStateChange
		}
		});

		players.push(player);
	}
}

var onPlayerReady = function(event) {
	//event.target.playVideo();
	//event.target.stopVideo();
}

var onPlayerError = function(event) {
	/*
	2	: û ߸ Ű  ԵǾ ֽϴ.   11ڸ ƴ  ID ϰų  ID ǥ Ǵ ǥ  ߸ ڰ Ե 쿡   ߻մϴ.
	5	: û  HTML5 ÷̾   ų HTML5 ÷̾ õ ٸ  ߻߽ϴ.
	100	: û  ã  ϴ.  ε  Ǿų  ǥõ 쿡   ߻մϴ.
	101	: û  ڰ  ÷̾  ϴ   ʽϴ.
	150	:   101 ϸ  101 Դϴ.
	*/
	console.log("youtube error", event.target.f.id, event.data);
}

function onPlayerStateChange(event) {
	if (event.data == YT.PlayerState.PLAYING) {
		//console.log("playing");
	}
}

var youtube_allStop = function() {
	for (var i = 0; i < players.length; i++)
	{
		if (players[i].stopVideo != undefined){
			players[i].stopVideo();
		}
	}
}
//--------------------------------------------------------------
var userAgent = navigator.userAgent.toLowerCase(),
iPhone = (/iPhone/i).test(userAgent),
iPod = (/iPod/i).test(userAgent),
iPad = (/iPad/i).test(userAgent),
setMinHeight;

var initMedia = function() {
	var tag = document.createElement('script');
	tag.src = "https://www.youtube.com/iframe_api";
	var firstScriptTag = document.getElementsByTagName('script')[0];
	firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

	playAudio = [];
	getAudio = document.getElementsByTagName("audio");
	if (getAudio.length > 0) {
		for (var i = 0; i < getAudio.length; i++) {
			//if (iPhone || iPod || iPad) { getAudio[i].style.minHeight = '150px'; }
			if (getAudio[i].getAttribute('data') == 'autoplay') {
				getAudio[i].setAttribute('autoplay', 'autoplay');
				getAudio[i].pause();
				playAudio.push(getAudio[i]);
			}
		}
	}
	playVideo = [];
	getVideo = document.getElementsByTagName("video");
	if (getVideo.length > 0) {
		for (var i = 0; i < getVideo.length; i++) {
			if (getVideo[i].getAttribute('data') == 'autoplay') {
				getVideo[i].setAttribute('autoplay', 'autoplay');
				getVideo[i].pause();
				playVideo.push(getVideo[i]);
			}
		}
	}
	//console.log(playAudio, playVideo);
},
fromNative = function(height) {
	//   
	if (height != undefined) {
		setMinHeight = height;
		var findAudio = document.getElementsByTagName("audio");
		if (findAudio.length > 0) {
			for (var i = 0; i < findAudio.length; i++) {
				findAudio[i].style.minHeight = height + 'px';
			}
		}
	}

	// ̵ ڵ 
	//  
	if (playAudio.length > 0) {
		playAudio[0].play();
	}
	//  
	if (playVideo.length > 0) {
		playVideo[0].play();
	}
}
//--------------------------------------------------------------