	lastType = "";
	require.config({
        baseUrl: "",
        shim: {
            xml2json: {
                deps: ['jquery'],
                exports: 'xml2json'
            },
            core: {
                deps: ['jquery'],
                exports: 'core'
            },
            widget: {
                deps: ['jquery'],
                exports: 'widget'
            },
            mouse: {
                deps: ['jquery', 'widget'],
                exports: 'mouse'
            },
            touchPunch: {
                deps: ['jquery', 'widget', 'mouse'],
                exports: 'touchPunch'
            },
            slider: {
                deps: ['jquery', 'core', 'mouse', 'widget'],
                exports: 'slider'
            },
            printarea: {
                deps: ['jquery'],
                exports: 'printarea'
            }
        },
        paths: {
            jquery: 'libs/jquery',
            xml2json: 'libs/jquery.xml2json',
            core: 'libs/jquery.core.min',
            mouse: 'libs/jquery.mouse.min',
            widget: 'libs/jquery.widget.min',
            slider: 'libs/jquery.slider',
            printarea: 'libs/jquery.PrintArea.js_4',
            base64: 'libs/base64',
            touchPunch: 'libs/jquery.touchPunch',
            log: 'js/MODEL/common/log' + lastType,
            version: 'js/MODEL/common/version' + lastType,
            browser: 'js/MODEL/common/browser' + lastType,
            params: 'js/MODEL/data/params' + lastType,
            selectViewer: 'js/CONTROL/selectViewer' + lastType,
            page: 'js/VIEW/page/page' + lastType,
            epub: 'js/MODEL/data/epub' + lastType,
            lanaguage: 'js/MODEL/data/language' + lastType,
            userInterface: 'js/VIEW/ui/userInterface' + lastType,
            templet: 'js/MODEL/data/templet' + lastType,
            draw: 'js/VIEW/util/draw' + lastType,
            memo: 'js/VIEW/util/memo' + lastType,
            link: "js/VIEW/util/link" + lastType,
            responsiveUI: 'js/VIEW/ui/responsiveUI' + lastType,
            search: 'js/VIEW/util/search' + lastType,
            loading: 'js/VIEW/page/loading' + lastType,
            zoom: 'js/VIEW/util/zoom' + lastType,
            indexList: 'js/VIEW/util/indexList' + lastType,
            bookmark: 'js/VIEW/util/bookmark' + lastType,
            thumbnail: 'js/VIEW/util/thumbnail' + lastType,
            print: 'js/VIEW/util/print' + lastType,
            epubImage: 'js/MODEL/data/epubImage' + lastType,
            pageImage: 'js/VIEW/page/pageImage' + lastType
        }
    });

	 print_type = {
       load_value: ['jquery', 'log'],
        load_func: function($, log, version, browser, params, selectViewer) {
            log("@ start print.js");
			console.log( CONTROL) ;
        }
    };

	require(print_type.load_value, print_type.load_func);
