
define(['jquery', 'log'], function ($, log) {
	'use strict';

log("\n @ import loading.js ... \n");

	ViewerManager.isloadingComplete = false;
	ViewerManager.isMiniLoadingComplete = false;

	var initLoading = function (type) {
		return;
		var iconClassName, left;
		switch (type) {
			case "NORMAL":
				iconClassName = "loading_icon";
				left = "50%";
				break;
			case "MINI":
				iconClassName = "loading_icon_mini";
				left = "180px";
				break;
		}

		$(".loading").addClass(iconClassName);
		//$('#pages').append("<div class='" + iconClassName + "'></div>");
		$(".loading " + iconClassName).css("left", left).css("left", "-=40px");
		$(".loading " + iconClassName).css("top", "50%").css("top", "-=40px");
		var rotateLoadingIcon = function (radius) {
			$("." + iconClassName).animate({borderSpacing: radius}, {
				step: function (now, fx) {
					switch (type) {
						case "NORMAL":
							if (!ViewerManager.isloadingComplete) {
								$(this).css('-webkit-transform','rotate(' + now + 'deg)');
								$(this).css('-moz-transform','rotate(' + now + 'deg)');
								$(this).css('transform','rotate(' + now + 'deg)');
							} else {
								$("." + iconClassName).stop().fadeOut("slow");
								ViewerManager.isloadingComplete = false;
							}
							break;
						case "MINI":
							if (!ViewerManager.isMiniLoadingComplete) {
								$(this).css('-webkit-transform','rotate(' + now + 'deg)');
								$(this).css('-moz-transform','rotate(' + now + 'deg)');
								$(this).css('transform','rotate(' + now + 'deg)');
							} else {
								$("." + iconClassName).stop().fadeOut("slow");
								ViewerManager.isMiniLoadingComplete = false;
							}
							break;
					}
				}, duration: 3000 },
			'linear');
		};
		var radius = 360;
		rotateLoadingIcon(radius);
		ViewerManager.rotateLoadingAnimation = setInterval(function () {
			if (radius === 360)
				radius = 0;
			else
				radius = 360;
			rotateLoadingIcon(radius);
		}, 3000);
	};


	var exportLoading = {
		initLoading : initLoading
	};
	return exportLoading;
});
