﻿define(['jquery', 'draw', 'log', 'browser', 'params', 'templet'], function ($, draw, log, browser, params, templet) {
	//'use strict';

	log("\n @ import responsiveUI.js ... \n");

	if (params.Params.paramIns == 'none')
	{
		params.paramsInit();
	}

	if (browser.ie8)
	{
		return;
	}

	var pageLoadingCheck = false,
		singlePageWidth = 768;
	var hide_menu_item = [];
	ViewerManager.adjustDoublePage = function (PAGE_CURRENT_NUMBER) {
		var adjustLeftPosition;
		switch (ViewerManager.pageMODE) {
			case "SINGLE":
			 	if (!ViewerManager.isOddCheck(PAGE_CURRENT_NUMBER) || parseInt(PAGE_CURRENT_NUMBER) === 1) {
					adjustLeftPosition = ViewerManager.iframeContentsWidth;
				} else {
					adjustLeftPosition = 0;
				}
				break;
			case "DOUBLE":
				adjustLeftPosition = 0;
				break;
		}
		return adjustLeftPosition;
	};

	function addCell(target, type, index) {
		if (browser.ie9 || browser.ie10) {
			if (type == 'draw' || type == 'memo') {
				return ;
			}
		}
		var _index = 0;
		_index = index == undefined ? -1 : index;
		var addtarget = target.insertCell(index);
		addtarget.className="td-"+index;
		switch (type) {
			case ('top_left') : {
				$(addtarget).css({'width' : '5px'});
				break;
			}
			case ('list_blank') : {
				$(addtarget).css({'width' : '100%'});
				break;
			}

			case ('indexList') : {
				$(addtarget).css({'width' : '52px', 'text-align' : 'center'});
				addtarget.innerHTML = templet.indexList;
				break;
			}
			case ('searchList') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.searchList;
				break;
			}
			case ('zoomIn') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.zoomIn;
				break;
			}
			case ('zoomOut') : {
				$(addtarget).css({'width' : '0px'});
				addtarget.innerHTML = templet.zoomOut;
				break;
			}
			case ('btn_draw') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_draw;
				document.getElementById("draw_detail").innerHTML = templet.drawDetailMenu;
				break;
			}
			case ('btn_memo') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_memo;
				break;
			}
			case ('btn_link') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_link;
				break;
			}
			case ('btn_fullScreen') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_fullScreen;
				break;
			}
			case ('btn_pageMode') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_pageMode;
				break;
			}

			case ('btn_sns_share') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_sns_share;
				break;
			}
			case ('btn_print') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_print;
				break;
			}
			case ('btn_more') : {
				$(addtarget).css({'width' : '0px'});
				addtarget.innerHTML = templet.btn_more;
				break;
			}
			case ('header_title') : {
				$(addtarget).css({'vertical-align' : 'middle'});
				addtarget.innerHTML = templet.header_title;
				break;
			}

			case ('header_img') : {
				$(addtarget).css({'vertical-align' : 'middle','text-align':'left'});
				addtarget.innerHTML = templet.header_img;
				break;
			}

			case ('btn_teacher_dataroom') : {
				$(addtarget).css({'width' : '143px'});
				addtarget.innerHTML = templet.btn_teacher_dataroom;
				break;
			}

			case ('btn_duclass') : {
				$(addtarget).css({'width' : '93px'});
				addtarget.innerHTML = templet.btn_duclass;
				break;
			}

			case ('btn_login') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_login;
				break;
			}
			case ('btn_filedownload') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_filedownload;
				break;
			}
			case ('btn_winclose') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_winclose;
				break;
			}
			case ('top_right') : {
				$(addtarget).css({'width' : '10px'});
				break;
			}

			case ('btn_history') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_history;
				break;
			}

			case ('call_Thumbnail') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.call_Thumbnail;
				break;
			}


			case ('info_paging') : {
//				$(addtarget).css({'width' : '100%'});
				addtarget.innerHTML = templet.info_paging;
				break;
			}


			case ('isFirst') : {
				$(addtarget).css({'width' : '42px'});
				addtarget.innerHTML = templet.isFirst;
				break;
			}

			case ('isLast') : {
				$(addtarget).css({'width' : '42px'});
				addtarget.innerHTML = templet.isLast;
				break;
			}

			case ('isBtmLeft') : {
				$(addtarget).css({'width' : '40px'});
				addtarget.innerHTML = templet.isBtmLeft;
				break;
			}

			case ('isBtmRight') : {
				$(addtarget).css({'width' : '40px'});
				addtarget.innerHTML = templet.isBtmRight;
				break;
			}

			case ('btn_info') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_info;
				break;
			}

			case ('btn_help') : {
				$(addtarget).css({'width' : '52px'});
				addtarget.innerHTML = templet.btn_help;
				break;
			}



			case ('setApp') : {
				$(addtarget).css({'width' : '52px'});
				if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
					addtarget.innerHTML = templet.setAppIOS;
				}
				else if (browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
					addtarget.innerHTML = templet.setAppAndroid;
				}
				break;
			}
			// 커스텀
			case ('mainage_logo') : {
				$(addtarget).css({'width' : '145px', 'padding-left' : '20px'});
				addtarget.innerHTML = '<img class="setLogo" src="images/logo/logo.png" alt="메인에이지" title="메인에이지">';
				break;
			}
		}
		return index;
	}
	/** top_left, indexList, searchList, zoomIn, zoomOut, btn_draw, btn_memo
	btn_link, btn_fullScreen, btn_pageMode, btn_print, btn_more, header_title,
	btn_login, top_right, setApp, mainage_logo
	**/
	/**
	addCell(topMenuTableTr, 'indexList'); // 인덱스 리스트
	addCell(topMenuTableTr, 'searchList'); // 검색
	addCell(topMenuTableTr, 'zoomIn'); // 줌인
	addCell(topMenuTableTr, 'zoomOut'); // 줌아웃(줌인과 겹침)
	addCell(topMenuTableTr, 'btn_draw'); // 판서
	addCell(topMenuTableTr, 'btn_fullScreen'); // 전체화면
	addCell(topMenuTableTr, 'btn_pageMode'); // 페이지모드
	addCell(topMenuTableTr, 'header_title'); // 타이틀
	addCell(topMenuTableTr, 'btn_memo'); // 메모
	addCell(topMenuTableTr, 'btn_link'); // 링크
	addCell(topMenuTableTr, 'btn_print'); // 프린트
	addCell(topMenuTableTr, 'btn_more'); // 더 보기
	addCell(topMenuTableTr, 'setApp'); // 앱설치 버튼
	addCell(topMenuTableTr, 'mainage_logo'); // 메인에이지 로고
	addCell(topMenuTableTr, 'btn_filedownload'); // 파일 다운로드
	addCell(topMenuTableTr, 'btn_winclose'); // 윈도우 닫기 버튼
	**/

	//setResponsiveMobileUI
	var setResponsiveMobileUI = function () {
		var menuType = ViewerManager.CustomizeType.split('MENU');
		if ((browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) && ViewerManager.CustomizeType!="9MENU5") {
			log("@ Mobile Device!");

			$('#topMenuTableTr').css('display', 'table-row');
			$('#header_toggle').css('display', 'block').css('left', '50%').css('left', '-=27px');

			ViewerManager.eventSelector = {
				downEvent : "touchstart",
				moveEvent : "touchmove",
				upEvent : "touchend"
			}

			var topMenuTableTr = document.getElementById("topMenuTableTr");
			addCell(topMenuTableTr, 'top_left', 0); // 왼쪽 공간
			addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
			addCell(topMenuTableTr, 'header_title', 2); // 타이틀

			var bottomMenuTableTr = document.getElementById("bottomMenuTableTr");
			setMobileOrientation("init");

			switch (ViewerManager.CustomizeType)
			{
				case "MAINAGE":
				{
					addCell(topMenuTableTr, 'mainage_logo', 0); // 메인에이지 로고

					$('#bookmark_container').css('display', 'none');
					$('#header table').css('margin-top', '6px');

					break;
				}
				case "SSG":
				{
					addCell(topMenuTableTr, 'zoomIn', 2); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 3); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_draw', 4); // 판서
					addCell(topMenuTableTr, 'btn_memo', 5); // 메모
					addCell(topMenuTableTr, 'btn_winclose', -1); // 윈도우 닫기 버튼
					break;
				}
				case "7MENU2":
				case "8MENU2":
				{
					addCell(topMenuTableTr, 'btn_draw', 2); // 판서
					break;
				}
				case "7MENU3":
				case "8MENU3":
				{
					addCell(topMenuTableTr, 'btn_draw', 2); // 판서
					addCell(topMenuTableTr, 'setApp', -1); // 앱설치 버튼
					break;
				}
				case "8MENU4":
				case "9MENU4":
				{
					addCell(topMenuTableTr, 'zoomIn', 2); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 3); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_draw', 4); // 판서
					addCell(topMenuTableTr, 'btn_memo', 5); // 판서
					if (String(ViewerManager.fileDownloadURL).length > 0) {
						addCell(topMenuTableTr, 'btn_filedownload', -1); // 파일 다운로드
					}
					/*if (String(location.href).match('titanbooks.co.kr')) {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}*/
					if (ViewerManager.GetData.USE.login == "1") {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}
					addCell(bottomMenuTableTr, 'setApp', 0); // 앱설치 버튼
					break;
				}
				case "8MENU6":
				{
					addCell(topMenuTableTr, 'zoomIn', 2); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 3); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_draw', 4); // 판서
					addCell(topMenuTableTr, 'btn_memo', 5); // 메모
					addCell(topMenuTableTr, 'setApp', -1); // 앱설치 버튼
					break;
				}
				case "9MENU5":
				{
					addCell(topMenuTableTr, 'searchList', 2); // 검색
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_draw', 5); // 판서
					addCell(topMenuTableTr, 'btn_memo', 6); // 메모
					addCell(topMenuTableTr, 'btn_link', 7); // 링크
					if (String(ViewerManager.fileDownloadURL).length > 0) {
						addCell(topMenuTableTr, 'btn_filedownload', -1); // 파일 다운로드
					}
					/*if (String(location.href).match('titanbooks.co.kr')) {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}*/
					if (ViewerManager.GetData.USE.login == "1") {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}
					addCell(bottomMenuTableTr, 'setApp', 0); // 앱설치 버튼
					break;
				}

				case "DEFAULT":
				{
					topMenuTableTr.deleteCell(2);
					addCell(topMenuTableTr, 'searchList', 2);
					addCell(topMenuTableTr, 'header_title', 3); // 타이틀
					addCell(topMenuTableTr, 'btn_sns_share' ,4); // sns_공유
					//addCell(topMenuTableTr, 'header_title', 8); // 타이틀
					/*if (String(location.href).match('titanbooks.co.kr')) {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}*/
					if (ViewerManager.GetData.USE.login == "1") {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}
					//addCell(bottomMenuTableTr, 'setApp', 0); // 앱설치 버튼
					break;
				}
			}

			addCell(topMenuTableTr, 'top_right', -1); // 오른쪽 공간
		} else {
			log("Desktop Computer!");

			$('#topMenuTableTr').css('display', 'table-row');
			$('#header_toggle').css('display', 'block').css('left', '50%').css('left', '-=27px');

			ViewerManager.eventSelector = {
				downEvent : "mousedown",
				moveEvent : "mousemove",
				upEvent : "mouseup"
			}
    if(browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
       ViewerManager.eventSelector = {
                  downEvent : "touchstart",
                  moveEvent : "touchmove",
                  upEvent : "touchend"
      }
 }
			var topMenuTableTr = document.getElementById("topMenuTableTr");
			addCell(topMenuTableTr, 'top_left', 0); // 왼쪽 공간

			var bottomMenuTableTr = document.getElementById("bottomMenuTableTr");
/*
					addCell(bottomMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(bottomMenuTableTr, 'searchList', 2); // 검색
					addCell(bottomMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(bottomMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
*/
			switch (ViewerManager.CustomizeType)
			{
				case "NASARET":
				{
					// 판서, 페이지 모드 삭제
					addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(topMenuTableTr, 'searchList', 2); // 검색
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_fullScreen', 5); // 전체화면
					addCell(topMenuTableTr, 'header_title', 6); // 타이틀

					$('#header_toggle').css('display','none');

					setMouseMenu();

					ViewerManager.pageMODE = 'SINGLE';

					break;
				}
				case "MAINAGE":
				{
					// 인덱스, 검색, 판서 삭제
					addCell(topMenuTableTr, 'zoomIn', 1); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 2); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_fullScreen', 3); // 전체화면
					addCell(topMenuTableTr, 'btn_pageMode', 4); // 페이지모드
					addCell(topMenuTableTr, 'header_title', 5); // 타이틀

					addCell(topMenuTableTr, 'mainage_logo', 0);

					$('#header_toggle').css('display','none');
					$('#bookmark_container').css('display', 'none');

					setMouseMenu();

					break;
				}
				case "DAEGUNAVI":
				{
					// 인덱스, 검색 삭제
					addCell(topMenuTableTr, 'zoomIn', 1); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 2); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_draw', 3); // 판서
					addCell(topMenuTableTr, 'btn_fullScreen', 4); // 전체화면
					addCell(topMenuTableTr, 'btn_pageMode', 5); // 페이지모드
					addCell(topMenuTableTr, 'header_title', 6); // 타이틀

					$('#bookmark_container').css('display', 'none');

					break;
				}
				case "SSG":
				{
					addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(topMenuTableTr, 'searchList', 2); // 검색
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					if (browser.ie8 || browser.ie9 || browser.ie10) {
						addCell(topMenuTableTr, 'btn_fullScreen', 5); // 전체화면
						addCell(topMenuTableTr, 'btn_pageMode', 6); // 페이지모드
						addCell(topMenuTableTr, 'header_title', 7); // 타이틀
					}
					else
					{
						addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						addCell(topMenuTableTr, 'btn_memo', 6); // 메모
						addCell(topMenuTableTr, 'btn_fullScreen', 7); // 전체화면
						addCell(topMenuTableTr, 'btn_pageMode', 8); // 페이지모드
						addCell(topMenuTableTr, 'header_title', 9); // 타이틀
					}

					break;
				}
				case "7MENU1":
				case "7MENU2":
				case "7MENU3":
				{
					addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(topMenuTableTr, 'searchList', 2); // 검색
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					if (browser.ie8 || browser.ie9 || browser.ie10) {
						//addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						addCell(topMenuTableTr, 'btn_fullScreen', 5); // 전체화면
						addCell(topMenuTableTr, 'btn_pageMode', 6); // 페이지모드
						addCell(topMenuTableTr, 'header_title', 7); // 타이틀
					}
					else
					{
						addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						addCell(topMenuTableTr, 'btn_fullScreen', 6); // 전체화면
						addCell(topMenuTableTr, 'btn_pageMode', 7); // 페이지모드
						addCell(topMenuTableTr, 'header_title', 8); // 타이틀
					}
					/*addCell(topMenuTableTr, 'btn_draw', 5); // 판서
					addCell(topMenuTableTr, 'btn_fullScreen', 6); // 전체화면
					addCell(topMenuTableTr, 'btn_pageMode', 7); // 페이지모드
					addCell(topMenuTableTr, 'header_title', 8); // 타이틀*/

					break;
				}
				case "8MENU2":
				case "8MENU3":
				case "8MENU4":
				case "8MENU6":
				{
					addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(topMenuTableTr, 'searchList', 2); // 검색
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					if (browser.ie8 || browser.ie9 || browser.ie10) {
						//addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						//addCell(topMenuTableTr, 'btn_memo', 6); // 메모
						addCell(topMenuTableTr, 'btn_fullScreen', 5); // 전체화면
						addCell(topMenuTableTr, 'btn_pageMode', 6); // 페이지모드
						addCell(topMenuTableTr, 'header_title', 7); // 타이틀
					}
					else
					{
						addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						addCell(topMenuTableTr, 'btn_memo', 6); // 메모

						/*if (ViewerManager.imageUse == 'true') {
							addCell(topMenuTableTr, 'btn_print', 7); // 프린트
							addCell(topMenuTableTr, 'btn_fullScreen', 8); // 전체화면
							addCell(topMenuTableTr, 'btn_pageMode', 9); // 페이지모드
							addCell(topMenuTableTr, 'header_title', 10); // 타이틀
						}
						else {*/
							addCell(topMenuTableTr, 'btn_fullScreen', 7); // 전체화면
							addCell(topMenuTableTr, 'btn_pageMode', 8); // 페이지모드
							addCell(topMenuTableTr, 'header_title', 9); // 타이틀
						//}
					}

					break;
				}
				case "9MENU4":
				case "9MENU5":
				{


					//addCell(topMenuTableTr, 'header_img', 1); // 타이틀 이미지
					addCell(topMenuTableTr, 'header_title', 1); // 타이틀


					//addCell(topMenuTableTr, 'btn_teacher_dataroom', 3); // 선생님 자료실 (새창)
					//addCell(topMenuTableTr, 'btn_duclass', 4); // 두클래스 (새창)
					addCell(bottomMenuTableTr, 'top_left', 0); // 오른쪽 공간
					addCell(bottomMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(bottomMenuTableTr, 'searchList', 2); // 검색
					addCell(bottomMenuTableTr, 'btn_memo', 3); // 메모
					addCell(bottomMenuTableTr, 'btn_draw', 4); // 판서
					addCell(bottomMenuTableTr, 'btn_link', 5); // 링크
					addCell(bottomMenuTableTr, 'zoomIn', 6); // 줌인
					addCell(bottomMenuTableTr, 'zoomOut', 7); // 줌아웃(줌인과 겹침)
					addCell(bottomMenuTableTr, 'isFirst', 8); // 처음으로
					addCell(bottomMenuTableTr, 'isBtmLeft', 9); // 이전으로
					addCell(bottomMenuTableTr, 'info_paging', 10); // info_paging
					addCell(bottomMenuTableTr, 'isBtmRight', 11); // 다음으로
					addCell(bottomMenuTableTr, 'isLast', 12); // 마지막으로
					addCell(bottomMenuTableTr, 'btn_history', 13); // history
					addCell(bottomMenuTableTr, 'btn_pageMode', 14); // 페이지모드
					addCell(bottomMenuTableTr, 'call_Thumbnail', 15); // thumbnail
					addCell(bottomMenuTableTr, 'btn_fullScreen', 16); // 전체화면
					addCell(bottomMenuTableTr, 'btn_print', 17); // 프린트
					addCell(bottomMenuTableTr, 'btn_info', 18); // Info
					//addCell(bottomMenuTableTr, 'btn_help', 19); // Help

					addCell(bottomMenuTableTr, 'btn_more', -1); // 윈도우 닫기 버튼
					addCell(bottomMenuTableTr, 'btn_winclose', -1); // 윈도우 닫기 버튼

					$('#footer_container').append( templet.logoLayer );


					hide_menu_item['9MENU5'] = [];
					hide_menu_item['9MENU5']['css'] = {
						"position" : "fixed",
						"width" : "104px",
						"bottom" : "58px" ,
						"right" : "59px",
						"left" : "auto",
						"top" : "auto",
					};
					hide_menu_item['9MENU5']['full'] = 1100;
					hide_menu_item['9MENU5']['full2'] = 950;
					hide_menu_item['9MENU5']['mobile'] = 480;
					hide_menu_item['9MENU5']['width'] = 52;
					hide_menu_item['9MENU5']['index'] = [[19,18],17,16,15,14,13,[7,6],5,4,3,2,1];
					hide_menu_item['9MENU5']['item'] = [
						[".btn_help",".btn_info"],
						"#btn_print",
						"#btn_fullScreen",
						"#callThumbnail",
						"#btn_pageMode",
						"#history",
						[".zoomIn",".zoomOut"],
						"#btn_link",
						"#btn_draw",
						"#btn_memo",
						".searchList",
						".indexList"
					];

					$("#morePopupTemplet").html("");

					if (browser.ie8 || browser.ie9 || browser.ie10) {
						//addCell(topMenuTableTr, 'btn_draw', 5); // 판서
						//addCell(topMenuTableTr, 'btn_memo', 6); // 메모
						//addCell(topMenuTableTr, 'btn_link', 7); // 링크
//						addCell(topMenuTableTr, 'btn_fullScreen', 5); // 전체화면
//						addCell(topMenuTableTr, 'btn_pageMode', 6); // 페이지모드
						//addCell(topMenuTableTr, 'btn_print', 7); // 페이지모드
//						addCell(topMenuTableTr, 'header_title', 7); // 타이틀
					}
					else
					{

						//addCell(topMenuTableTr, 'btn_link', 7); // 링크
//						addCell(topMenuTableTr, 'btn_fullScreen', 7); // 전체화면
//						addCell(topMenuTableTr, 'btn_pageMode', 8); // 페이지모드
//						addCell(topMenuTableTr, 'header_title', 9); // 타이틀
//						addCell(topMenuTableTr, 'btn_print', 10); //인쇄
					}

					break;
				}

				case "DEFAULT":
				{
					addCell(topMenuTableTr, 'indexList', 1); // 인덱스 리스트
					addCell(topMenuTableTr, 'searchList', 2); // 줌인
					addCell(topMenuTableTr, 'zoomIn', 3); // 줌인
					addCell(topMenuTableTr, 'zoomOut', 4); // 줌아웃(줌인과 겹침)
					addCell(topMenuTableTr, 'btn_fullScreen',5); // 전체화면
					addCell(topMenuTableTr, 'btn_pageMode',6); // 페이지모드
					addCell(topMenuTableTr,  'btn_sns_share',7); // sns_공유
					addCell(topMenuTableTr, 'header_title', 8); // 타이틀
					/*if (String(location.href).match('titanbooks.co.kr')) {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}*/
					if (ViewerManager.GetData.USE.login == "1") {
						addCell(topMenuTableTr, 'btn_login', -1); // 로그인
					}
					//addCell(bottomMenuTableTr, 'setApp', 0); // 앱설치 버튼
					break;
				}
			}

			if (String(ViewerManager.fileDownloadURL).length > 0) {
				addCell(topMenuTableTr, 'btn_filedownload', -1); // 파일 다운로드
			}
			/*if (String(location.href).match('titanbooks.co.kr')) {
				addCell(topMenuTableTr, 'btn_login', -1); // 로그인
			}*/
			if (ViewerManager.GetData.USE.login == "1") {
				addCell(topMenuTableTr, 'btn_login', -1); // 로그인
			}
//			addCell(topMenuTableTr, 'btn_winclose', -1); // 윈도우 닫기 버튼
			addCell(topMenuTableTr, 'top_right', -1); // 오른쪽 공간
		}
	},

	excuteResizePageFrame = function (selector, zoomRate) {
		log('[Function excuteResizePageFrame]  page name  : ' + selector)
		switch (selector) {
			case "#adpage_iframe":
			if (document.domain == "http://titanbooks.co.kr")
			{
				document.domain = "http://titanbooks.co.kr";
				//console.log(document.domain);// = '127.0.0.1';
				//console.log(selector, $(selector), $(selector).contents());
			}
			break;
			case "#components":
				var setScale = 0.8;
				$(selector).css({
					"-ms-transform": "scale(" + (zoomRate < setScale ? setScale : zoomRate) + "," + (zoomRate < setScale ? setScale : zoomRate) + ")",
					"-webkit-transform": "scale(" + (zoomRate < setScale ? setScale : zoomRate) + "," + (zoomRate < setScale ? setScale : zoomRate) + ")",
					"transform": "scale(" + (zoomRate < setScale ? setScale : zoomRate) + "," + (zoomRate < setScale ? setScale : zoomRate) + ")",
					"transform-origin": "0% 0%",
					"-webkit-transform-origin": "0% 0%",
					"-ms-transform-origin": "0% 0%"
				});
				break;
		}
		ViewerManager.zoomRate = zoomRate;

	},

	orientation1, orientation2,
	setResponsiveScale = function (frameName, pageFrameElement) {
		log('@ first iframeContentsWidth : ' + ViewerManager.iframeContentsWidth);
		log('@ first iframeContentsHeight : ' + ViewerManager.iframeContentsHeight);

		var pageWidth;
		var pageHeight;
		var contentTagStr;
		if ($(pageFrameElement).find('meta').length > 0) {
			contentTagStr =$(pageFrameElement).find('meta')[1].getAttribute('content');
		}

		if (contentTagStr) {
			pageWidth = parseInt(contentTagStr.split(',')[0].split('=')[1]) != 0 ?  parseInt(contentTagStr.split(',')[0].split('=')[1])  : ViewerManage.iframeContentsWidth;
			pageHeight =  parseInt(contentTagStr.split(',')[1].split('=')[1]) != 0 ?  parseInt(contentTagStr.split(',')[1].split('=')[1]) :  ViewerManage.iframeContentsHeight;
		}else {
			pageWidth = ViewerManager.iframeContentsWidth;
			pageHeight =  ViewerManager.iframeContentsHeight;
		}

		var replaceMeta = 'width=device-width, height=device-height,,user-scalable=no';
		if ($(pageFrameElement).find('meta').length > 0) {
			$(pageFrameElement).find('meta')[1].setAttribute('content',replaceMeta);
		}
		switch (ViewerManager.pageMODE) {
			case "SINGLE":
				var w_rate = window.innerWidth / (pageWidth);//window.innerWidth / window.innerHeight;
				var h_rate = window.innerHeight / pageHeight;//(pageWidth * 2) / pageHeight;
				var zr;

				if ((window.innerWidth / window.innerHeight) < (4 / 3)) {
					zr = w_rate;
					if ((window.innerHeight - ((pageHeight) * zr)) / 2 < 0) {
						zr = h_rate;
					}
					/*
					if ((window.innerHeight - ((pageHeight) * zr))  > 0) {
						zr = h_rate;
					}
					*/
				}
				else {
					zr = h_rate;
				}

				if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
					if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone) {
						orientation1 = 0;
						orientation2 = 180;
					}
					if (!browser.isMobile.androidPhone && browser.isMobile.androidTablet) {
						orientation1 = 90;
						orientation2 = -90;

					}
					/* portrait mode */
					if (window.orientation === orientation1 || window.orientation === orientation2)
					{
						var select_rate;
						if (ViewerManager.iframeContentsWidth * ViewerManager.bookContainerHeight > ViewerManager.iframeContentsHeight * ViewerManager.bookContainerWidth) {
							select_rate = ViewerManager._zoom_horizontal;
						} else {
							select_rate = ViewerManager._zoom_vertical;
						}
						excuteResizePageFrame(frameName, zr);
						excuteResizePageFrame('#adpage_iframe', zr);
						//pageFrameElement.setAttribute("style", "margin-left:"+ parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager._zoom_horizontal) / 2) + "px; " + "margin-top:" + parseInt((ViewerManager.bookContainerHeight - (ViewerManager.bookContainerHeight / ViewerManager._zoom_vertical) * ViewerManager._zoom_horizontal) / 2) + "px; visibility: hidden; overflow: hidden;");

						if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet)
						{
							//var n_left = ($(window).innerWidth() - $(frameName).contents().find('body').width() * zr) / 2;
							//var n_top = ($(window).innerHeight() - $(frameName).contents().find('body').height() * zr) / 2;
							//pageFrameElement.setAttribute("style", "margin-left:"+ parseInt(n_left) + "px; " + "margin-top:" + parseInt(n_top) + "px; visibility: hidden; overflow: hidden;");
						}
						//document.querySelector("#content").setAttribute("style", "overflow: scroll");
					}
					/* landscape mode */
					else {
						var select_rate;
						if (ViewerManager.iframeContentsWidth * ViewerManager.bookContainerHeight > ViewerManager.iframeContentsHeight * ViewerManager.bookContainerWidth) {
							select_rate = ViewerManager._zoom_horizontal;
						} else {
							select_rate = ViewerManager._zoom_vertical;
						}
						excuteResizePageFrame(frameName, zr);
						excuteResizePageFrame('#adpage_iframe', zr);

						//pageFrameElement.setAttribute("style", "margin-left:"+ parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) + "px; " + "margin-top: 0px; visibility: hidden; overflow: scroll;");

						if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet)
						{
							//var n_left = ($(window).innerWidth() - $(frameName).contents().find('body').width() * zr) / 2;
							//var n_top = ($(window).innerHeight() - $(frameName).contents().find('body').height() * zr) / 2;
							//pageFrameElement.setAttribute("style", "margin-left:"+ parseInt(n_left) + "px; " + "margin-top:" + parseInt(n_top) + "px; visibility: hidden; overflow: hidden;");
						}
						//document.querySelector("#content").setAttribute("style", "overflow: scroll");
					}

				} else {
					if (ViewerManager.iframeContentsWidth * ViewerManager.zoomRate > ViewerManager.bookContainerWidth) {
						excuteResizePageFrame(frameName, zr);
						excuteResizePageFrame('#adpage_iframe', zr);
						// excuteResizePageFrame("#components", ViewerManager._zoom_horizontal);
					} else {
						excuteResizePageFrame(frameName, zr);
						excuteResizePageFrame('#adpage_iframe', zr);
						// excuteResizePageFrame("#components", ViewerManager._zoom_vertical);
					}
					//pageFrameElement.setAttribute("style", "margin-left:"+ parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) + "px; " + "margin-top:" + parseInt((ViewerManager.bookContainerHeight - (ViewerManager.bookContainerHeight / ViewerManager._zoom_vertical) * ViewerManager.zoomRate) / 2) + "px; visibility: hidden; overflow: hidden;");
				}

				/*
				컨텐트의 크기는 회면에 꽉 정확치 차지 않을 수 있으며, 따라서 이 컨텐트를 화면의 중앙에
				배치하기 위해서 그 차이를 2로 나눈 값을 margin 값으로 설정
				*/
				$("#pages").css({
					"margin-top" : parseInt((window.innerHeight - ((pageHeight) * ViewerManager.zoomRate)) / 2 ) + "px",
					"margin-left" : parseInt((window.innerWidth - ((pageWidth) * ViewerManager.zoomRate)) / 2) + "px"
				});
				$('#gras .graLeft').css('display', 'none');
				$('#gras .graRight').css('display', 'none');
				break;

			case "DOUBLE" :

				var w_rate = window.innerWidth / (pageWidth * 2);//window.innerWidth / window.innerHeight;
				var h_rate = window.innerHeight / pageHeight;//(pageWidth * 2) / pageHeight;
				var zr;

				if ((window.innerWidth / window.innerHeight) >= (4 / 3)) {
					zr = h_rate;

					if ((window.innerWidth - ((pageWidth * 2) * zr)) / 2 < 0) {
						zr = w_rate;
					}

					if(ViewerManager.pixeWidth) {
						zr = w_rate;
						//$('#content').css('overflow-y', 'auto');
					}
				}
				else {

					zr = w_rate;
				}

				excuteResizePageFrame(frameName, zr);
				excuteResizePageFrame('#adpage_iframe', zr);

				if ($('#rightPageFrame').length > 0) {
					$('#rightPageFrame').css({
						'margin-left' : pageWidth + 'px'
					});
				}

				/*
				$('#rightPageFrame').css({
					'left' : pageWidth + 'px'
				});
				*/
				var pg_mtop = (window.innerHeight - ((pageHeight) * ViewerManager.zoomRate)) / 2 ;
				if(pg_mtop < 0 )
					pg_mtop = 0;
				$("#pages").css({
					"margin-top" : pg_mtop+ "px",
					"margin-left" : (window.innerWidth - ((pageWidth * 2) * ViewerManager.zoomRate)) / 2 + "px"
				});
	/*
				pageFrameElement.setAttribute("style", "margin-top:" + parseInt((ViewerManager.bookContainerHeight - (ViewerManager.bookContainerHeight / ViewerManager._zoom_vertical) * ViewerManager.zoomRate) / 2) + "px; visibility: hidden; overflow: hidden;");

				if (frameName === "#leftPageFrame") {
					$(frameName).css("margin-left", (parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) - 5 ) + "px");
				}
	*/
				if (ViewerManager.PAGE_CURRENT_NUMBER == 1) {
					$('#gras .graLeft').css({'display' : 'none'});
					$('#gras .graRight').css({'display' : 'block'});
				}
				else
				{
					$('#gras .graLeft').css({'display' : 'block'});
					$('#gras .graRight').css({'display' : 'block'});
					if (ViewerManager.PAGE_CURRENT_NUMBER >= ViewerManager.PAGE_TOTAL_NUMBER && ViewerManager.PAGE_TOTAL_NUMBER%2 == 0) {
						$('#gras .graRight').css({'display' : 'none'});
					}
				}

				break;
		}


		$(pageFrameElement).width(pageWidth);
		$(pageFrameElement).height(pageHeight);
		//pageFrameElement.setAttribute("width", pageWidth + 'px');
		//pageFrameElement.setAttribute("height", pageHeight + 'px');
		if ($('#bookmark_container').css('display') == 'none') {
			$('#bookmark_container').css('display', 'block');
		}

		if ($('#rightPageFrame').length > 0) $('#leftPageFrame').css("visibility", "visible");
		if ($('#rightPageFrame').length > 0)  $('#rightPageFrame').css("visibility", "visible");

		$('#pages').css({
			'transform' : 'scale(' + zr + ')',
			'-o-transform' : 'scale(' + zr + ')',
			'-webkit-transform' : 'scale(' + zr + ')',
			'-moz-transform' : 'scale(' + zr + ')',
			'-ms-transform' : 'scale(' + zr + ')'
		});

		if ($('#adpage_iframe'))
		{
			var adpage = $('#adpage_iframe_iframe');
			adpage.css({
				'width' : (ViewerManager.iframeContentsWidth * ViewerManager.zoomRate) + 'px',
				'height' : (ViewerManager.iframeContentsHeight * ViewerManager.zoomRate) + 'px',
				'margin-top' : '0',
				'margin-left' : '0'
			});
		}

		var margin_top = parseInt((ViewerManager.bookContainerHeight - (ViewerManager.bookContainerHeight / ViewerManager.zoomRate) * ViewerManager.zoomRate) / 2);
		var margin_left = (parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager.zoomRate) * ViewerManager.zoomRate) / 2));

		$('#gras .graLeft img').css({'width' : ViewerManager.Settings.graWidth + 'px'});
		$('#gras .graRight img').css({'width' : ViewerManager.Settings.graWidth + 'px'});

		$('#gras .graLeft').css({
			'height' : $('#leftPageFrame').height() + 'px',
			'left' : ($('#leftPageFrame').width() + margin_left - ViewerManager.Settings.graWidth)+ 'px'
		});

		$('#gras .graRight').css({
			'height' : $('#rightPageFrame').height() + 'px',
			'left' : ($('#leftPageFrame').width() + margin_left) + 'px'
		});
		var comPage = ViewerManager.pageMODE == 'SINGLE' ? 1 : 2;
		$('#components').css({
			"left" : (window.innerWidth - ((pageWidth * comPage) * ViewerManager.zoomRate)) / 2 + "px",
			"top" : (window.innerHeight - ((pageHeight) * ViewerManager.zoomRate)) / 2 + "px"
		});
	},

	setMobileOrientation = function (setType) {
		var topMenuTableTr = document.getElementById("topMenuTableTr");
		if (window.orientation == 0 || window.orientation == 90 || window.orientation == 180 || window.orientation == -90)
		{
			if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone) {
				orientation1 = 0;
				orientation2 = 180;
			}
			if (!browser.isMobile.androidPhone && browser.isMobile.androidTablet) {
				orientation1 = 90;
				orientation2 = -90;
			}

			if (window.orientation == orientation1 || window.orientation == orientation2) {
				log("@ portrait mode ...");
				ViewerManager.pageMODE = "SINGLE";
				$('#btn_pageMode').parents('td').css('display', 'none');
				$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_01.png");
				// 이부분은 모바일에 동작시 초기화 하면서 동작함. 이 시점에서는 아래 변수들이 세팅 되어 있지 않음 . 초기화 시점에서 ViewerManager.PAGE_CURRENT_NUMBER 는 Nan 이나 undefied 일 것임
				ViewerManager.PAGE_CURRENT_NUMBER =  parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
				ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;

			} else {
				log("@ landsacpe mode ...");
				ViewerManager.pageMODE = "DOUBLE";

				$('#btn_pageMode').parents('td').css('display', 'block');

				if(ViewerManager.pixeWidth)
					$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png");
				else
					$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");

				if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER);
				else ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;
					// 이부분은 모바일에 동작시 초기화 하면서 동작함. 이 시점에서는 아래 변수들 세팅이 되어 있지 않음 . 초기화 시점에서 ViewerManager.PAGE_CURRENT_NUMBER 는 Nan 이나 undefied 일 것임
				if (ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER)) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
				ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
			}

			if (setType === "resize") {
				ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
			}
		}

		if (window.screen.orientation)
		{
			var orientation = window.screen.orientation.type.split('-')[0];
			if (orientation == 'portrait')
			{
				log("@ portrait mode ...");
				ViewerManager.pageMODE = "SINGLE";

				$('#btn_pageMode').parents('td').css('display', 'none');
				$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_01.png");
				// 이부분은 모바일에 동작시 초기화 하면서 동작함. 이 시점에서는 아래 변수들이 세팅 되어 있지 않음 . 초기화 시점에서 ViewerManager.PAGE_CURRENT_NUMBER 는 Nan 이나 undefied 일 것임
				ViewerManager.PAGE_CURRENT_NUMBER =  parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) ;
				ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
			}
			else if (orientation == 'landscape')
			{
				log("@ landsacpe mode ...");
				ViewerManager.pageMODE = "DOUBLE";

				$('#btn_pageMode').parents('td').css('display', 'block');
				if( ViewerManager.pixeWidth )
					$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png")
				else
					$('#btn_pageMode').attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");
				// 이부분은 모바일에 동작시 초기화 하면서 동작함. 이 시점에서는 아래 변수들이 세팅 되어 있지 않음 . 초기화 시점에서 ViewerManager.PAGE_CURRENT_NUMBER 는 Nan 이나 undefied 일 것임
				if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER);
				else ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;

				if (ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER)) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

				ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
			}

			if (setType === "resize")
			{
				if (!ViewerManager || !ViewerManager.pageLoading)
				{
					setTimeout(function(){
						setMobileOrientation('resize');
					}, 500);

					return;
				}

				ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
			}
		}
	};

	//상단 header 및 하단 footer (토클 메뉴 영역 ) 에 마우스  일정 밤위 안으로 혹은 밖으로 move 시  메뉴 슬라이드 업  슬라이드 down 처리
	var setMouseMenu = function()
	{
		if (browser.ie9 || browser.ie10 || (!browser.chrome && browser.safari))
		{
			topMenuTableTr.deleteCell(5);// 기본/전체 화면 삭제
		}

		var move_term = 60;

		$('#container').append("<div id='over_top' style='position:absolute; left:0; top;0; width:" + $('#header_container').width() + "px; height:" + ($('#header_container').height() + 30) + "px; background:#000; z-index:11; opacity:0;'></div>");

		$('#over_top').bind('mousemove', function(e){
			if (e.pageY < (move_term) && $('#header').css('display') == 'none')
			{
				$('#header').slideDown(ViewerManager.Settings.menuSpeed);
				ViewerManager.swipeStatus('off');
			}
			else if (e.pageY >= (move_term) && $('#header').css('display') == 'block')
			{
				$('#header').slideUp(ViewerManager.Settings.menuSpeed);
				ViewerManager.indexList_click('showmove');
				ViewerManager.swipeStatus('on');
			}
		});

		$('#container').append("<div id='over_bottom' style='position:absolute; left:0; bottom:0; width:" + $('#footer_container').width() + "px; height:" + ($('#footer_container').height() + 30) + "px; background:#000; z-index:11; opacity:0;'></div>");

		var w_height;
		var prev_bottom;

		$('#over_bottom').bind('mousemove', function(e){
			w_height = window.innerHeight;
			prev_bottom = w_height - e.pageY;

			if (prev_bottom <= (move_term) && $('#footer_container').css('display') == 'none')
			{
				$('#footer_container').slideDown(ViewerManager.Settings.menuSpeed);
				ViewerManager.swipeStatus('off');
			}
			else if (prev_bottom > (move_term) && $('#footer_container').css('display') == 'block')
			{
				$('#footer_container').slideUp(ViewerManager.Settings.menuSpeed);
				ViewerManager.swipeStatus('on');
			}
		});

		$(document).on('mouseleave', function(e){
			if ($('#header').css('display') == 'block')
			{
				$('#header').slideUp(ViewerManager.Settings.menuSpeed);
				ViewerManager.indexList_click('showmove');
				ViewerManager.swipeStatus('on');
			}
			if ($('#footer_container').css('display') == 'block')
			{
				$('#footer_container').slideUp(ViewerManager.Settings.menuSpeed);
				ViewerManager.swipeStatus('on');
			}
		});
	},

	_loadStart = function () {
		var title_text = String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength());
	    if (ViewerManager.Settings.useComment == 'true' && $("#header_title").width() > 100) {
	        title_text = (String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength()) + '<span id="comment_btn"></span>');
	    }
	    $("#header_title").html(title_text);
	    $("#header_title").attr({"alt":ViewerManager.Local.cntsTitle, "title":ViewerManager.Local.cntsTitle});
	},
	_setHeader = function(){
		var title_text = String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength());
	    if (ViewerManager.Settings.useComment == 'true' && $("#header_title").width() > 100) {
	        title_text = (String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength()) + '<span id="comment_btn"></span>');
	    }

	    $("#header_title").html(title_text);
	    $("#header_title").attr({"alt":ViewerManager.Local.cntsTitle, "title":ViewerManager.Local.cntsTitle});
	},
	_set_morelayout = function() {
		var tp = ViewerManager.CustomizeType;
		if(hide_menu_item[tp] instanceof Array)
		{
			$("#morePopupTemplet").html("").css(hide_menu_item['9MENU5']['css']);
			_menu_resize();
		}
	},
	_menu_resize = function() {
		var tp = ViewerManager.CustomizeType;
		$("body").css("overflow","hidden");
		$(".pop_slide_wrap").css("bottom", "-200");
		$("#morePopupTemplet").css(hide_menu_item['9MENU5']['css']);
		if(hide_menu_item[tp] instanceof Array)
		{

			var win_width = $(window).width();
			$("#bottomMenuTableTr").find("td").css("width", "auto");
			var full_width = hide_menu_item['9MENU5']['full'];
			if( hide_menu_item['9MENU5']['mobile'] > win_width )
			{
				full_width = hide_menu_item['9MENU5']['full2'];
				$("#logo-out").hide();
				$("#bottomMenuTableTable").css("margin-left" , "0px");
			}
			else
			{
				$("#logo-out").show();
				$("#bottomMenuTableTable").css("margin-left" , "150px");
			}

			if(win_width > full_width)
			{

				$('#btn_more').hide();
				if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][0][0]).length > 0)
					$(hide_menu_item[tp]['item'][0][0]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][0][0]);
				if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][0][1]).length > 0)
					$(hide_menu_item[tp]['item'][0][1]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][0][1]);

				for(m = 1; m < hide_menu_item[tp]['item'] .length; m++)
				{
					if( hide_menu_item[tp]['item'][m] instanceof Array )
					{
						for( am = 0; am < hide_menu_item[tp]['item'][m].length; am++)
							if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][m][am]).length > 0)
								$(hide_menu_item[tp]['item'][m][am]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][m][am]);
					}
					else
						if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][m]).length > 0)
							$(hide_menu_item[tp]['item'][m]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][m]);
				}
			}
			else
			{

				$('#btn_more').show();
				if($("#bottomMenuTableTr").find(hide_menu_item[tp]['item'][0][0]).length > 0)
					$(hide_menu_item[tp]['item'][0][0]).prependTo("#morePopupTemplet");
				if($("#bottomMenuTableTr").find(hide_menu_item[tp]['item'][0][1]).length > 0)
					$(hide_menu_item[tp]['item'][0][1]).prependTo("#morePopupTemplet");

				for(m = 1; m < hide_menu_item[tp]['item'] .length; m++)
				{

					if( win_width < full_width  - (hide_menu_item[tp]['width'] * m) )
					{
						if( hide_menu_item[tp]['item'][m] instanceof Array )
						{
							for( am = 0; am < hide_menu_item[tp]['item'][m].length; am++)
								if($("#bottomMenuTableTr").find(hide_menu_item[tp]['item'][m][am]).length > 0)
									$(hide_menu_item[tp]['item'][m][am]).prependTo("#morePopupTemplet");
						}
						else
							if($("#bottomMenuTableTr").find(hide_menu_item[tp]['item'][m]).length > 0)
								$(hide_menu_item[tp]['item'][m]).prependTo("#morePopupTemplet");

					}
					else
					{
						if( hide_menu_item[tp]['item'][m] instanceof Array )
						{
							for( am = 0; am < hide_menu_item[tp]['item'][m].length; am++)
								if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][m][am]).length > 0)
									$(hide_menu_item[tp]['item'][m][am]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][m][am]);
						}
						else
							if($("#morePopupTemplet").find(hide_menu_item[tp]['item'][m]).length > 0)
								$(hide_menu_item[tp]['item'][m]).prependTo("#bottomMenuTableTr > .td-"+hide_menu_item[tp]['index'][m]);
					}
				}

			}
		}
	},
	_resize = function () {
$('#print-frame').height( $(window).height() );
var frameID = document.getElementById("print-frame");
frameID.contentWindow.resize_print_frame();
		ViewerManager.bookContainerWidth = $(window).width();
	    ViewerManager.bookContainerHeight = $(window).height();

		_menu_resize();

	    if (ViewerManager.bookContainerHeight == 0) {ViewerManager.bookContainerHeight = $(document).height();}
	    // for Responsive UI
	    var title_text = String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength());

	    if (ViewerManager.Settings.useComment == 'true' && $("#header_title").width() > 100) {
	        title_text = (String(ViewerManager.Local.cntsTitle).getStringLength(adjustTitleLength()) + '<span id="comment_btn"></span>');
	    }

	    $("#header_title").html(title_text);
	    $("#header_title").attr({"alt":ViewerManager.Local.cntsTitle, "title":ViewerManager.Local.cntsTitle});

	    $('#thumb_container').fadeOut('fast', function () {
	        $('#thumbnail').empty();
	    });

	    if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
			log("@ Mobile Device!");

			$('#header_toggle').css('display', 'block').css('left', '50%').css('left', '-=27px');
			setMobileOrientation("resize");
		} else {
			log("Desktop Computer!");

			if ((window.innerWidth / window.innerHeight) >= (1)) {
				$("#header_container").css("width", "100%");
				$("#footer_container").css("width", "100%");

				ViewerManager.pageMODE = "DOUBLE";
				if(ViewerManager.pixeWidth)
					$("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png");
				else
					$("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");
				// 짝수페이지인 경우, 홀수로 변경
				if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0) {
					var newNumber = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;
					ViewerManager.PAGE_CURRENT_NUMBER = newNumber;
				}

				ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
			} else {
				$("#header_container").css("width", singlePageWidth + " px");
				$("#footer_container").css("width", singlePageWidth + " px");

				ViewerManager.pageMODE = "SINGLE";
				$("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_01.png");

				ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
			}

			if ($("#header").css('display') == 'none') {
				//$("#header").css('display', 'block');
				$('#btn_menu').attr('src', 'images/topArrowDown_btn_01.png');
				$("#header_toggle").css('display', 'block');
			}
			$('#header_toggle').css('left', '50%').css('left', '-=27px');
		}
	}

	var adjustTitleLength = function () {
	    var td_width = $('#header_title').parent().width();
	    var div_fontsize = Number($('#header_title').css('font-size').replace('px',''));
	    return parseInt(td_width / div_fontsize);
	}

	var exportResponsiveUI = {
		setResponsiveMobileUI : setResponsiveMobileUI,
		setResponsiveScale : setResponsiveScale,
		setMobileOrientation : setMobileOrientation,
		_loadStart : _loadStart,
		_resize : _resize,
		_set_morelayout : _set_morelayout,
		adjustTitleLength : adjustTitleLength,
		setHeader : _setHeader,
		hide_menu_item:hide_menu_item
	};

	CONTROL.responsiveUI = exportResponsiveUI;

	return exportResponsiveUI;

});
