define(["jquery", "base64", "log", "browser"], function(L, w, m, g) {
    m("\n @ import draw.js ... \n");
    if (g.ie9 || g.ie10) {
        L("#drawing_container").remove()
    }
    var i, R = "http://www.w3.org/2000/svg";
    var P = false,
        l, h, F, p, am, s, k, z, ad, X = [],
        A, C, r, al, T, W, a = 0,
        Q = "",
        Y, U, O = [],
        v, an, D, f = [];
    var ak = {
            isDrawing: false,
            mousedown: function(ao) {
                U = ao.y * ViewerManager.zoomRate + Number(L("#pages").css("margin-top").split("px")[0]);
                if (U <= L("#header_menu_detail").height()) {
                    return
                }
                X = [];
                al = [Number(ao.x).setPoint(3), Number(ao.y).setPoint(3)];
                X.push(al);
                this.isDrawing = true;
                A = document.createElementNS(R, "path");
                A.setAttribute("opacity", ViewerManager.GLOBALALPHA);
                A.setAttribute("fill", "none");
                A.setAttribute("stroke", ViewerManager.LINECOLOR);
                A.setAttribute("stroke-width", ViewerManager.LINEWIDTH);
                A.setAttribute("stroke-linecap", "round");
                A.setAttribute("stroke-linejoin", "round");
                A.setAttribute("d", "M" + X[0][0] + "," + X[0][1]);
                C = document.createElementNS(R, "path");
                C.setAttribute("opacity", ViewerManager.GLOBALALPHA);
                C.setAttribute("fill", "none");
                C.setAttribute("stroke", ViewerManager.LINECOLOR);
                C.setAttribute("stroke-width", ViewerManager.LINEWIDTH);
                C.setAttribute("stroke-linecap", "round");
                C.setAttribute("stroke-linejoin", "round");
                C.setAttribute("d", "M" + X[0][0] + "," + X[0][1]);
                p = document.getElementById("svgMask");
                s = document.getElementById("svgDrawGroup");
                if (ViewerManager.GLOBALCOMPOSITEOPERATION == "destination-out") {
                    A.setAttribute("visibility", "hidden");
                    s.appendChild(A);
                    C.setAttribute("stroke", "#000000");
                    p.appendChild(C)
                } else {
                    C.setAttribute("stroke", "#FFFFFF");
                    p.appendChild(C);
                    s.appendChild(A)
                }
                T = A.getAttribute("d");
                W = 0;
                if (al[0] <= parseInt(ViewerManager.iframeContentsWidth)) {
                    v = "left"
                } else {
                    v = "right"
                }
                an = v;
                D = ""
            },
            mousemove: function(ap) {
                if (this.isDrawing) {
                    al = [Number(ap.x).setPoint(3), Number(ap.y).setPoint(3)];
                    X.push(al);
                    W++;
                    var ao;
                    if (W == 1) {
                        ao = " Q" + al[0] + "," + al[1]
                    } else {
                        ao = " " + al[0] + "," + al[1]
                    }
                    T = T + ao;
                    if (W % 2 == 0) {
                        L(A).attr("d", T);
                        L(C).attr("d", T)
                    }
                    if (D == "") {
                        if (al[0] <= parseInt(ViewerManager.iframeContentsWidth)) {
                            an = "left"
                        } else {
                            an = "right"
                        }
                        if (v != an) {
                            D = an
                        }
                    }
                }
            },
            mouseup: function() {
                if (this.isDrawing == false && (L("#drawing:hover").length !== 0 || L("#close_draw:hover").length !== 0)) {
                    m("@ mouseenter! ");
                    return
                } else {
                    m("@ mouseleave! ")
                }
                this.isDrawing = false;
                ai()
            }
        },
        ai = function() {
            //console.log("@ createDrawObject...");
            var ao;
            if (D == "") {
                D = v
            }
            ao = v;
            if (v != D) {
                ao = "double"
            }
			
            f.push(ao);
            var ap = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) % 2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
            Q = h.innerHTML
        },
        E = function() {
            if (L("#draw_detail").css("display") === "block") {
                L("#btn_draw").attr("src", "images/titan_topMenu/topMenu_draw_btn_01.png");
                L("#draw_detail").slideUp("slow", function() {
                    L("#header_menu_detail").css({
                        display: "none"
                    })
                })
            }
        },
        ae = function() {
            m("@ attachCanvasEvent...");
            if (L("#div-ad-left").length > 0) {
                L("#div-ad-left").css("display", "none")
            }
            if (L("#div-ad-right").length > 0) {
                L("#div-ad-right").css("display", "none")
            }
            if (h == null) {
                h = document.getElementById("drawingSVG")
            }
            h.addEventListener(ViewerManager.eventSelector.downEvent, V, false);
            h.addEventListener(ViewerManager.eventSelector.moveEvent, V, false);
            h.addEventListener(ViewerManager.eventSelector.upEvent, V, false);
            c()
        },
        ab = function() {
            m("@ detachCanvasEvent...");
            if (L("#div-ad-left").length > 0) {
                L("#div-ad-left").css("display", "none")
            }
            if (L("#div-ad-right").length > 0) {
                L("#div-ad-right").css("display", "none")
            }
            if (h == null) {
                h = document.getElementById("drawingSVG")
            }
            h.removeEventListener(ViewerManager.eventSelector.downEvent, V, false);
            h.removeEventListener(ViewerManager.eventSelector.moveEvent, V, false);
            h.removeEventListener(ViewerManager.eventSelector.upEvent, V, false);
            q()
        },
        V = function(ar) {
            var aq = L("#pages").css("margin-left").split("px")[0];
            var ap = L("#pages").css("margin-top").split("px")[0];
            var at, ao = function(au) {
                var av = Number(h.style.left.replace("px", ""));
                at = {
                    x: ((au.clientX - Number(aq)) / ViewerManager.zoomRate) - (av) + a,
                    y: ((au.clientY - Number(ap)) / ViewerManager.zoomRate)
                };
                return at
            };
            switch (ar.type) {
                case "mousedown":
                    ak.mousedown(ao(ar));
                    break;
                case "mousemove":
                    ak.mousemove(ao(ar));
                    break;
                case "touchstart":
                    ak.mousedown(ao(ar.touches.item(0)));
                    break;
                case "touchmove":
                    ak.mousemove(ao(ar.touches.item(0)));
                    break;
                case "mouseup":
                case "touchend":
                    ak.mouseup();
                    break
            }
        },
        c = function() {
            L("#drawing_container").css("pointer-events", "auto");
            L("#header_title").text(ViewerManager.Local.modeTitle).css("left", "50%").css("left", "-=50px");
            L("#currentModeNotice").css("display", "block").text(ViewerManager.Local.modeNoticeText)
        },
        q = function() {
            L("#drawing_container").css("pointer-events", "none");
            L("#currentModeNotice").empty().css("display", "none")
        },
        ag = function(ao, ap) {
            m(ao, ap);
            if (ao != null && ao != undefined) {
                h.innerHTML = ao;
                p = document.getElementById("svgMask");
                s = document.getElementById("svgDrawGroup");
                Q = ao
            }
        },
        e = function(ao) {
            if (parseInt(ao) == 0) {
                return
            }
				
            m("@@ saveCanvasData...");
            if (Q != null && Q.length > 0) {
                K(ao)
            }
        },
        ah = function(ap) {
            m("@ insertClearRectEraser...");
            var ao = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) % 2 == 0 ? 0 : ViewerManager.iframeContentsWidth;
            s = document.getElementById("svgDrawGroup");
            F = document.createElementNS(R, "rect");
            F.setAttributeNS(null, "opacity", "1");
            F.setAttributeNS(null, "fill", "#660099");
            F.setAttributeNS(null, "x", ao);
            F.setAttributeNS(null, "y", "0");
            F.setAttributeNS(null, "visibility", "hidden");
            F.setAttributeNS(null, "width", ViewerManager.iframeContentsWidth);
            F.setAttributeNS(null, "height", ViewerManager.iframeContentsHeight);
            s.appendChild(F);
            p = document.getElementById("svgMask");
            r = document.createElementNS(R, "rect");
            r.setAttributeNS(null, "opacity", "1");
            r.setAttributeNS(null, "fill", "#000000");
            r.setAttributeNS(null, "x", ao);
            r.setAttributeNS(null, "y", "0");
            r.setAttributeNS(null, "width", ViewerManager.iframeContentsWidth);
            r.setAttributeNS(null, "height", ViewerManager.iframeContentsHeight);
            p.appendChild(r);
            ai();
            e(ViewerManager.PAGE_CURRENT_NUMBER)
        },
        o = function(ap) {
            console.log("@ clearCanvas...");
            try {
                if (ap) {
                    switch (ViewerManager.pageMODE) {
                        case "SINGLE":
                            ah(ViewerManager.PAGE_CURRENT_NUMBER);
                            break;
                        case "DOUBLE":
                            console.log("clearCanvas DOUBLE");
                            if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
                                n(ViewerManager.PAGE_CURRENT_NUMBER)
                            } else {
                                n(parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1);
                                n(ViewerManager.PAGE_CURRENT_NUMBER)
                            }
                            h.innerHTML = Y;
                            Q = "";
                            break
                    }
                }
            } catch (ao) {
                m("@ clearCanvas Error : " + ao)
            }
        },
        S = function() {
            m("@ loadServerData...");
            i = JSON.parse(CONTROL.save_target("draw"));
            if (i.draw.length > 0) {
                var aw = false;
                for (var aq = 0; aq < i.draw.length; aq++) {
                    var ao = i.draw[aq].pageNo == undefined ? parseInt(i.draw[aq].pageNum) : parseInt(i.draw[aq].pageNo);
                    ao = i.draw[aq].pageno == undefined ? ao : parseInt(i.draw[aq].pageno);
                    if (ViewerManager.VIEWER_TYPE == "LOCAL") {
                        if (ViewerManager.GetData.EPUB.ID == i.draw[aq].bookId) {
                            if (ViewerManager.pageMODE == "SINGLE") {
                                if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                    ag(i.draw[aq].svg, i.draw[aq].imgData);
                                    break
                                }
                            } else {
                                if (ViewerManager.pageMODE == "DOUBLE") {
                                    if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
                                        if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                            ag(i.draw[aq].svg, i.draw[aq].imgData);
                                            break
                                        }
                                    } else {
                                        if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == ao || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                            ag(i.draw[aq].svg, i.draw[aq].imgData);
                                            break
                                        }
                                    }
                                }
                            }
                        }
                    } else {
                        if (i.draw[aq].svg == undefined) {
                            aw = true
                        }
                        if (i.draw[aq].cntsId != undefined || i.draw[aq].pageNum != undefined || i.draw[aq].bookId == undefined || i.draw[aq].svg == undefined) {
                            var av = i.draw[aq].cntsId != undefined ? i.draw[aq].cntsId : ViewerManager.GetData.EPUB.ID;
                            var at = String(ao);
                            var ax = i.draw[aq].imgData;
                            var ap = i.draw[aq].lastDate != undefined ? i.draw[aq].lastDate : (new Date()).yyyymmddhh24miss();
                            var au = i.draw[aq].svg;
                            if (ax != undefined && au == undefined) {
                                au = N(ax)
                            }
                            var ar = parseInt(at) == 1 ? parseInt(at) : parseInt(at) % 2 == 0 ? parseInt(at) : parseInt(at) - 1;
                            if (ar < 10) {
                                ar = "000" + String(ar)
                            } else {
                                if (ar >= 10 && ar < 100) {
                                    ar = "00" + String(ar)
                                } else {
                                    if (ar >= 100 && ar < 1000) {
                                        ar = "0" + String(ar)
                                    } else {
                                        if (ar >= 1000 && ar <= 10000) {
                                            ar = String(ar)
                                        }
                                    }
                                }
                            }
                            au = au.replace(/\t/gi, "");
                            i.draw[aq] = {
                                bookId: av,
                                pageno: at,
                                lastdate: ap,
                                svg: au,
                                drawurl: ar + ".svg",
                                show: "true"
                            };
                            if (aq == i.draw.length - 1) {
                                CONTROL.save_target("draw", JSON.stringify(i));
                                if (aw == true) {
                                    CONTROL.save_svg_each()
                                }
                                if (ViewerManager.pageMODE == "SINGLE") {
                                    if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                        ag(i.draw[aq].svg, null)
                                    }
                                } else {
                                    if (ViewerManager.pageMODE == "DOUBLE") {
                                        if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
                                            if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                                ag(i.draw[aq].svg, null)
                                            }
                                        } else {
                                            if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == ao || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                                ag(i.draw[aq].svg, null)
                                            }
                                        }
                                    }
                                }
                            }
                        } else {
                            if (ViewerManager.pageMODE == "SINGLE") {
                                if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                    ag(i.draw[aq].svg, i.draw[aq].imgData);
                                    break
                                }
                            } else {
                                if (ViewerManager.pageMODE == "DOUBLE") {
                                    if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
                                        if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                            ag(i.draw[aq].svg, i.draw[aq].imgData);
                                            break
                                        }
                                    } else {
                                        if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == ao || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == ao) {
                                            ag(i.draw[aq].svg, i.draw[aq].imgData);
                                            break
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },
        N = function(az) {
            m("convertImageToSVG", az);
            var aq, ao = JSON.parse(az),
                ap = null,
                ax;
            h.innerHTML = Y;
            p = document.getElementById("svgMask");
            s = document.getElementById("svgDrawGroup");
            for (var au in ao.data) {
                ax = JSON.stringify(ao.data[au]);
                if (ap != null && ap == ax) {
                    ap = ax;
                    continue
                }
                var at, ar, ay, av, aw;
                if (ao.data[au]["globalCompositeOperation"] == "source-over") {
                    at = "1";
                    ar = ao.data[au]["color"];
                    if (ar.indexOf("Black") != -1) {
                        ar = "#000000"
                    } else {
                        if (ar.indexOf("Purple") != -1) {
                            ar = "#6F00FF"
                        } else {
                            if (ar.indexOf("Red") != -1) {
                                ar = "#FF0000"
                            } else {
                                if (ar.indexOf("Yellow") != -1) {
                                    ar = "#FFFF00"
                                } else {
                                    if (ar.indexOf("Green") != -1) {
                                        ar = "#00FF00"
                                    } else {
                                        if (ar.indexOf("Blue") != -1) {
                                            ar = "#0000FF"
                                        }
                                    }
                                }
                            }
                        }
                    }
                    ay = ao.data[au]["lineWidth"];
                    av = af(ao.data[au]["path"]);
                    A = document.createElementNS(R, "path");
                    A.setAttribute("opacity", at);
                    A.setAttribute("fill", "none");
                    A.setAttribute("stroke", ar);
                    A.setAttribute("stroke-width", ay);
                    A.setAttribute("stroke-linecap", "round");
                    A.setAttribute("stroke-linejoin", "round");
                    A.setAttribute("d", av);
                    C = document.createElementNS(R, "path");
                    C.setAttribute("opacity", at);
                    C.setAttribute("fill", "none");
                    C.setAttribute("stroke", ar);
                    C.setAttribute("stroke-width", ay);
                    C.setAttribute("stroke-linecap", "round");
                    C.setAttribute("stroke-linejoin", "round");
                    C.setAttribute("d", av);
                    C.setAttribute("stroke", "#FFFFFF");
                    p.appendChild(C);
                    s.appendChild(A)
                } else {
                    if (ao.data[au]["globalCompositeOperation"] == "xor") {
                        at = "0.5";
                        ar = ao.data[au]["color"];
                        if (ar.replace(/\s/gi, "").indexOf("rgba(0,0,0") != -1) {
                            ar = "#000000"
                        } else {
                            if (ar.replace(/\s/gi, "").indexOf("rgba(111,0,255") != -1) {
                                ar = "#6F00FF"
                            } else {
                                if (ar.replace(/\s/gi, "").indexOf("rgba(255,0,0") != -1) {
                                    ar = "#FF0000"
                                } else {
                                    if (ar.replace(/\s/gi, "").indexOf("rgba(255,255,0") != -1) {
                                        ar = "#FFFF00"
                                    } else {
                                        if (ar.replace(/\s/gi, "").indexOf("rgba(0,255,0") != -1) {
                                            ar = "#00FF00"
                                        } else {
                                            if (ar.replace(/\s/gi, "").indexOf("rgba(0,0,255") != -1) {
                                                ar = "#0000FF"
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        ay = ao.data[au]["lineWidth"];
                        av = af(ao.data[au]["path"]);
                        C = document.createElementNS(R, "path");
                        C.setAttribute("opacity", at);
                        C.setAttribute("fill", "none");
                        C.setAttribute("stroke", "#FFFFFF");
                        C.setAttribute("stroke-width", ay);
                        C.setAttribute("stroke-linecap", "round");
                        C.setAttribute("stroke-linejoin", "round");
                        C.setAttribute("d", av);
                        p.appendChild(C);
                        A = document.createElementNS(R, "path");
                        A.setAttribute("opacity", at);
                        A.setAttribute("fill", "none");
                        A.setAttribute("stroke", ar);
                        A.setAttribute("stroke-width", ay);
                        A.setAttribute("stroke-linecap", "round");
                        A.setAttribute("stroke-linejoin", "round");
                        A.setAttribute("d", av);
                        s.appendChild(A)
                    } else {
                        if (ao.data[au]["globalCompositeOperation"] == "destination-out") {
                            ay = ao.data[au]["lineWidth"];
                            av = af(ao.data[au]["path"]);
                            A = document.createElementNS(R, "path");
                            A.setAttribute("opacity", "1");
                            A.setAttribute("fill", "none");
                            A.setAttribute("stroke", "#660099");
                            A.setAttribute("stroke-width", ay);
                            A.setAttribute("stroke-linecap", "round");
                            A.setAttribute("stroke-linejoin", "round");
                            A.setAttribute("d", av);
                            A.setAttribute("visibility", "hidden");
                            s.appendChild(A);
                            C = document.createElementNS(R, "path");
                            C.setAttribute("opacity", "1");
                            C.setAttribute("fill", "none");
                            C.setAttribute("stroke", "#000000");
                            C.setAttribute("stroke-width", ay);
                            C.setAttribute("stroke-linecap", "round");
                            C.setAttribute("stroke-linejoin", "round");
                            C.setAttribute("d", av);
                            p.appendChild(C)
                        } else {
                            if (ao.data[au]["globalCompositeOperation"] == "clearRect") {
                                if (ao.data[au]["target"] == "leftFrame") {
                                    aw = "0"
                                } else {
                                    if (ao.data[au]["target"] == "rightFrame") {
                                        aw = ViewerManager.iframeContentsWidth
                                    }
                                }
                                F = document.createElementNS(R, "rect");
                                F.setAttributeNS(null, "opacity", "1");
                                F.setAttributeNS(null, "fill", "#660099");
                                F.setAttributeNS(null, "x", aw);
                                F.setAttributeNS(null, "y", "0");
                                F.setAttributeNS(null, "visibility", "hidden");
                                F.setAttributeNS(null, "width", ViewerManager.iframeContentsWidth);
                                F.setAttributeNS(null, "height", ViewerManager.iframeContentsHeight);
                                s.appendChild(F);
                                p = document.getElementById("svgMask");
                                r = document.createElementNS(R, "rect");
                                r.setAttributeNS(null, "opacity", "1");
                                r.setAttributeNS(null, "fill", "#000000");
                                r.setAttributeNS(null, "x", aw);
                                r.setAttributeNS(null, "y", "0");
                                r.setAttributeNS(null, "width", ViewerManager.iframeContentsWidth);
                                r.setAttributeNS(null, "height", ViewerManager.iframeContentsHeight);
                                p.appendChild(r)
                            }
                        }
                    }
                }
                ap = JSON.stringify(ao.data[au])
            }
            aq = h.innerHTML;
            aq = aq.replace(/\t/gi, "");
            return aq
        },
        u = function(ap) {
            m("convertWebToApp", ap);
            var av, aw, au, at, aq, ax;
            var ar = document.createElementNS(R, "svg");
            ar.innerHTML = ap;
            if (ar.childNodes.length == 0) {
                ar = null;
                av = "";
                return av
            }
            for (aw = 0; aw < ar.childNodes.length; aw++) {
                var ay = ar.childNodes[aw].nodeName.toLowerCase();
                if (ay == "mask") {
                    aq = ar.childNodes[aw].cloneNode(true);
                    ar.removeChild(ar.childNodes[aw]);
                    aw--
                } else {
                    if (ay == "g") {
                        ax = ar.childNodes[aw].cloneNode(true);
                        ar.removeChild(ar.childNodes[aw]);
                        aw--
                    }
                }
            }
            var ao = document.createElementNS(R, "g");
            ao.innerHTML = ax.innerHTML;
            for (aw = 0; aw < ao.childNodes.length; aw++) {
                var ay = ao.childNodes[aw].nodeName.toLowerCase();
                if (ao.childNodes[aw].nodeType == "1") {
                    if (ao.childNodes[aw].getAttribute("visibility") != null) {
                        ao.childNodes[aw].removeAttribute("visibility")
                    }
                    ar.appendChild(ao.childNodes[aw].cloneNode(true))
                }
            }
            av = ar.innerHTML;
            av = av.replace(/\t/gi, "");
            av = av.replace(/\n/gi, "");
            m("returnSVG", av);
            ar = null;
            return av
        },
        d = function(aA) {
            m("convertAppToWeb", aA);
            var av, aw, at, ar, ao, ay;
            var aq = document.createElementNS(R, "svg");
            aq.innerHTML = Y;
            for (aw = 0; aw < aq.childNodes.length; aw++) {
                var aB = aq.childNodes[aw].nodeName.toLowerCase();
                if (aB == "mask") {
                    ao = aq.childNodes[aw]
                } else {
                    if (aB == "g") {
                        ay = aq.childNodes[aw]
                    }
                }
            }
            var az, ax, au, ap;
            for (aw = 0; aw < aA.length; aw++) {
                if (aA[aw].nodeType == 1) {
                    if (aA[aw].tagName == "path") {
                        az = aA[aw].cloneNode(true);
                        ax = az.cloneNode(true);
                        if (az.getAttribute("stroke") == "#660099") {
                            az.setAttribute("visibility", "hidden");
                            if (az.getAttribute("xmlns") != null) {
                                az.removeAttribute("xmlns")
                            }
                            ay.appendChild(az);
                            ax.setAttribute("stroke", "#000000");
                            if (ax.getAttribute("xmlns") != null) {
                                ax.removeAttribute("xmlns")
                            }
                            ao.appendChild(ax)
                        } else {
                            ax.setAttribute("stroke", "#FFFFFF");
                            if (ax.getAttribute("xmlns") != null) {
                                ax.removeAttribute("xmlns")
                            }
                            ao.appendChild(ax);
                            if (az.getAttribute("xmlns") != null) {
                                az.removeAttribute("xmlns")
                            }
                            ay.appendChild(az)
                        }
                    } else {
                        if (aA[aw].tagName == "rect") {
                            au = aA[aw].cloneNode(true);
                            ap = au.cloneNode(true);
                            ap.setAttribute("fill", "#000000");
                            ap.setAttribute("stroke", "#000000");
                            if (ap.getAttribute("xmlns") != null) {
                                ap.removeAttribute("xmlns")
                            }
                            ao.appendChild(ap);
                            au.setAttribute("visibility", "hidden");
                            if (au.getAttribute("xmlns") != null) {
                                au.removeAttribute("xmlns")
                            }
                            ay.appendChild(au)
                        }
                    }
                }
            }
            av = aq.innerHTML;
            av = av.replace(/\t/gi, "");
            aq = null;
            return av
        },
        af = function(ar) {
            var at, aq, ao = ar.length,
                ap;
            if (ao % 2 == 0) {
                ao = ao - 1
            }
            for (aq = 0; aq < ao; aq++) {
                ap = [Number(ar[aq][0]).setPoint(3), Number(ar[aq][1]).setPoint(3)];
                if (aq == 0) {
                    at = "M" + ap[0] + "," + ap[1]
                } else {
                    if (aq == 1) {
                        at = at + " Q" + ap[0] + "," + ap[1]
                    } else {
                        at = at + " " + ap[0] + "," + ap[1]
                    }
                }
            }
            return at
        },
        G = function(ao, at) {
            m("excuteInsertDrawDataInLocalStorage", ao, at);
			
            if (ViewerManager.pageMODE == "SINGLE") {
                if (parseInt(ao) == 1) {
                    J(ao, at)
                } else {
                    var av = parseInt(ao) % 2 == 0 ? 1 : -1;
                    var aw = O[parseInt(ao) + av] == "false" ? "false" : O[parseInt(ao) + av] == undefined ? "false" : O[parseInt(ao) + av];
                    J((parseInt(ao) + av), aw);
                    J(ao, at)
                }
            } else {
                if (ViewerManager.pageMODE == "DOUBLE") {
                   
					/*
					if (f.length == 0) {
						return
                    }
					*/
					
					var gl= false,gr = false;
					var fp = false;
					$('#svgMask').find("path").each(function() {
						fp = true;
						var rect = ($(this).attr("d")).split(" ");
						var rect_x = rect[1];
						if(parseFloat(rect_x) >= 0 && parseFloat(rect_x) < parseInt(ViewerManager.iframeContentsWidth))
							gl = true;
						
						if( parseFloat(rect_x) > parseInt(ViewerManager.iframeContentsWidth))
							gr = true;
					});

					if(!fp)
						return;
                    
					if(gl && gr)
						f[0] = "double";
					else
					{
						if(gl)
							f[0] = "left";
						if(gr)
							f[0] = "right";
					}

					var au, aq, ax;
                    if (f.length == 1) {
                        if (f[0] == "double") {
                            aq = "double";
                            au = "double"
                        } else {
                            aq = f[0];
                            au = "single"
                        }
                    } else {
                        for (var ar = 0, ap = f.length; ar < ap; ar++) {
                            if (ar == 0) {
                                if (f[0] == "double") {
                                    aq = "double";
                                    au = "double";
                                    break
                                } else {
                                    aq = f[0];
                                    au = "single"
                                }
                            } else {
                                if (f[ar] == "double") {
                                    aq = "double";
                                    au = "double";
                                    break
                                } else {
                                    if (aq != f[ar]) {
                                        au = "double";
                                        break
                                    }
                                }
                            }
                        }
                    }
					console.log(ao+","+aq+","+au);
                    if (au == "single") {
                        if (aq == "left") {
                            j((parseInt(ao) - 1));
                            J((parseInt(ao) - 1))
                        } else {
                            j(ao);
                            J(ao)
                        }
                    } else {
                        j((parseInt(ao) - 1));
                        J((parseInt(ao) - 1));
                        j(ao);
                        J(ao);
                    }
                    v = "", D = "";
                    f = []
                }
            }
        },
        j = function(at) {
			
            m("excuteDeleteSavedLocalStorageData", at);
            try {
                i = JSON.parse(CONTROL.save_target("draw"));
                var ap = i.draw.length;
                for (var aq = ap - 1; aq > -1; aq--) {
                    var ao = i.draw[aq].pageNo == undefined ? parseInt(i.draw[aq].pageNum) : parseInt(i.draw[aq].pageNo);
                    ao = i.draw[aq].pageno == undefined ? ao : parseInt(i.draw[aq].pageno);
                    if (parseInt(at) == ao) {
                        i.draw.splice(aq, 1)
                    }
                }
				
                CONTROL.save_target("draw", JSON.stringify(i))
            } catch (ar) {
					
                m(ar)
            }
        },
        K = function(au) {
            m("@ overWriteLocalData...", au);
            try {
                i = JSON.parse(CONTROL.save_target("draw"));
                if (i.draw.length > 0) {
                    var at = false;
                    for (var ap = 0; ap < i.draw.length; ap++) {
                        var ao = i.draw[ap].pageNo == undefined ? parseInt(i.draw[ap].pageNum) : parseInt(i.draw[ap].pageNo);
                        ao = i.draw[ap].pageno == undefined ? ao : parseInt(i.draw[ap].pageno);
						if (ViewerManager.VIEWER_TYPE == "LOCAL") {
                            if (ViewerManager.GetData.EPUB.ID == i.draw[ap].bookId && parseInt(au) == ao) {
                                at = true;
                                var ar = ViewerManager.pageMODE == "SINGLE" ? (parseInt(au) % 2 == 0 ? (parseInt(au) + 1) : (parseInt(au) - 1)) : (parseInt(au) - 1);

								j(au);
                                if (ar != 0) {
                                    j(ar)
                                }
                                G(au);
                                break
                            } else {
                                at = false
                            }
                        } else {
                            if (parseInt(au) == ao) {
                                at = true;
                                var ar = ViewerManager.pageMODE == "SINGLE" ? (parseInt(au) % 2 == 0 ? (parseInt(au) + 1) : (parseInt(au) - 1)) : (parseInt(au) - 1);
                                j(au);
                                if (ar != 0) {
                                    j(ar)
                                }
                                G(au);
                                break
                            } else {
                                at = false
                            }
                        }
                    }
                    if (at == false) {
                        G(au)
                    }
                } else {
                    G(au)
                }
            } catch (aq) {
                m("@ overWriteLocalData " + aq)
            }
        },
        n = function(ar) {
            m("@ deleteLocalData...");
            try {
                i = JSON.parse(CONTROL.save_target("draw"));
                for (var ap = 0; ap < i.draw.length; ap++) {
                    var ao = i.draw[ap].pageNo == undefined ? parseInt(i.draw[ap].pageNum) : parseInt(i.draw[ap].pageNo);
                    ao = i.draw[ap].pageno == undefined ? ao : parseInt(i.draw[ap].pageno);
                    if (parseInt(ar) == ao) {
                        i.draw.splice(ap, 1);
                        CONTROL.save_target("draw", JSON.stringify(i));
                        m("@ localStorage.draw : " + JSON.parse(CONTROL.save_target("draw")))
                    }
                }
            } catch (aq) {
                m("@ deleteLocalData Error : " + aq)
            }
        },
        J = function(at, ar, aq) {
			
            m("@ insertlocalData...");
            m("@ insert date : " + (new Date()).yyyymmddhh24miss(), at + "page");
            i = JSON.parse(CONTROL.save_target("draw"));
            m("@ ::: insert draw data to localStorage ... :::");
            var ap = "true";
            if (aq == "false") {
                ap = aq
            }
            var ao = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) % 2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
            if (ao < 10) {
                ao = "000" + String(ao)
            } else {
                if (ao >= 10 && ao < 100) {
                    ao = "00" + String(ao)
                } else {
                    if (ao >= 100 && ao < 1000) {
                        ao = "0" + String(ao)
                    } else {
                        if (ao >= 1000 && ao <= 10000) {
                            ao = String(ao)
                        }
                    }
                }
            }
            Q = Q.replace(/\t/gi, "");
            i.draw.push({
                bookId: ViewerManager.GetData.EPUB.ID,
                pageno: String(at),
                lastdate: (new Date()).yyyymmddhh24miss(),
                svg: Q,
                drawurl: ao + ".svg",
                show: ap
            });
            O[at] = ap;
			
            CONTROL.save_target("draw", JSON.stringify(i))
        },
        I = function(aq) {
            var ao = JSON.parse(window.localStorage.getItem("palette"));
            if (ao === null) {
                try {
                    window.localStorage.setItem("palette", JSON.stringify({
                        palette: []
                    }));
                    ao = JSON.parse(window.localStorage.getItem("palette"));
                    ao.palette.push({
                        paletteId: "pen",
                        selectColor: "#colorBlack",
                        lineWidth: "6"
                    }, {
                        paletteId: "highlight",
                        selectColor: "#highlighterBlack",
                        lineWidth: "10"
                    });
                    window.localStorage.setItem("palette", JSON.stringify(ao))
                } catch (ap) {
                    m(ap)
                }
            }
            L(ao.palette[aq].selectColor).trigger("click");
            L("#slider_drawing").slider({
                value: ao.palette[aq].lineWidth
            });
            ViewerManager.LINEWIDTH = ao.palette[aq].lineWidth
        },
        M = function(au, ao, at) {
            var ar;
            switch (ao) {
                case "pen":
                    ar = 0;
                    break;
                case "highlighter":
                    ar = 1;
                    break
            }
            var ap = JSON.parse(window.localStorage.getItem("palette"));
            switch (au) {
                case "color":
                    ap.palette[ar].selectColor = at;
                    break;
                case "lineWidth":
                    ap.palette[ar].lineWidth = at;
                    break
            }
            try {
                window.localStorage.setItem("palette", JSON.stringify(ap))
            } catch (aq) {
                m(aq)
            }
        },
        ac = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("@ draw._init");
            var ao = document.getElementById("drawing_container");
            ao.style.width = (ViewerManager.iframeContentsWidth * 2) + "px";
            ao.style.height = ViewerManager.iframeContentsHeight + "px";
            h = document.getElementById("drawingSVG");
            h.setAttribute("width", (ViewerManager.iframeContentsWidth * 2) + "px");
            h.setAttribute("height", ViewerManager.iframeContentsHeight + "px");
            p = document.getElementById("svgMask");
            p.setAttribute("width", (ViewerManager.iframeContentsWidth * 2));
            p.setAttribute("height", ViewerManager.iframeContentsHeight);
            am = document.getElementById("maskRect");
            am.setAttribute("width", (ViewerManager.iframeContentsWidth * 2));
            am.setAttribute("height", ViewerManager.iframeContentsHeight);
            s = document.getElementById("svgDrawGroup");
            s.setAttribute("width", (ViewerManager.iframeContentsWidth * 2));
            s.setAttribute("height", ViewerManager.iframeContentsHeight);
            Y = h.innerHTML;
            i = JSON.parse(CONTROL.save_target("draw"))
        },
        B = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("@ draw._loadStart");
            L("#draw_detail").css("display", "none");
            L("#drawing_container").css("display", "none");
            ab();
            E();
            h.innerHTML = Y;
            Q = ""
        },
        Z = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("@ draw._loadComplete");
            if (h == null) {
                h = document.getElementById("drawingSVG")
            }
            if (ViewerManager.pageMODE == "SINGLE") {
                if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) % 2 == 0) {
                    a = 0;
                    h.style.width = ViewerManager.iframeContentsWidth + "px";
                    h.setAttribute("viewBox", "0 0 " + ViewerManager.iframeContentsWidth + " " + ViewerManager.iframeContentsHeight)
                } else {
                    a = parseInt(ViewerManager.iframeContentsWidth);
                    h.style.width = ViewerManager.iframeContentsWidth + "px";
                    h.setAttribute("viewBox", ViewerManager.iframeContentsWidth + " 0 " + ViewerManager.iframeContentsWidth + " " + ViewerManager.iframeContentsHeight)
                }
            } else {
                if (ViewerManager.pageMODE == "DOUBLE") {
                    a = 0;
                    h.style.width = ViewerManager.iframeContentsWidth * 2 + "px";
                    h.setAttribute("viewBox", "0 0 " + ViewerManager.iframeContentsWidth * 2 + " " + ViewerManager.iframeContentsHeight)
                }
            }
            L("#drawing_container").css({
                display: "block"
            });
            S()
        },
        y = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("@ draw._save");
            e(ViewerManager.PAGE_CURRENT_NUMBER)
        },
        H = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("@ draw._resize")
        },
        x = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("draw._refresh");
            S()
        },
        aj = function() {
            L("#drawing_container").css({
                "pointer-events": "auto",
                cursor: "-webkit-grab"
            })
        },
        t = function() {
            L("#drawing_container").css({
                "pointer-events": "none",
                cursor: "default"
            })
        },
        aa = function() {
            if (g.ie9 || g.ie10) {
                return
            }
            m("draw._zoom");
            if (ViewerManager.zoomScore == 1) {
                L("#drawing_container").css({
                    "pointer-events": "none",
                    cursor: "default"
                })
            } else {
                if (L("#draw_detail").css("display") === "block") {
                    ab();
                    q();
                    E();
                    console.log("#draw_detail")
                }
                L("#drawing_container").css({
                    "pointer-events": "auto",
                    cursor: "-webkit-grab"
                })
            }
        };
    var b = {
        attachCanvasEvent: ae,
        detachCanvasEvent: ab,
        saveCanvasData: e,
        hideDrawMenu: E,
        onDrawMode: c,
        offDrawMode: q,
        clearCanvas: o,
        setDrawPaletteInfo: I,
        insertDrawPaletteInfo: M,
        convertWebToApp: u,
        convertAppToWeb: d,
        _init: ac,
        _loadStart: B,
        _loadComplete: Z,
        _save: y,
        _resize: H,
        _refresh: x,
        _zoom: aa,
        _zoomMove: aj,
        _zoomClick: t
    };
    CONTROL.draw = b;
    return b
});