define(['jquery', 'log', 'zoom', 'browser'], function ($, log, zoom, browser) {
	'use strict';

	log("\n @ import print.js ... \n");
	
	var excutePrint = function (printWindow, currentNumber) {
		log("@ excutePrint...");
		/*$("#content #pages iframe").printArea( {mode:'iframe', popTitle:'SViewer', popClose:true} );*/

		var printTarget = document.createElement('div');
		printWindow.innerHTML = '<!DOCTYPE html><html lang="ko"> <head>  <style type="text/css"> body, div, img {margin: 0; border: 0; padding: 0; overflow: hidden;} </style> </head> <body> <div id="printArea"> </div> </body> </html>';
		
		/*if (browser.chrome) {

			var pageFrameElement = document.createElement("div");
				pageFrameElement.innerHTML = "<iframe id='leftPrintPage' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe><iframe id='rightPrintPage' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe>";

			printWindow.document.body.appendChild(pageFrameElement);

			var leftPage = printWindow.document.body.querySelector("#leftPrintPage"),
			scale = (ViewerManager.zoomRate < 0.6 ? ViewerManager.zoomRate * 0.75 : ViewerManager.zoomRate), 
			pageNumber, adjustPageNum = (ViewerManager.pageMODE === "SINGLE" ? 0 : 1);

			if (currentNumber - adjustPageNum > 99) {
				pageNumber = "" + (currentNumber - adjustPageNum);
			} else if (currentNumber > 9) {
				pageNumber = "0" + (currentNumber - adjustPageNum);
			} else {
				pageNumber = "00" + (currentNumber - adjustPageNum);
			}	
console.log(leftPage, leftPage.contentDocument);
			leftPage.contentDocument.open('text/html', 'replace');
			if ((currentNumber - adjustPageNum) === 0) {
				leftPage.contentDocument.write(ViewerManager.pageHTMLData[parseInt(currentNumber) - adjustPageNum][1]);	
			} else {
				var getPrintImage =  $.ajax({
					method: "POST",
					async : false,
					url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png"
				});
				getPrintImage.done(function (img) {
					log("@ done...");
					leftPage.contentDocument.write("<img id='leftPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");	
			 	});
				getPrintImage.fail(function (jqXHR, error) {
					log("@ error : " + error);
					leftPage.contentDocument.write("<img id='leftPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");	
				});
			}
			leftPage.contentDocument.close();

			if (ViewerManager.pageMODE === "DOUBLE") {
				if (currentNumber > 99) {
					pageNumber = "" + currentNumber;
				} else if (currentNumber > 9) {
					pageNumber = "0" + currentNumber;
				} else {
					pageNumber = "00" + currentNumber;
				}	
				var rightPage = printWindow.document.body.querySelector("#rightPrintPage");
				rightPage.contentDocument.open('text/html', 'replace');

				if ((currentNumber - adjustPageNum) === ViewerManager.PAGE_TOTAL_NUMBER) {
					rightPage.contentDocument.write(ViewerManager.pageHTMLData[parseInt(currentNumber)][1]);	
				} else {

					var getPrintImage =  $.ajax({
						method: "POST",
						async : false,
						url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png"
					});
					getPrintImage.done(function (img) {
						log("@ done...");
						rightPage.contentDocument.write("<img id='rightPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");					
				 	});
					getPrintImage.fail(function (jqXHR, error) {
						log("@ error : " + error);
						rightPage.contentDocument.write("<img id='rightPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");						
					});
				}
				
				rightPage.contentDocument.close();
			}

			var printTimer = setInterval(function () {
				if (ViewerManager.pageMODE === "SINGLE") {
					pageFrameElement.setAttribute("style", "width:" + leftPage.contentDocument.body.scrollWidth + "px; left: 0px; top: 0px; float: left; -ms-transform:scale(" + scale + "); -webkit-transform:scale(" + scale + "); transform:scale(" + scale + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden; position:absolute;");
				} else {
					log(leftPage.contentDocument);// + " : " + leftPage.contentDocument.body);
					pageFrameElement.setAttribute("style", "width:" + (leftPage.contentDocument.body.scrollWidth + rightPage.contentDocument.body.scrollWidth) + "px; left: 0px; top: 0px; float: left; -ms-transform:scale(" + scale + "); -webkit-transform:scale(" + scale + "); transform:scale(" + scale + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden; position:absolute;");
					rightPage.setAttribute("style", "width:" + rightPage.contentDocument.body.scrollWidth + "px; height:" + rightPage.contentDocument.body.scrollHeight + "px;");
				}
				leftPage.setAttribute("style", "width:" + leftPage.contentDocument.body.scrollWidth + "px; height:" + leftPage.contentDocument.body.scrollHeight + "px;");
				setTimeout(function () {
					clearTimeout(printTimer);
				}, 1000);
					
			}, 50);
	
		} else {
			// for IE Print
			try {
				printWindow.document.body.innerHTML = "<div id='printPageContainer' style='visibility: hidden;'><iframe id='leftPrintPage' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe><iframe id='rightPrintPage' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe></div>";

				var leftPage = printWindow.document.body.querySelector("#leftPrintPage"),
				scale = ViewerManager.zoomRate, 
				pageNumber, adjustPageNum = (ViewerManager.pageMODE === "SINGLE" ? 0 : 1);

				if (currentNumber - adjustPageNum > 99) {
					pageNumber = "" + (currentNumber - adjustPageNum);
				} else if (currentNumber > 9) {
					pageNumber = "0" + (currentNumber - adjustPageNum);
				} else {
					pageNumber = "00" + (currentNumber - adjustPageNum);
				}	

				leftPage.contentDocument.open('text/html', 'replace');
				if ((currentNumber - adjustPageNum) === 0) {
					leftPage.contentDocument.write(ViewerManager.pageHTMLData[parseInt(currentNumber) - adjustPageNum][1]);	
				} else {
					var getPrintImage =  $.ajax({
						method: "POST",
						async : false,
						url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png"
					});
					getPrintImage.done(function (img) {
						log("@ done...");
						leftPage.contentDocument.write("<img id='leftPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");	
				 	});
					getPrintImage.fail(function (jqXHR, error) {
						log("@ error : " + error);
						leftPage.contentDocument.write("<img id='leftPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");	
					});
				}
				leftPage.contentDocument.close();
			
				if (ViewerManager.pageMODE === "DOUBLE") {
					if (currentNumber > 99) {
						pageNumber = "" + currentNumber;
					} else if (currentNumber > 9) {
						pageNumber = "0" + currentNumber;
					} else {
						pageNumber = "00" + currentNumber;
					}	
					var rightPage = printWindow.document.body.querySelector("#rightPrintPage");
					rightPage.contentDocument.open('text/html', 'replace');
					if ((currentNumber - adjustPageNum) === ViewerManager.PAGE_TOTAL_NUMBER) {
						rightPage.contentDocument.write(ViewerManager.pageHTMLData[parseInt(currentNumber)][1]);	
					} else {
						var getPrintImage =  $.ajax({
							method: "POST",
							async : false,
							url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png"
						});
						getPrintImage.done(function (img) {
							log("@ done...");
							rightPage.contentDocument.write("<img id='rightPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");					
					 	});
						getPrintImage.fail(function (jqXHR, error) {
							log("@ error : " + error);
							rightPage.contentDocument.write("<img id='rightPageImage' src='" + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + pageNumber + "/page.png'>");						
						});
					}
					rightPage.contentDocument.close();
					
					setTimeout(function () {
						rightPage.setAttribute("style", "width:" + rightPage.contentDocument.body.scrollWidth + "px; height:" + rightPage.contentDocument.body.scrollHeight + "px;");					
					}, 300);	
				}	
				setTimeout(function () {
					printWindow.document.querySelector("#printPageContainer").setAttribute("style", "width:" + (leftPage.contentDocument.body.scrollWidth + leftPage.contentDocument.body.scrollWidth + 5) + "px; left: 0px; top: 0px; -ms-transform:scale(" + scale + "); -webkit-transform:scale(" + scale + "); transform:scale(" + scale + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden; position:absolute;");
					leftPage.setAttribute("style", "width:" + leftPage.contentDocument.body.scrollWidth + "px; height:" + leftPage.contentDocument.body.scrollHeight + "px;");		
				}, 200);

			} catch (e) {
				log(e);
			}
		} 
		*/
	};

	var exportPrint = {
		excutePrint : excutePrint
	};
	return exportPrint;
});