'use strict';
var userAgent = navigator.userAgent.toLowerCase();
var test = false;

var lastType = '.min';
var index_init, index_type, image_type, main_type;

function checkArr() {
    var checkReturn = false;
    for (var i = 0; i < agentArray.length; i++) {
        if (userAgent.match(String(agentArray[i]).toLowerCase())) {
            checkReturn = true;
            break;
        }
        continue;
    }

    return checkReturn;
}


if (test == true || userAgent == "") {// || checkArr() == true) {
    $('html').html("");
    ViewerManager = null;
    window.close();
} else {
    require.config({
        baseUrl: "",
        waitSeconds: 200,
        paths: {
            jquery: 'libs/jquery',
            xml2json: 'libs/jquery.xml2json',
            core: 'libs/jquery.core.min',
            mouse: 'libs/jquery.mouse.min',
            widget: 'libs/jquery.widget.min',
            slider: 'libs/jquery.slider',
            printarea: 'libs/jquery.PrintArea.js_4',
            base64: 'libs/base64',
            touchPunch: 'libs/jquery.touchPunch',
            log: 'js/MODEL/common/log' + lastType,
            version: 'js/MODEL/common/version' + lastType,
            browser: 'js/MODEL/common/browser' + lastType,
            params: 'js/MODEL/data/params' + lastType,
            selectViewer: 'js/CONTROL/selectViewer' + lastType,
            page: 'js/VIEW/page/page' + lastType,
            epub: 'js/MODEL/data/epub' + lastType,
            lanaguage: 'js/MODEL/data/language' + lastType,
            userInterface: 'js/VIEW/ui/userInterface' + lastType,
            templet: 'js/MODEL/data/templet' + lastType,
            draw: 'js/VIEW/util/draw' + lastType,
            memo: 'js/VIEW/util/memo' + lastType,
            link: "js/VIEW/util/link" + lastType,
            responsiveUI: 'js/VIEW/ui/responsiveUI' + lastType,
            search: 'js/VIEW/util/search' + lastType,
            loading: 'js/VIEW/page/loading' + lastType,
            zoom: 'js/VIEW/util/zoom' + lastType,
            indexList: 'js/VIEW/util/indexList' + lastType,
            bookmark: 'js/VIEW/util/bookmark' + lastType,
            thumbnail: 'js/VIEW/util/thumbnail' + lastType,
            print: 'js/VIEW/util/print' + lastType,
            epubImage: 'js/MODEL/data/epubImage' + lastType,
            pageImage: 'js/VIEW/page/pageImage' + lastType
        },
        shim: {
            xml2json: {
                deps: ['jquery'],
                exports: 'xml2json'
            },
            core: {
                deps: ['jquery'],
                exports: 'core'
            },
            widget: {
                deps: ['jquery'],
                exports: 'widget'
            },
            mouse: {
                deps: ['jquery', 'widget'],
                exports: 'mouse'
            },
            touchPunch: {
                deps: ['jquery', 'widget', 'mouse'],
                exports: 'touchPunch'
            },
            slider: {
                deps: ['jquery', 'core', 'mouse', 'widget'],
                exports: 'slider'
            },
            printarea: {
                deps: ['jquery'],
                exports: 'printarea'
            }
        }
    });

    index_init = false;
    /*
    인덱스펍을 보기 위한 모드 설정
    */
    index_type = {
        load_value: ['jquery',
            'log',
            'version',
            'browser',
            'params',
            'selectViewer'
        ],
        load_func: function($, log, version, browser, params, selectViewer) {
            log("@ start index.js");
            log("\n\n" + version.getInfo() + "\n\n");

            if (params.Params.paramIns == 'none') {
                params.paramsInit();
            }

            if (index_init == false && ViewerManager.main_check == true) {
                change_require('main');
            } else if (index_init == false && ViewerManager.image_check == true) {
                change_require('image');
            }

            index_init = true;
        }
    };

    /*
    ie8 전용 보기를 위한 모드 설정
    */
    image_type = {
        load_value: ['jquery','log','version','browser','params','epubImage'],
        load_func: function($, log, version, browser, params, epubImage) {
            log("@ start imageView.js");

            log("\n\n" + version.getInfo() + "\n\n");

            if (params.Params.paramIns == 'none') {
                params.paramsInit();
            }

            index_init = true;
        }
    };

    /*
    이펍을 보기 위한 모드 설정
    */
    main_type = {
        load_value: ['jquery', 'log', 'version', 'browser','params','printarea','epub','slider', 'touchPunch','page','lanaguage','userInterface','zoom','responsiveUI'],
        load_func: function($, log, version, browser, params, printarea, epub, slider, touchPunch, page, lanaguage, userInterface, zoom,responsiveUI) {
            log("@ start main.js");
            log("\n\n" + version.getInfo() + "\n\n");

            if (params.Params.paramIns == 'none') {
                params.paramsInit();
            }

            if (browser.ie8 || ViewerManager.openError == true) {
                return;
            }

            index_init = true;

            // 파라미터 설정 후, 폼 삭제
            //document.body.removeChild(document.getElementById('getForm'));

            if (ViewerManager.language === null || ViewerManager.language === "" || ViewerManager.language === undefined) {
                log("@ LANGUAGE(navigator.language) = " + navigator.language);
            } else {
                log("@ LANGUAGE(ViewerManager.language) = " + ViewerManager.language);
            }

            log("\n @@ S viewer Initializa... \n");
            log("@ cntsDirPath= " + ViewerManager.Path.cntsDirPath);
            log("@ cntsFilePath= " + ViewerManager.Path.cntsFilePath);
            log("@ cntsTitle= " + ViewerManager.Local.cntsTitle);

            // 파라미터 받아서 설정 처리
            if (ViewerManager.Settings.bgType == 'color') {
                $('#content').css('background', '#' + ViewerManager.Settings.bgColor);
            } else if (ViewerManager.Settings.bgType == 'image') {
                $('#content').css('background', 'url(' + ViewerManager.Settings.bgUrl + ')');
            }

            log('@purchase : ' + ViewerManager.Params.purchase + ' @prePageNo : ' + ViewerManager.Params.prePageNo);
            ViewerManager.urlPage = page.getURLParameter('page');
            if (page.getURLParameter('subjSeq')) ViewerManager.userInfo.subjSeq = page.getURLParameter('subjSeq');

            ViewerManager.sliderValue = 1;
            ViewerManager.isPageSlider = false;
            ViewerManager.PAGE_TOTAL_NUMBER = ViewerManager.ePub.opf_xml2json_total_len;
            ViewerManager.PAGE_OPS_NAME = ViewerManager.ePub.ops_name;

            // drawing support check
            ViewerManager.isDraw = false;

            ViewerManager.pageHistory = [];
            ViewerManager.pageSearchData = [];
            ViewerManager.checkFirstInit = false;
			      ViewerManager.pixeWidth = false;
            if (!ViewerManager.pageMODE) ViewerManager.pageMODE = "DOUBLE";
            if ((window.innerWidth / window.innerHeight) < (4 / 3)) {ViewerManager.pageMODE = "SINGLE"; $("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png");}

            if (ViewerManager.Settings.useComment == 'true') {
                // 코멘트 게시판 넣기
                /*var commentDiv = document.getElementById('commentBoard');
                if (commentDiv != null) {
                    commentDiv.innerHTML = '
                    <div id="commentBoard_top">
                        <ul id="comment_menu">
                            <li id="comment_title">리뷰</li>
                            <li id="comment_close">닫기</li>
                            <li id="comment_write">글쓰기</li>
                        </ul>
                    </div>
                    <div id="commentBoard_content"></div>';
                }*/

                var commentContentDiv = document.getElementById('commentBoard_content');
                if (commentContentDiv != null) {
                    commentContentDiv.innerHTML = '<iframe src="http://titanbooks.co.kr/App/comment/comment.php?book_num=' + ViewerManager.GetData.EPUB.ID + '" style="position:absolute; width:100%; height:100%; z-index:20;"></iframe>';
                }

                var getTime;
                if (window.localStorage.getItem('comment_' + ViewerManager.GetData.EPUB.ID) != null) {
                    // 저장된 시간이 있다면
                    getTime = window.localStorage.getItem('comment_' + ViewerManager.GetData.EPUB.ID);

                    $.ajax({
                        url : API.commentNEW() + '?book_num=' + ViewerManager.GetData.EPUB.ID + '&date=' + getTime,
                        error : function (jqXHR, textStatus, errorThrown) {

                        },
                        success : function (data) {
                            var getXml = $.xml2json(data);
                            var newCount = parseInt(getXml.NEW_CNT);
                            if (newCount > 0) {
                                document.getElementById('comment_btn').style.background = 'url("./images/titan_topMenu/topMenu_comment_new.png") no-repeat';
                            }
                        }
                    });
                }

                /*var thisDate;
                ViewerManager.commentTimer = setTimeout(function () {

                }, 5000);*/
            }

            page.initPageHTMLData();

            log("@ ViewerManager.userInfo.subjSeq : " + ViewerManager.userInfo.subjSeq);

            // 진도율이 필요한 경우 이 시점에서 체크
            ViewerManager.lastPage = 1; // 마지막으로 보던 페이지 설정

            ViewerManager.PAGE_CURRENT_NUMBER = (ViewerManager.urlPage) ? ViewerManager.urlPage : ViewerManager.lastPage;
            ViewerManager.bookContainerWidth = $(window).width();
            ViewerManager.bookContainerHeight = $(window).height();
            if (ViewerManager.bookContainerHeight == 0) {ViewerManager.bookContainerHeight = $(document).height();}
            log("@ ViewerManager BookContainer size");
            log("@ " + ViewerManager.bookContainerWidth + " / " + ViewerManager.bookContainerHeight);

            //0 : 순차 모드  (순차 모드에서는 페이지 이동 불가),    1 : 비순차 모드
            if (ViewerManager.progressType === "1") page.initProgressCompletePage();

            // ViewerManager.pageLoading 함수 이름 변경 금지 (ePub 컨텐츠에서 호출하고 있음)
            ViewerManager.pageLoading = function(currentPageNumber, totalPageNumber, stat) {
                // 현 페이지안의 사운드 끄기

                if (ViewerManager.iframePlay) clearTimeout(ViewerManager.iframePlay);

                CONTROL.loadStart();

                if (ViewerManager.Settings.uiHold == "1") {
                    ViewerManager.UInormal('show');
                }

                if (parseInt(currentPageNumber) != parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) { ViewerManager.PAGE_CURRENT_NUMBER = currentPageNumber; }

                if (ViewerManager.pageMODE == "DOUBLE") {
                    if (parseInt(currentPageNumber)%2 == 0) {
                        currentPageNumber = (parseInt(currentPageNumber) + 1);
                        ViewerManager.PAGE_CURRENT_NUMBER = currentPageNumber;
                    }
                }

                if (ViewerManager.GetData.PROGRESS.progressRate == "true") {
                    // 진도율 체크
                    // 해당 유저의 정보 넘겨줄 부분 체크
                    if (ViewerManager.GetData.PROGRESS.progressRateType == "Order" && ViewerManager.prevPageNumber != parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) {
                        // 순차진도
                        var thisPage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
                        ViewerManager.GetData.PROGRESS.progressRateArray[thisPage] = "Y";

                        var pageTerm = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - ViewerManager.prevPageNumber;
                        var pageReturn = ViewerManager.pageMODE == "SINGLE" ? 1 : 2;
                        //console.log(pageTerm, pageReturn, pageTerm > pageReturn)
                        if (pageTerm > pageReturn) {
                            alert("잘못된 이동입니다.");

                            ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.prevPageNumber;
                            ViewerManager.sliderValue = ViewerManager.prevPageNumber;
                            if (stat == 'slider') {
                                // 슬라이더 초기화
                                $("#slider-range").slider({
                                    range: "min",
                                    value: ViewerManager.PAGE_CURRENT_NUMBER,
                                    min: 1,
                                    max: ViewerManager.PAGE_TOTAL_NUMBER
                                });
                                //page.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                            }

                            return;
                        }
                        // 이전 페이지 넘버 저장
                        ViewerManager.prevPageNumber = parseInt(ViewerManager.PAGE_CURRENT_NUMBER);

                        // 최종으로 지금 페이지 번호 넘겨줌
                        // ViewerManager.PAGE_CURRENT_NUMBER;
                        setData();
                    } else if (ViewerManager.GetData.PROGRESS.progressRateType == "OutOfOrder") {
                        // 비순차진도
                        var thisPage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
                        ViewerManager.GetData.PROGRESS.progressRateArray[thisPage] = "Y";
                        if (ViewerManager.pageMODE == "DOUBLE" && parseInt(ViewerManager.PAGE_CURRENT_NUMBER) > 1) {
                            ViewerManager.GetData.PROGRESS.progressRateArray[thisPage - 1] = "Y";
                        }
                        //console.log("Array", ViewerManager.GetData.PROGRESS.progressRateArray);
                        // 텍스트로 변환
                        var returnPage = "";
                        for (var i = 0; i < ViewerManager.GetData.PROGRESS.progressRateArray.length; i++) {
                            returnPage = returnPage + ViewerManager.GetData.PROGRESS.progressRateArray[i];
                        }
                        //console.log("Text", returnPage);

                        // 최종으로 배열 또는 텍스트를 넘겨줌
                        // ViewerManager.GetData.PROGRESS.progressRateArray or returnPage;
                        //setData(ViewerManager.GetData.PROGRESS.progressRateArray);
                        setData(returnPage);
                    }
                }

                // 줌 초기화
                zoom.clearZoom();
                if (ViewerManager.zoomScore != 1) {
                    ViewerManager.zoomScore = 1;
                    zoom.zoomViewportCenterAlign();
                }
                // 미리보기 페이지 체크 통일(page, thumnail, index, jquery.slider,)
                //log('get page >> currentPageNumber : ' + currentPageNumber + ' totalPageNumber : ' + totalPageNumber + ' stat : ' + stat);
                if (parseInt(ViewerManager.Params.purchase) == 0 && parseInt(ViewerManager.Params.prePageNo) != 0 && parseInt(ViewerManager.Params.prePageNo) < parseInt(currentPageNumber)) {
                    // 현재 페이지 기존 페이지로 수정
                    ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1];
                    // 슬라이드 값도 기존 페이지로 수정
                    ViewerManager.sliderValue = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1];

                    // 얼랏창 띄워주기
                    alert("미리보기가 제공되지 않는 페이지 입니다.");

                    // page, thumnail, slider, page, indexList >> 페이지로 연결시킴
                    if (stat == 'slider') {
                        // 슬라이더 초기화
                        $("#slider-range").slider({
                            range: "min",
                            value: ViewerManager.PAGE_CURRENT_NUMBER,
                            min: 1,
                            max: ViewerManager.PAGE_TOTAL_NUMBER
                        });
                        //page.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                    }

                    return;
                }

                if (ViewerManager.progressType === "0" && ViewerManager.progressComplete === "N" && ViewerManager.lastPage < currentPageNumber) {
                    $("#currentModeNotice").text(ViewerManager.Local.indexListLinkAlert).fadeIn(300, function() {
                        var noticeTimer = setTimeout(function() {
                            $("#currentModeNotice").fadeOut(500);
                            $("#slider-range").slider({
                                value: ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1]
                            });
                            ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1];
                            ViewerManager.sliderValue = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1];
                            clearTimeout(noticeTimer);
                        }, 1000);
                    });
                } else {
                    switch (ViewerManager.pageMODE) {
                        case "SINGLE":
                            ViewerManager.PAGE_CURRENT_NUMBER = parseInt(currentPageNumber) === 1 ? parseInt(currentPageNumber) : parseInt(currentPageNumber) - 1;
                            break;
                        case "DOUBLE":
                            if (parseInt(currentPageNumber) === 1) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(currentPageNumber);
                            else ViewerManager.PAGE_CURRENT_NUMBER = parseInt(currentPageNumber) + 1;

                            if (ViewerManager.isOddCheck(currentPageNumber)) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(currentPageNumber) - 1;
                            break;
                    }

                    if (!String(location.href).match('.html'))
                    {
                        CONTROL.refreshAD();
                    }

                    page.pageLoading(currentPageNumber, totalPageNumber);
                }
            };

            ViewerManager.pageResizing = function (){
                //page.pageResizing();
                CONTROL.resize();
            }

            // 유저인터페이스중 드랍다운 메뉴를 숨겨줌
            ViewerManager.indexList_click = function(stat) {
                userInterface.indexList_click(stat);
            };
			ViewerManager.dbclick_zoom = function(stat) {
                userInterface.dbclick_zoom(stat);
            };

            // 페이지 넘기는 이벤트 작성
            var swipeArray = new Array();
            var touch = "ontouchend" in document;
            var startEvent = (touch) ? 'touchstart' : 'mousedown';
            var moveEvent = (touch) ? 'touchmove' : 'mousemove';
            var endEvent = (touch) ? 'touchend' : 'mouseup';
            var startTarget;
            var endTarget;

            var startX = 0;
            var moveX = 0;
            var endX = 0;
            var checkX = 0;

            var moveTerm = 50;

            ViewerManager.swipeReg = function(target, stat) {
                //if (!(browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) || ViewerManager.CustomizeType == 'SSG') {
                //if (!(browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet)) {
                    $('#swipe').remove();
                    return;
                //}

                swipeArray = new Array();
                swipeArray.push($(document));

                if (stat == true) {
                    swipeArray.push(target);
                    target
                    .bind(startEvent, startFunc).bind(moveEvent, function(e) {
                        e.preventDefault();
                    })
                    .unbind(moveEvent);
                } else {
                    target
                    .unbind(startEvent)
                    .unbind(moveEvent);
                }
            },
            ViewerManager.swipeStatus = function(stat) {
                if (stat == 'on') {
                    $('#swipe').css('display', 'block');
                } else {
                    $('#swipe').css('display', 'none');
                }
            }

            //ViewerManager.swipeReg($('#swipe'), true);
            //ViewerManager.swipeReg($('body'), true);
            var index_target = document.getElementById('');
            var thumb_target = document.getElementById('thumb_container');
            $(window).on('touchmove', function (e){
                //console.log(e.target, thumb_target);
                if (thumb_target.style.display != 'block' && index_target.style.display != 'block') {
                    e.preventDefault();
                }
            });

            var same_target;
            var clear_sametarget, check_settime;

            function startFunc(e) {
                //e.preventDefault();

                var sw_target = e.target;

                startX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].pageX : e.pageX;
                checkX = 0;
                //console.log('start', sw_target, e.target, startX);

                $(sw_target).bind(moveEvent, function(e) {
                    e.preventDefault();

                    /*endX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].pageX : e.pageX;

                    if (Math.abs(startX - endX) > moveTerm) {
                        checkSwipe(startX, endX);
                        //$(sw_target).unbind(moveEvent);
                    }*/
                });
                $(sw_target).bind(endEvent, function (e) {
                    endX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].pageX : e.pageX;
                    //console.log('end', sw_target, e.target, endX);
                    if (Math.abs(startX - endX) > moveTerm) {
                        checkSwipe(startX, endX);
                    }
                });
                check_settime = setTimeout(function() {
                    checkX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].pageX : e.pageX;

                    if (checkX == startX) {
                        $(sw_target).unbind(startEvent).unbind(moveEvent).unbind(endEvent);
                        //$(sw_target).css('display','none');
                        var blur_target;
                        if (ViewerManager.pageMODE == "SINGLE") {
                            blur_target = $('#leftPageFrame').contents().find('body');
                            $(blur_target).blur();
                        } else if (ViewerManager.pageMODE == "DOUBLE") {
                            if (checkX <= window.innerWidth / 2) {
                                blur_target = $('#leftPageFrame').contents().find('body');
                            }
                            else {
                                blur_target = $('#rightPageFrame').contents().find('body');
                            }
                            $(blur_target).blur();
                        }
                        $(blur_target).bind(endEvent, function(e) {
                            //$('#swipe').css('display', 'block');
                            //$('#swipe').bind(startEvent, startFunc);
                            $(sw_target).bind(startEvent, startFunc);
                        });
                    }
                }, 300);
            }

            function checkSwipe(start, end) {
                clearTimeout(check_settime);
                var moveCall = start - end;

                if (moveCall < 0) {
                    //console.log("left >> right", ViewerManager.PAGE_CURRENT_NUMBER);
                    if (ViewerManager.PAGE_CURRENT_NUMBER == 1) {return;}
                    page.previousPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                } else if (moveCall > 0) {
                    //console.log("right >> left", ViewerManager.PAGE_CURRENT_NUMBER);
                    if (ViewerManager.PAGE_CURRENT_NUMBER == ViewerManager.PAGE_TOTAL_NUMBER) {return;}
                    page.nextPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                }
            }

            // resize start
            var resizingTimer,orientation1,orientation2;
            if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
                $(window).on("orientationchange", function(event) {
                     window.location.reload();
                     /*
                     resizingTimer = setTimeout(function() {
                          var w_width = window.innerWidth;
                          $('body').css('width', w_width + 'px');
                          log("@page resizing!!!");
                          ViewerManager.pageResizing();
                        }, 50);
                        */
                });

            } else {
                $(window).on('resize', function() {
                    var w_width = window.innerWidth;
                    $('body').css('width', w_width + 'px');
                    //$('#td_palette').css('width', w_width - $('#drawSelectOption').width());
                    clearTimeout(resizingTimer);
                        resizingTimer = setTimeout(function() {
                            log("@page resizing!!!");
                            ViewerManager.pageResizing();
                        }, 100);
                   });
            }

            log('@ sliderValue : ' + ViewerManager.sliderValue);
            log('@ PAGE_TOTAL_NUMBER : ' + ViewerManager.PAGE_TOTAL_NUMBER);
            log('@ PAGE_CURRENT_NUMBER : ' + ViewerManager.PAGE_CURRENT_NUMBER);
            log('@ PAGE_OPS_NAME : ' + ViewerManager.PAGE_OPS_NAME);

            //titan 사이트로 부터 생성된 뷰어이며 , 확장가가 .html 이 아닌 경우 (html 이라면 독립 뷰어 혹은 개발 섭 뷰어임)  광고 프레임임을 노출
            /*
            if (String(location.href).match('titanbooks.co.kr') && !String(location.href).match('.html'))
            {
                $('#img-adclose-left') .css('display', 'inline-block') .on('click', function (e){
                    $('#div-ad-left').remove();
                });
                $('#img-adclose-right') .css('display', 'inline-block') .on('click', function (e){
                    $('#div-ad-right').remove();
                });
            }
            else
            {
                $('#div-ad-left').remove();
                $('#div-ad-right').remove();
            }
            */

            $('body').css('width', window.innerWidth + 'px');
            $('body').on('focusin', 'input, textarea', function(event) {
              if(navigator.userAgent.indexOf('Android') > -1){
                var scroll = $(this).offset();
                    window.scrollTo(0, scroll);
                }
            });

            $(document).ready(function (){
                $('div.ui-loader').remove();
                function callWorker() {
					co
                    // 페이지 데이터 프리로드 테스트 >> 워커에 들어가는 데이터는 정적이면서 순환하지 않아야하나?
                    // data clone 에러가 발생하지 않도록 데이터를 clone 해서 넘겨 주던가, 문자열로 변환해서 넘겨줌
                    // safari 에서 JSON.stringify cannot serialize cyclic structures 에러 발생 >> 원인 분석이 필요함
                    if (!(browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.safari)) {
                        if (window['Worker']) {
                            var w = new Worker('js/MODEL/data/preload.min.js');
                            //w.postMessage(ViewerManager);
                            w.postMessage(JSON.stringify(ViewerManager));
                            w.onmessage = function(e) {
                                switch (typeof(e.data)) {
                                    case "string" : {
                                        console.log(e.data);
                                        break;
                                    }
                                    case "object" : {
                                        ViewerManager.pageHTMLData = e.data;
                                        w.terminate();
                                        w = null;
                                        break;
                                    }
                                }
                            };
                        }
                    } else {
						cosole.log( "mobile");
					}
                }

                CONTROL.init();
                //adjust page number  by startPageIndex and parameter 'page'
               if (ViewerManager.urlPage == "0" || !ViewerManager.urlPage  || ViewerManager.urlPage == 'undefined') ViewerManager.urlPage = ViewerManager.GetData.EPUB.startPageIndex;
                ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.transVirtualToRealPageIndex(parseInt(ViewerManager.urlPage));
                if ((ViewerManager.PAGE_CURRENT_NUMBER < 1)  ||  (ViewerManager.PAGE_CURRENT_NUMBER > ViewerManager.PAGE_TOTAL_NUMBER)) {
                    var startPage = ViewerManager.transRealToVirtualPageIndex(1);
                    var endPage = ViewerManager.transRealToVirtualPageIndex(ViewerManager.PAGE_TOTAL_NUMBER);
                    alert("wrong page index ("  + startPage  + " ~ " + endPage + " )");
                    window.close();
                    return;
                }

                ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;

                // 페이지를 부르기 전에 싱크 데이터 생성
                if (ViewerManager.GetData.USE.sync == "true" && ViewerManager.userInfo.loginKey.length > 0) {
                    sync_data('down');
                    // 데이터가 로드되는 시간을 만들어주자
                    setTimeout(function () {
                        callWorker();
                        ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                    }, 1500);
                } else {
                    // 데이터가 로드되는 시간을 만들어주자 >> 싱크할 때 보단 적음
                    setTimeout(function () {
                        callWorker();
                        ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
                    }, 1000);
                }
            })

            //ViewerManager.pageLoading((ViewerManager.urlPage) ? ViewerManager.urlPage : ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
        }
    };
}

function change_require(stat) {

	if (stat == 'index') {
        require(index_type.load_value, index_type.load_func);
    } else if (stat == 'image') {
        require(image_type.load_value, image_type.load_func);
    } else if (stat == 'main') {
        ViewerManager.showType = "normal";
        require(main_type.load_value, main_type.load_func);
    }
}
change_require('index');
