			var isZoomIn = false;
			var isMiniLoad = true; // 최소 로드. exe에서 계속 클릭시에 죽는다.
			var mBaseDist;
			var mBaseRatio;
			var initialRatio = 1;
			var STEP = 170;
			var mRatio = initialRatio;

			var touchDragStartX;
			var touchDragStartY;
			var touchDragStart = false;

			var contentX = 0;
			var contentY = 0;

			var isContentInfoInit = false;
			var isWindowSizeInit = false;
			var windowWidth;
			var windowHeight;
			var contentDivWidth;
			var contentDivHeight;

			var origin;

			$(document).ready(function(event) {
				contentX  = $('#content').offset().left;
				contentY  = $('#content').offset().top;
				//alert($(window).width() + " : " + $(window).height());
				$('.page_action_container').css({'background-color':'rgba(0,0,0,0)'});
			});

			$(document).on("pagecreate", function() {
				$(window).on("orientationchange", function() {
                    /*$('body').css('width', window.innerWidth + 'px');
                    clearTimeout(resizingTimer);
                    resizingTimer = setTimeout(function() {
                        log("@page resizing!!!");
                        ViewerManager.pageResizing();
                    }, 100);*/
                });

				$('.page_action_container').css('background-color', 'rgba(0,0,0,0)');
				$('.page_action_container').on('swipeleft', function(event) {
					if (isZoomIn == false) $('#btnSlideRight').trigger('click');
				});
				$('.page_action_container').on('swiperight', function(event) {
					if (isZoomIn == false) $('#btnSlideLeft').trigger('click');
				});

				var getMultiTouchDistance = function(event){
					var dx = parseInt(event.originalEvent.touches[0].screenX - event.originalEvent.touches[1].screenX);
					var dy = parseInt(event.originalEvent.touches[0].screenY - event.originalEvent.touches[1].screenY);
					return Math.sqrt(dx * dx + dy * dy);
				};

				var addPageSwipeActioniListener = function(){
					//$('.page_action_container').show();
					$('.page_action_container').on('swipeleft');
					$('.page_action_container').on('swiperight');
				};

				var removePageSwipeActionListener = function(){
					//$('.page_action_container').hide();
					$('.page_action_container').off('swipeleft');
					$('.page_action_container').off('swiperight');
				};

				var getOffsetCenterPosition = function(event){
					var dx = parseInt(event.originalEvent.touches[0].screenX - event.originalEvent.touches[1].screenX);
					var dy = parseInt(event.originalEvent.touches[0].screenY - event.originalEvent.touches[1].screenY);
					var offsetCenterX = dx < 0 ? event.originalEvent.touches[0].screenX + (Math.abs(dx) / 2) : event.originalEvent.touches[1].screenX + (dx / 2);
					var offsetCenterY = dy < 0 ? event.originalEvent.touches[0].screenY + (Math.abs(dy) / 2) : event.originalEvent.touches[1].screenY + (dy / 2);
					return {x : offsetCenterX  , y : offsetCenterY };
				};

				var convertPosition = function(position) {
					var offsetX = $('#content').offset().left;
					var offsetY = $('#content').offset().top;
					return {x : parseInt((position.x / mRatio) + ( Math.abs(offsetX) / mRatio))  , y : parseInt((position.y / mRatio) + ( Math.abs(offsetY) / mRatio))};
				}

				$('.page_action_container').on("touchstart touchmove touchend", function(e){
					if (!isContentInfoInit) {
						contentDivWidth = $('#content').innerWidth();
						contentDivHeight = $('#content').innerHeight();
						isContentInfoInit = true;
					}

					if (!isWindowSizeInit){
						windowWidth = $(window).innerWidth();
						windowHeight= $(window).innerHeight();
						isWindowSizeInit = true;
					}

					var orig = e.originalEvent;
					var action = e.type;
					//multi touch
					if (orig.touches.length == 2){
						if (action == 'touchstart'){
							e.stopPropagation();
							e.preventDefault();
							mBaseDist = getMultiTouchDistance(e);
							mBaseRatio = mRatio;
							var position = convertPosition(getOffsetCenterPosition(e));
							origin = position.x + "px "+ position.y + "px";


						}else if (action == 'touchmove'){
							e.preventDefault();
							e.stopPropagation();

							var delta = (getMultiTouchDistance(e) - mBaseDist) / STEP;
							var multi = parseFloat(Math.pow(2, delta));

					 		var tempRatio = Math.min(1024.0, Math.max(0.1, mBaseRatio * multi));
					 		if (tempRatio <= initialRatio) {mRatio = initialRatio;}
					 		else {mRatio = tempRatio;}

							if (mRatio <= initialRatio) {isZoomIn = false;
							}else {isZoomIn = true;}

							$('#content').css({'-moz-transform-origin': origin,'transform-origin': origin,'-ms-transform-origin': origin,'-webkit-transform-origin': origin});
                			$('#content').css({transform: 'scale(' + mRatio + ',' + mRatio + ' )'});
							//alert('[width-height] ' + $('#content').width()  + " : " + $('#content').height() + " [offset] : " + $('#content').offset().left + " : " + $('#content').offset().top + " [css] " + $('#content').css('left') + " : " + $('#content').css('top'));
					       	//$(this).css("width", parseFloat(width) * orig.scale);
					        //$(this).css("height", parseFloat(height) * orig.scale);
					        //$(this).css("-webkit-transform","rotate(" + ((parseFloat(rotation) + orig.rotation) % 360) + "deg)");

					        //드래그 발생시마다 컨텐트 페이지의 오프셋을 저장

						}else if (action =='touchend'){
							//alert("2 touchend : " + $('#content').offset().left + " : " + $('#content').offset().top);
						}
					//one touch action
					}else  {
						if (action =='touchstart' ){
							if (isZoomIn == true && touchDragStart == false){
								e.stopPropagation();
								e.preventDefault();
								touchDragStart = true;
								touchDragStartX = orig.touches[0].screenX;
								touchDragStartY = orig.touches[0].screenY;
							}
						}else if (action == 'touchmove'){
							if (isZoomIn == true && touchDragStart == true){

								var moveX = orig.touches[0].screenX;
								var moveY = orig.touches[0].screenY;

								var deltaX = moveX - touchDragStartX;
								var deltaY = moveY - touchDragStartY;

                				var contentXTmp = $('#content').offset().left + deltaX;
                				var contentYTmp = $('#content').offset().top + deltaY;

                				var contentOffsetRight =  $('#content').offset().left +contentDivWidth ;
                				var contentOffsetBottom = $('#content').offset().top+ contentDivHeight;

                				if (deltaX > 0) {
                					if (contentXTmp < 0) $('#content').offset({left : contentXTmp})
                				}else if (deltaX < 0) {
                					if (Math.abs(contentXTmp) <= (contentDivWidth * mRatio) - ((contentDivWidth * mRatio) / mRatio)){
    									$('#content').offset({left : contentXTmp});
                					}
                				}

                				if (deltaY > 0) {
                					if (contentYTmp < 0) $('#content').offset({top : contentYTmp})
                				}else if (deltaY < 0){
                					if (Math.abs(contentYTmp) <= (contentDivHeight * mRatio) - ((contentDivHeight * mRatio) / mRatio) ){
    									$('#content').offset({top : contentYTmp});
                					}
                				}
                				//$('#content').offset({top:contentY, left : contentX})
                				touchDragStartX = moveX;
								touchDragStartY = moveY;
							}
						}else if (action == "touchend"){
							if (isZoomIn == true && touchDragStart == true){
								e.stopPropagation();
								touchDragStart = false;
								//alert("[offset] : " + $('#content').offset().left + " : " + $('#content').offset().top + " [css] " + $('#content').css('left') + " : " + $('#content').css('top'));
							}
						}
					}
				});
			});
