define(['log'], function (log) {
	'use strict';

	log("@ import browser.js");

	var userAgent = navigator.userAgent.toLowerCase(),
		Browser = {
			ie: userAgent.indexOf('msie') != -1,
			ie6: userAgent.indexOf('msie 6') != -1,
			ie7: userAgent.indexOf('msie 7') != -1,
			ie8: userAgent.indexOf('msie 8') != -1,
			ie9: userAgent.indexOf('msie 9') != -1,
			ie10: userAgent.indexOf('msie 10') != -1,
			ie11: userAgent.indexOf('trident/7.0') != -1,
			edge: userAgent.indexOf('edge') != -1,
			opera: !!window.opera,
			safari: userAgent.indexOf('safari') != -1,
			safari3: userAgent.indexOf('applewebkir/5') != -1,
			mac: userAgent.indexOf('mac') != -1,
			chrome: userAgent.indexOf('chrome') != -1,
			firefox: userAgent.indexOf('firefox') != -1,
			pc : '',
			isMobile : {
				iPhone : (/iPhone/i).test(userAgent),
				iPod : (/iPod/i).test(userAgent),
				iPad : (/iPad/i).test(userAgent),
				androidPhone : (/(?=.*\bAndroid\b)(?=.*\bMobile\b)/i).test(userAgent),
				androidTablet : (/Android/i).test(userAgent)
			},
			windowOS : 7
		};

	function getIEcheckOS()
	{
		var Trident = userAgent.match(/trident\/(\d)/i);

		if (Trident != null)
		{
			switch (String(Trident[1]))
			{
				case '4':
				{
					Browser.ie6 = Browser.ie7 = false;
					Browser.ie8 = true;
					break;
				}
				case '5':
				{
					Browser.ie6 = Browser.ie7 = Browser.ie8 = false;
					Browser.ie9 = true;
					break;
				}
				case '6':
				{
					aBrowser.ie6 = Browser.ie7 = Browser.ie8 = Browser.ie9 = false;
					Browser.ie10 = true;
					break;
				}
				default:
				{
					break;
				}
			}
		}
		else
		{

		}

		alert("change : " + Browser.ie8 + " : " + Browser.ie9 + " : " + Browser.ie10);
	}
	//getIEcheckOS();

	function getWindowOS()
	{
		var startWindow = userAgent.indexOf('windows nt');
		var windows_text = userAgent.substr(startWindow + 10, 5);

		if (windows_text.indexOf('10') != -1)
		{
			Browser.windowOS = 10;
		}
		else if (windows_text.indexOf('8') != -1)
		{
			Browser.windowOS = 8;
		}
	}
	getWindowOS();

	function onlyPC() {
		if ((/iPhone/i).test(userAgent) == false && (/iPod/i).test(userAgent) == false && (/iPad/i).test(userAgent) == false && (/(?=.*\bAndroid\b)(?=.*\bMobile\b)/i).test(userAgent) == false && (/Android/i).test(userAgent) == false) {
			Browser.pc = 'PC';
		}
	}
	onlyPC();

	log("@ userAgent : " + userAgent);

	CONTROL.browser = Browser;

	return Browser;
});
