define(["jquery", "log", "browser", "xml2json", "params"], function(c, b, a, e, d) {
    b("\n @ import epub.js ... \n");
    if (d.Params.paramIns == "none") {
        d.paramsInit()
    }
    if ((a.isMobile.androidPhone || a.isMobile.androidTablet || a.isMobile.iPhone || a.isMobile.iPod || a.isMobile.iPad) && ViewerManager.WebApp == false) {
        return
    }
    b("@ ViewerManager.Path.cntsFilePath= " + ViewerManager.Path.cntsFilePath);
    var f = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath;
    ViewerManager.ePub.container_xml2json_data_Array = [];
    ViewerManager.ePub.opf_xml2json_data_Array = [];
    ViewerManager.ePub.opf_xml2json_total_len = [];
    ViewerManager.ePub.ops_name = [];
    ViewerManager.thumbnails = [];
    c.ajax({
        url: (f + "META-INF/container.xml"),
        dataType: "xml",
        async: false,
        success: function(g) {
            var h = c.xml2json(g);
            b("@ " + h.rootfiles["rootfile"]["full_path"]);
            ViewerManager.ePub.container_xml2json_data_Array.push(h.rootfiles["rootfile"]["full_path"])
        },
        error: function(i, g, h) {
            b("@ container_xml2json error : " + h);
            ViewerManager.openError = true;
            c("body").html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>container.xml file not found!</p><p style='font-size: 25px;'>check the ePub content root path.</p></span><br><p>" + (f + "META-INF/container.xml") + "</p></div>")
        },
        complete: function() {
            b("@ META-INF/container.xml complete");
            if (ViewerManager.openError == true) {
                return
            }
            ViewerManager.ePub.ops_name = ViewerManager.ePub.container_xml2json_data_Array[0].split("/");
            b("@ toc.xhtml path : " + f + ViewerManager.ePub.ops_name[0] + "/toc.xhtml");
            c.ajax({
                url: (f + ViewerManager.ePub.ops_name[0] + "/toc.xhtml"),
                dataType: "xml",
                async: false,
                success: function(g) {
                    ViewerManager.ePub.toc = g
                },
                error: function(i, g, h) {
                    b("@ OEBPS/toc.xhtml error : " + h);
                    c("#pages").empty().append("<div style='width : " + ViewerManager.bookContainerWidth + "px; text-align: center;' ><br><br><br><br><br><span style='font-size: 50px; color:#333333;'><p>" + h + "</p><p style='font-size: 25px;'>check the toc.xhtml file.</p></span></div>")
                },
                complete: function() {
                    b("@ OEBPS/toc.xhtml complete")
                }
            });
			
            c.ajax({
                url: (f + ViewerManager.ePub.container_xml2json_data_Array),
                dataType: "xml",
                async: false,
                success: function(k) {
                    var h = c.xml2json(k);
					
					var idefID = "";
					for(idf = 9; idf < h.metadata.identifier.length; idf++) {
						idefID += h.metadata.identifier[idf];
					}
					$("#BOOK_ID").attr("value",idefID);
					ViewerManager.GetData.EPUB.ID = idefID;
					
                    ViewerManager.ePub.opf_xml2json_total_len = h.spine.itemref.length;
                    var l = h.manifest.item.length;
                    if (h.metadata.use_image) {
                        ViewerManager.imageUse = "true";
                        ViewerManager.imageFile = h.metadata.use_image
                    }
                    if (h.metadata.pagewidth) {
                        ViewerManager.iframeContentsWidth = h.metadata.pagewidth
                    }
                    if (h.metadata.pageheight) {
                        ViewerManager.iframeContentsWidth = h.metadata.pagewidth
                    }
                    ViewerManager.GetData.EPUB.startPageIndex = parseInt(h.metadata.startpage_index ? h.metadata.startpage_index : 1);
                    ViewerManager.Local.cntsTitle = h.metadata.title;
                    if (ViewerManager.GetData.EPUB.TITLE.length > 0) {
                        ViewerManager.Local.cntsTitle = ViewerManager.GetData.EPUB.TITLE
                    }
                    if (ViewerManager.GetData.EPUB.absTitle.length > 0) {
                        ViewerManager.Local.cntsTitle = ViewerManager.GetData.EPUB.absTitle
                    }
                    ViewerManager.Local.eBookType = h.metadata.ebooktype;
                    if (ViewerManager.ePub.opf_xml2json_total_len === undefined) {
                        b("@ undefined process");
                        ViewerManager.ePub.opf_xml2json_total_len = 1;
                        for (var n = 0; n <= l - 1; n++) {
                            if (h.spine.itemref.idref === h.manifest.item[n].id) {
                                b("@ 1 " + h.manifest.item[n].id + "=" + h.manifest.item[n].href);
                                ViewerManager.ePub.opf_xml2json_data_Array.push(h.manifest.item[n].href)
                            }
                        }
                    } else {
                        for (var o = 0; o <= ViewerManager.ePub.opf_xml2json_total_len - 1; o++) {
                            for (var n = 0; n <= l - 1; n++) {
                                if (h.spine.itemref[o].idref === h.manifest.item[n].id) {
                                    b("@ 2 " + h.manifest.item[o].id + "=" + h.manifest.item[n].href);
                                    ViewerManager.ePub.opf_xml2json_data_Array.push(h.manifest.item[n].href)
                                }
                            }
                        }
                    }
                    for (var j = 0; j < ViewerManager.ePub.opf_xml2json_data_Array.length; j++) {
                        var q = m(ViewerManager.ePub.opf_xml2json_data_Array[j].split("/")[1].split(".")[0]);
                        ViewerManager.thumbnails.push(q)
                    }

                    function m(i) {
                        var r = "";
                        for (var p = 0; p < h.manifest.item.length; p++) {
                            if (h.manifest.item[p].href.indexOf("thumbnail") == -1) {
                                continue
                            } else {
                                if (h.manifest.item[p].href.indexOf(String(i)) == -1) {
                                    continue
                                } else {
                                    r = h.manifest.item[p].href;
                                    break
                                }
                            }
                        }
                        return r
                    }
                    if (ViewerManager.GetData.PROGRESS.progressRateType == "OutOfOrder") {
                        for (var g = 0; g < parseInt(ViewerManager.ePub.opf_xml2json_total_len); g++) {
                            ViewerManager.GetData.PROGRESS.progressRateArray[g] = "N";
                            if (ViewerManager.GetData.PROGRESS.progressRateData.substr(g, 1) == "Y") {
                                ViewerManager.GetData.PROGRESS.progressRateArray[g] = "Y"
                            }
                        }
                    } else {
                        if (ViewerManager.GetData.PROGRESS.progressRateType == "Order") {
                            for (var g = 0; g < parseInt(ViewerManager.ePub.opf_xml2json_total_len); g++) {
                                ViewerManager.GetData.PROGRESS.progressRateArray[g] = "N";
                                if (g <= parseInt(ViewerManager.urlPage) - 1) {
                                    ViewerManager.GetData.PROGRESS.progressRateArray[g] = "Y"
                                }
                            }
                        }
                    }
                },
                error: function(i, g, h) {
                    b("@ opf_xml2json error : " + h);
                    c("#pages").empty().append("<div style='width : " + ViewerManager.bookContainerWidth + "px; text-align: center;' ><br><br><br><br><br><span style='font-size: 50px; color:#333333;'><p>" + h + "</p><p style='font-size: 25px;'>check the opf file path.</p></span></div>")
                },
                complete: function() {
                    ViewerManager.ePub.opf_xml2json_total_len = ViewerManager.ePub.opf_xml2json_total_len;
                    ViewerManager.ePub.opf_xml2json_data_Array = ViewerManager.ePub.opf_xml2json_data_Array;
                    b("@ ViewerManager.ePub.opf_xml2json_total_len : " + ViewerManager.ePub.opf_xml2json_total_len);
                    b("@ ViewerManager.ePub.opf_xml2json_data_Array : " + ViewerManager.ePub.opf_xml2json_data_Array);
                    if (a.ie8) {
                        return
                    }
                    c.ajax({
                        url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/" + ViewerManager.ePub.opf_xml2json_data_Array[0],
                        dataType: "html",
                        async: false,
                        success: function(k) {
                            var j = c.xml2json(k);
                            for (var h = 0; h < j.head["meta"].length; h++) {
                                if (j.head["meta"][h]["name"] && j.head["meta"][h]["name"] == "viewport") {
                                    var g = j.head["meta"][h]["content"].split(",");
                                    if (g[0].indexOf("width") != -1) {
                                        ViewerManager.iframeContentsWidth = g[0].split("=")[1];
                                        ViewerManager.iframeContentsHeight = g[1].split("=")[1]
                                    } else {
                                        if (g[0].indexOf("height") != -1) {
                                            ViewerManager.iframeContentsWidth = g[1].split("=")[1];
                                            ViewerManager.iframeContentsHeight = g[0].split("=")[1]
                                        }
                                    }
                                }
                            }
                        }
                    })
                }
            })
        }
    })
});