define(['jquery', 'log', 'page' ], function ($, log, page) {
	//'use strict';
	log("\n @ import keyboard.js ... \n");
	
	var kc_LeafLeft=39;var kc_LeafRight=37;var kc_ScrollBottom=38;var kc_ScrollTop=40;var kc_ScrollLeftTop=36;var kc_ScrollRightTop=33;var kc_ScrollRightBottom=35;var kc_ScrollLeftBottom=34;
	var kc_ScrollLeft=39;var kc_ScrollRight=37;var kc_EnLarge=107;var kc_Shrink=109;var kc_Refresh=116;var kc_PrintLeft=120;var kc_PrintRight=121;var kc_Maxmize=122;
	var kc_Restore=122;var kc_Minimize=123;var kc_BackSpace=8;var kc_Enter=13;var kc_view=93;var kc_tab = 9;var kc_esc = 27;
	

	initKeyboardEvent = function() {
		$(document).keydown( function(event) {
			keyboardExec( event.keyCode );
		});

		$('#leftPageFrame').load(function() {
			$( $('#leftPageFrame')[0].contentWindow.document ).keydown(function(event) {
				keyboardExec( event.keyCode );
			});
		});
		$('#rightPageFrame').load(function() {
			console.log( "RIGHT set keyboard event " );
			$( $('#rightPageFrame')[0].contentWindow.document ).contents().keydown(function(event) {
				keyboardExec( event.keyCode );
			});
		});
		
		setTimeout(function() { $("#header_toggle").children("a").focus(); }, 100);
	};
	keyboardExpPageMove = function( loc ) {
		var gap = 10 * ViewerManager.zoomScore;
		var expWidth = $("#content").width();
		var expHeight = $("#content").height();
		var limitX = ((expWidth * ViewerManager.zoomScore) - expWidth) / 2;
		var limitY = ((expHeight * ViewerManager.zoomScore) -expHeight) / 2;
		var maxX = -limitX;
		var maxY = -limitY;

		var nowX = parseInt($("#content").css("left"));
		var nowY = parseInt($("#content").css("top"));

		switch( loc ) {
			case "left" : nowX = nowX - gap; break;
			case "right" : nowX = nowX + gap; break;
			case "top" : nowY = nowY - gap; break;
			case "bottom" : nowY = nowY + gap; break;

			case  "leftend" : nowX = maxX; nowY = maxY; break;
			case  "rightend" : nowX = limitX; nowY=limitY; break;
		}
		
		if(nowX > limitX)
			nowX = limitX;
		if(nowX < maxX)
			nowX = maxX;
		if(nowY > limitY)
			nowY = limitY;
		if(nowY < maxY)
			nowY = maxY;
		$("#content").css({"left": nowX +"px" , "top" : nowY+"px"});

	};
	keyboardExec = function( code ) {
		var zoom = ViewerManager.zoomScore;
		var rate1 = parseInt(ViewerManager.Settings.zoomRate1) / 100;
		var rate2 = parseInt(ViewerManager.Settings.zoomRate2) / 100;

//console.log(zoom, rate2, code );
		if( zoom <= rate1 ) {
			switch( code ) {
				case kc_ScrollLeftTop :
					if(zoom == 1)
						page.previousPage(2, ViewerManager.PAGE_TOTAL_NUMBER);
					else
						keyboardExpPageMove("rightend");
				break;

				case kc_ScrollRightBottom :
					if(zoom == 1)
						page.nextPage(ViewerManager.PAGE_TOTAL_NUMBER - 2, ViewerManager.PAGE_TOTAL_NUMBER);
					else
						keyboardExpPageMove("leftend");
				break;

				case kc_ScrollLeftBottom :
				case kc_LeafLeft :
					if(zoom == 1)	
						page.nextPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
					else
						keyboardExpPageMove("left");	
				break;
				
				case kc_ScrollRightTop:
				case kc_LeafRight :
					if(zoom == 1)
						page.previousPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
					else
						keyboardExpPageMove("right");
				break;
				
				case kc_ScrollBottom :
					if(zoom > 1)
						keyboardExpPageMove("bottom");
					else
						showhideMenu("hide");	
				break;
					
				case kc_ScrollTop :
					if(zoom > 1)
						keyboardExpPageMove("top");
					else
						showhideMenu("show");

				break;

				case kc_EnLarge : 
					if( zoom < rate2 ) 
						$(".zoomIn").trigger("click");
				break;

				case kc_Shrink :
					$(".zoomOut").trigger("click");
				break;

				case kc_Enter : 
					enterKeyPress();
				break;

				case kc_tab :
					tabKeyPress();
				break;
				
				case kc_esc :
					escKeyPress();
				break;
			}
		} else {
			switch( code ) {
				case kc_ScrollLeftTop :
					keyboardExpPageMove("rightend");
				break;

				case kc_ScrollRightBottom :
					keyboardExpPageMove("leftend");
				break;

				case kc_LeafLeft :
					keyboardExpPageMove("left");
				break;
				case kc_LeafRight :
					keyboardExpPageMove("right");
				break;
				
				case kc_ScrollBottom :
					keyboardExpPageMove("bottom");
				break;
				
				case kc_ScrollTop :
					keyboardExpPageMove("top");
				break;

				case kc_Shrink :
				case kc_EnLarge : 
					$(".zoomOut").trigger("click");
				break;
				case kc_Enter : 
					enterKeyPress();
				break;

				case kc_tab :
					tabKeyPress();
				break;

				case kc_esc :
					escKeyPress();
				break;
			}
		}

	};
	showhideMenu = function(type) {
		if(type == "show") {
			if($("#header").css("display") == "none") {
				$("#btn_menu").trigger("click");
				setTimeout(function() { $("#header_toggle").children("a").focus(); /*tab_cnt=0;*/ tabKeyPress();}, 100);
			}
		} else {
			if($("#header").css("display") != "none") {
				$("#btn_menu").trigger("click");
				setTimeout(function() { $("#header_toggle").children("a").focus(); /*tab_cnt=0;*/ tabKeyPress();}, 100);
			}
		}

	}
	escKeyPress = function() {
		$(".zoomOut").trigger("click");
		if(ViewerManager.currentLayerPopup)
			$("#"+ViewerManager.currentLayerPopup).hide();
		$("#print-modal").hide();

		$(".info_close").trigger("click");
		$("#thumb_container").hide();

		if($("#header").css("display") == "none") {
			$("#btn_menu").trigger("click");
			setTimeout(function() { $("#header_toggle").children("a").focus(); /*tab_cnt=0;*/ tabKeyPress();}, 100);
		}
	}
	enterKeyPress = function() {
		 $(":focus").trigger("click");
		 $(":focus").children().trigger("click");
	}
	var old_focus = "";
	var tab_cnt = 0;
	tabKeyPress = function() {
		var get_id = $(":focus").attr("id");
		var get_class = $(":focus").attr("class");
		var get_ch_id = $(":focus").children().attr("id");
		var get_ch_class = $(":focus").children().attr("class");	
		if( tab_cnt < 1) {
			tab_cnt++;

			setTimeout(function() { $("#header_toggle").children("a").focus(); tabKeyPress();}, 100);
			
			return;
		}

		setTimeout(function(){$(":focus").children().trigger("mouseover");}, 100);
		if( old_focus )
			old_focus.children().trigger("mouseout");

		old_focus = $(":focus");
		
		tab_cnt++;
		/*
		if(get_ch_id == "btn_winclose")
			tab_cnt = 0;
		*/
	}

	var exportKeyboard = {
		initKeyboardEvent : initKeyboardEvent
	};
	
	
	
	return exportKeyboard;
});