"use strict";

function checkArr() {
    for (var e = !1, a = 0; a < agentArray.length; a++)
        if (userAgent.match(String(agentArray[a]).toLowerCase())) {
            e = !0;
            break
        }
    return e
}

function change_require(e) {
    "index" == e ? require(index_type.load_value, index_type.load_func) : "image" == e ? require(image_type.load_value, image_type.load_func) : "main" == e && (ViewerManager.showType = "normal", require(main_type.load_value, main_type.load_func))
}
var userAgent = navigator.userAgent.toLowerCase(),
    test = !1,
    lastType = ".min",
    index_init, index_type, image_type, main_type;
1 == test || "" == userAgent || 1 == checkArr() ? ($("html").html(""), ViewerManager = null, window.close()) : (require.config({
    baseUrl: "",
    shim: {
        xml2json: {
            deps: ["jquery"],
            exports: "xml2json"
        },
        core: {
            deps: ["jquery"],
            exports: "core"
        },
        widget: {
            deps: ["jquery"],
            exports: "widget"
        },
        mouse: {
            deps: ["jquery", "widget"],
            exports: "mouse"
        },
        touchPunch: {
            deps: ["jquery", "widget", "mouse"],
            exports: "touchPunch"
        },
        slider: {
            deps: ["jquery", "core", "mouse", "widget"],
            exports: "slider"
        },
        printarea: {
            deps: ["jquery"],
            exports: "printarea"
        }
    },
    paths: {
        jquery: "libs/jquery",
        xml2json: "libs/jquery.xml2json",
        core: "libs/jquery.core.min",
        mouse: "libs/jquery.mouse.min",
        widget: "libs/jquery.widget.min",
        slider: "libs/jquery.slider",
        printarea: "libs/jquery.PrintArea.js_4",
        base64: "libs/base64",
        touchPunch: "libs/jquery.touchPunch",
        nicescroll: "libs/jquery.nicescroll.min",
        kakao: "libs/kakao.min",
        log: "js/common/log" + lastType,
        version: "js/common/version" + lastType,
        browser: "js/common/browser" + lastType,
        params: "js/data/params" + lastType,
        selectViewer: "js/index/selectViewer" + lastType,
        page: "js/page/page" + lastType,
        epub: "js/data/epub" + lastType,
        lanaguage: "js/data/language" + lastType,
        userInterface: "js/ui/userInterface" + lastType,
        templet: "js/ui/templet" + lastType,
        draw: "js/util/draw" + lastType,
        memo: "js/util/memo" + lastType,
        link: "js/util/link" + lastType,
        responsiveUI: "js/ui/responsiveUI" + lastType,
        search: "js/util/search" + lastType,
        loading: "js/page/loading" + lastType,
        zoom: "js/util/zoom" + lastType,
        indexList: "js/util/indexList" + lastType,
        bookmark: "js/util/bookmark" + lastType,
        thumbnail: "js/util/thumbnail" + lastType,
        print: "js/util/print" + lastType,
        epubImage: "js/data/epubImage" + lastType,
        pageImage: "js/page/pageImage" + lastType,
        share: "js/util/share" + lastType,
		keyboard: "js/ui/keyboard" + lastType
    }
}), index_init = !1, index_type = {
    load_value: ["jquery", "log", "version", "browser", "params", "selectViewer"],
    load_func: function(e, a, r, i, n, t) {
        a("@ start index.js"), a("\n\n" + r.getInfo() + "\n\n"), "none" == n.Params.paramIns && n.paramsInit(), 0 == index_init && 1 == ViewerManager.main_check ? change_require("main") : 0 == index_init && 1 == ViewerManager.image_check && change_require("image"), index_init = !0
    }
}, image_type = {
    load_value: ["jquery", "log", "version", "browser", "params", "epubImage"],
    load_func: function(e, a, r, i, n, t) {
        a("@ start imageView.js"), a("\n\n" + r.getInfo() + "\n\n"), "none" == n.Params.paramIns && n.paramsInit(), index_init = !0
    }
}, main_type = {
    load_value: ["jquery", "log", "version", "browser", "params", "printarea", "epub", "slider", "touchPunch", "page", "lanaguage", "userInterface", "zoom", "templet", "kakao", "thumbnail", "keyboard"],
    load_func: function(e, a, r, i, n, t, o, s, g, l, p, u, c, w, d, M, K) {
        if (a("@ start main.js"), a("\n\n" + r.getInfo() + "\n\n"), "none" == n.Params.paramIns && n.paramsInit(), !i.ie8 && 1 != ViewerManager.openError) {
            if (index_init = !0, a(null === ViewerManager.language || "" === ViewerManager.language || void 0 === ViewerManager.language ? "@ LANGUAGE(navigator.language) = " + navigator.language : "@ LANGUAGE(ViewerManager.language) = " + ViewerManager.language), a("\n @@ S viewer Initializa... \n"), a("@ cntsDirPath= " + ViewerManager.Path.cntsDirPath), a("@ cntsFilePath= " + ViewerManager.Path.cntsFilePath), a("@ cntsTitle= " + ViewerManager.Local.cntsTitle), "color" == ViewerManager.Settings.bgType ? e("#content").css("background", "#" + ViewerManager.Settings.bgColor) : "image" == ViewerManager.Settings.bgType && e("#content").css("background", "url(" + ViewerManager.Settings.bgUrl + ")"), a("@purchase : " + ViewerManager.Params.purchase + " @prePageNo : " + ViewerManager.Params.prePageNo), l.getURLParameter("subjSeq") && (ViewerManager.userInfo.subjSeq = l.getURLParameter("subjSeq")), ViewerManager.sliderValue = 1, ViewerManager.isPageSlider = !1, ViewerManager.PAGE_TOTAL_NUMBER = ViewerManager.ePub.opf_xml2json_total_len, ViewerManager.PAGE_OPS_NAME = ViewerManager.ePub.ops_name, ViewerManager.isDraw = !1, ViewerManager.pageHistory = [], ViewerManager.pageSearchData = [], ViewerManager.checkFirstInit = !1, ViewerManager.pageMODE || (ViewerManager.pageMODE = "EXCEL" != ViewerManager.VIEWER_TYPE ? "DOUBLE" : "SINGLE"), window.innerWidth / window.innerHeight < 4 / 3 && (ViewerManager.pageMODE = "SINGLE", e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png")), ViewerManager.GetData.USE.kakaoAppKey && "" != ViewerManager.GetData.USE.kakaoAppKey && (a("@ Kakao SDK initialize... appKey : " + ViewerManager.GetData.USE.kakaoAppKey), d.init(ViewerManager.GetData.USE.kakaoAppKey)), "true" == ViewerManager.Settings.useComment) {
                var m = document.getElementById("commentBoard_content");
                null != m && (m.innerHTML = '<iframe src="http://titanbooks.co.kr/App/comment/comment.php?book_num=' + ViewerManager.GetData.EPUB.ID + '" style="position:absolute; width:100%; height:100%; z-index:20;"></iframe>');
                var V;
                null != window.localStorage.getItem("comment_" + ViewerManager.GetData.EPUB.ID) && (V = window.localStorage.getItem("comment_" + ViewerManager.GetData.EPUB.ID), e.ajax({
                    url: API.commentNEW + "?book_num=" + ViewerManager.GetData.EPUB.ID + "&date=" + V,
                    error: function(e, a, r) {},
                    success: function(a) {
                        var r = e.xml2json(a),
                            i = parseInt(r.NEW_CNT);
                        i > 0 && (document.getElementById("comment_btn").style.background = 'url("./images/titan_topMenu/topMenu_comment_new.png") no-repeat')
                    }
                }))
            }
            ViewerManager.lastPage = 1, ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.urlPage ? ViewerManager.urlPage : ViewerManager.lastPage, l.initPageHTMLData(), a("@ ViewerManager.userInfo.subjSeq : " + ViewerManager.userInfo.subjSeq), ViewerManager.bookContainerWidth = e(window).width(), ViewerManager.bookContainerHeight = e(window).height(), 0 == ViewerManager.bookContainerHeight && (ViewerManager.bookContainerHeight = e(document).height()), a("@ ViewerManager BookContainer size"), a("@ " + ViewerManager.bookContainerWidth + " / " + ViewerManager.bookContainerHeight), "1" === ViewerManager.progressType && l.initProgressCompletePage(), ViewerManager.pageLoading = function(a, r, i) {
                if ("1" == ViewerManager.Settings.uiHold && ViewerManager.UInormal("show"), parseInt(a) != parseInt(ViewerManager.PAGE_CURRENT_NUMBER) && (ViewerManager.PAGE_CURRENT_NUMBER = a), "DOUBLE" == ViewerManager.pageMODE && parseInt(a) % 2 == 0 && (a = parseInt(a) + 1, ViewerManager.PAGE_CURRENT_NUMBER = a), "true" == ViewerManager.GetData.PROGRESS.progressRate)
                    if ("Order" == ViewerManager.GetData.PROGRESS.progressRateType && ViewerManager.prevPageNumber != parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) {
                        var n = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - ViewerManager.prevPageNumber,
                            t = "SINGLE" == ViewerManager.pageMODE ? 1 : 2;
                        if (n > t) return alert("잘못된 이동입니다."), ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.prevPageNumber, ViewerManager.sliderValue = ViewerManager.prevPageNumber, void("slider" == i && e("#slider-range").slider({
                            range: "min",
                            value: ViewerManager.PAGE_CURRENT_NUMBER,
                            min: 1,
                            max: ViewerManager.PAGE_TOTAL_NUMBER
                        }));
                        ViewerManager.prevPageNumber = parseInt(ViewerManager.PAGE_CURRENT_NUMBER), setData()
                    } else if ("OutOfOrder" == ViewerManager.GetData.PROGRESS.progressRateType) {
                    var o = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
                    ViewerManager.GetData.PROGRESS.progressRateArray[o] = "Y", "DOUBLE" == ViewerManager.pageMODE && parseInt(ViewerManager.PAGE_CURRENT_NUMBER) > 1 && (ViewerManager.GetData.PROGRESS.progressRateArray[o - 1] = "Y");
                    for (var s = "", g = 0; g < ViewerManager.GetData.PROGRESS.progressRateArray.length; g++) s += ViewerManager.GetData.PROGRESS.progressRateArray[g];
                    setData(s)
                }
                if (e("#draw_detail").css("display", "none"), e("#drawing_container").css("display", "none"), c.clearZoom(), 1 != ViewerManager.zoomScore && (ViewerManager.zoomScore = 1, c.zoomViewportCenterAlign()), 0 == parseInt(ViewerManager.Params.purchase) && 0 != parseInt(ViewerManager.Params.prePageNo) && parseInt(ViewerManager.Params.prePageNo) < parseInt(a)) return ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1], ViewerManager.sliderValue = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1], alert("미리보기가 제공되지 않는 페이지 입니다."), void("slider" == i && e("#slider-range").slider({
                    range: "min",
                    value: ViewerManager.PAGE_CURRENT_NUMBER,
                    min: 1,
                    max: ViewerManager.PAGE_TOTAL_NUMBER
                }));
                if ("0" === ViewerManager.progressType && "N" === ViewerManager.progressComplete && ViewerManager.lastPage < a) e("#currentModeNotice").text(ViewerManager.Local.indexListLinkAlert).fadeIn(300, function() {
                    var a = setTimeout(function() {
                        e("#currentModeNotice").fadeOut(500), e("#slider-range").slider({
                            value: ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1]
                        }), ViewerManager.PAGE_CURRENT_NUMBER = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1], ViewerManager.sliderValue = ViewerManager.pageHistory[ViewerManager.pageHistory.length - 1], clearTimeout(a)
                    }, 1e3)
                });
                else {
                    switch (ViewerManager.pageMODE) {
                        case "SINGLE":
                            ViewerManager.PAGE_CURRENT_NUMBER = 1 === parseInt(a) ? parseInt(a) : parseInt(a) - 1;
                            break;
                        case "DOUBLE":
                            1 === parseInt(a) ? ViewerManager.PAGE_CURRENT_NUMBER = parseInt(a) : ViewerManager.PAGE_CURRENT_NUMBER = parseInt(a) + 1, ViewerManager.isOddCheck(a) && (ViewerManager.PAGE_CURRENT_NUMBER = parseInt(a) - 1)
                    }
                    String(location.href).match(".html") || ViewerManager.refreshAD(), l.pageLoading(a, r), e("#chapter #scrollBox ul li").size() > 0 && parseInt(e("chapter #scrollBox ul li.active div").children("div").text()) !== ViewerManager.PAGE_CURRENT_NUMBER && (e("#chapter #scrollBox ul li").removeClass("active"), e("#chapter #scrollBox ul li:eq(" + (ViewerManager.PAGE_CURRENT_NUMBER - 1) + ")").addClass("active"), "lSliderClick" !== i && setTimeout(M.autoNiceScrolling, 300))
                }
            }, ViewerManager.pageResizing = function() {
                l.pageResizing()
            }, ViewerManager.indexList_click = function(e) {
                u.indexList_click(e)
            }, new Array, "ontouchend" in document, ViewerManager.swipeReg = function(a, r) {
                e("#swipe").remove()
            }, ViewerManager.swipeStatus = function(a) {
                "on" == a ? e("#swipe").css("display", "block") : e("#swipe").css("display", "none")
            }, ViewerManager.refreshAD = function() {
                var a;
                String(location.href).match("titanbooks.co.kr") && !String(location.href).match(".html") && (document.getElementById("div-ad-left") && (a = e("#div-ad-left")[0].innerHTML, e("#div-ad-left")[0].innerHTML = "", e("#div-ad-left")[0].innerHTML = a, e("#img-adclose-left").css("display", "inline-block").on("click", function(a) {
                    e("#div-ad-left").remove()
                })), document.getElementById("div-ad-right") && (a = e("#div-ad-right")[0].innerHTML, e("#div-ad-right")[0].innerHTML = "", e("#div-ad-right")[0].innerHTML = a, e("#img-adclose-right").css("display", "inline-block").on("click", function(a) {
                    e("#div-ad-right").remove()
                })))
            };
            var E = document.getElementById("indexListTemplet"),
                _ = document.getElementById("thumb_container");
            e(window).on("touchmove", function(e) {
                "block" != _.style.display && "block" != E.style.display && e.preventDefault()
            });
			
			K.initKeyboardEvent();
            
			var y;
            i.isMobile.iPhone || i.isMobile.iPod || i.isMobile.iPad || i.isMobile.androidPhone || i.isMobile.androidTablet ? e(window).on("orientationchange", function() {
                e("body").css("width", window.innerWidth + "px"), clearTimeout(y), y = setTimeout(function() {
                    a("@page resizing!!!"), l.pageResizing()
                }, 100)
            }) : e(window).on("resize", function() {
                var r = window.innerWidth;
                e("body").css("width", r + "px"), clearTimeout(y), y = setTimeout(function() {
                    a("@page resizing!!!"), l.pageResizing()
                }, 100)
            }), a("@ sliderValue : " + ViewerManager.sliderValue), a("@ PAGE_TOTAL_NUMBER : " + ViewerManager.PAGE_TOTAL_NUMBER), a("@ PAGE_CURRENT_NUMBER : " + ViewerManager.PAGE_CURRENT_NUMBER), a("@ PAGE_OPS_NAME : " + ViewerManager.PAGE_OPS_NAME), String(location.href).match("titanbooks.co.kr") && !String(location.href).match(".html") ? (e("#img-adclose-left").css("display", "inline-block").on("click", function(a) {
                e("#div-ad-left").remove()
            }), e("#img-adclose-right").css("display", "inline-block").on("click", function(a) {
                e("#div-ad-right").remove()
            })) : (e("#div-ad-left").remove(), e("#div-ad-right").remove()), e("body").css("width", window.innerWidth + "px"), e("body").on("focusin", "input, textarea", function(a) {
                if (navigator.userAgent.indexOf("Android") > -1) {
                    var r = e(this).offset();
                    window.scrollTo(0, r)
                }
            }), "true" == ViewerManager.GetData.USE.sunc && ViewerManager.userInfo.loginKey.length > 0 && sync_data("down"), e(document).ready(function() {
                ViewerManager.pageLoading(ViewerManager.urlPage ? ViewerManager.urlPage : ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER)
            })
        }
    }
}), change_require("index");