define(["jquery", "draw", "log", "browser", "params", "templet", "thumbnail"], function(e, a, i, n, r, t, u) {
    "use strict";

    function o(a, i, r) {
        if (!n.ie9 && !n.ie10 || "draw" != i && "memo" != i) {
            var o = 0;
            o = void 0 == r ? -1 : r;
            var s = a.insertCell(r);
            switch (i) {
                case "top_left":
                    e(s).css({
                        width: "5px"
                    });
                    break;
                case "indexList":
                    e(s).css({
                        width: "52px",
                        "text-align": "center"
                    }), s.innerHTML = t.indexList;
                    break;
                case "searchList":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.searchList;
                    break;
                case "zoomIn":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.zoomIn;
                    break;
                case "zoomOut":
                    e(s).css({
                        width: "0px"
                    }), s.innerHTML = t.zoomOut;
                    break;
                case "btn_draw":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_draw, document.getElementById("draw_detail").innerHTML = t.drawDetailMenu;
                    break;
                case "btn_memo":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_memo;
                    break;
                case "btn_link":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_link;
                    break;
                case "btn_share":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_share;
                    break;
                case "btn_fullScreen":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_fullScreen;
                    break;
                case "btn_pageMode":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_pageMode;
                    break;
                case "btn_print":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_print;
                    break;
                case "btn_more":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_more;
                    break;
                case "header_title":
                    e(s).css({
                        "vertical-align": "middle"
                    }), s.innerHTML = t.header_title;
                    break;
                case "btn_login":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_login;
                    break;
                case "btn_filedownload":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_filedownload;
                    break;
                case "btn_winclose":
                    e(s).css({
                        width: "52px"
                    }), s.innerHTML = t.btn_winclose;
                    break;
                case "top_right":
                    e(s).css({
                        width: "10px"
                    });
                    break;
                case "setApp":
                    e(s).css({
                        width: "52px"
                    }), n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad ? s.innerHTML = t.setAppIOS : (n.isMobile.androidPhone || n.isMobile.androidTablet) && (s.innerHTML = t.setAppAndroid);
                    break;
                case "mainage_logo":
                    e(s).css({
                        width: "145px",
                        "padding-left": "20px"
                    }), s.innerHTML = '<img class="setLogo" src="images/logo/logo.png" alt="메인에이지" title="메인에이지">'
            }
        }
    }
    if (i("\n @ import responsiveUI.js ... \n"), "none" == r.Params.paramIns && r.paramsInit(), !n.ie8) {
        var s = 768;
        ViewerManager.isOddCheck = function(e) {
            var a = parseInt(e) % 2,
                i = parseInt(e) % 2 + 1;
            return 0 === a && 1 === i ? !0 : !1
        }, ViewerManager.adjustDoublePage = function(e) {
            var a;
            switch (ViewerManager.pageMODE) {
                case "SINGLE":
                    a = ViewerManager.isOddCheck(e) && 1 !== parseInt(e) ? 0 : ViewerManager.iframeContentsWidth;
                    break;
                case "DOUBLE":
                    a = 0
            }
            return a
        };
        var d, g, M = function() {
                ViewerManager.CustomizeType.split("MENU");
                if (n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone || n.isMobile.androidTablet) {
                    i("@ Mobile Device!"), 
                    e("#topMenuTableTr").css("display", "table-row"), 
                    e("#header_toggle").css("display", "block").css("left", "50%").css("left", "-=27px"), 
                    ViewerManager.eventSelector = {
                        downEvent: "touchstart",
                        moveEvent: "touchmove",
                        upEvent: "touchend"
                    };
                    var a = document.getElementById("topMenuTableTr");
                    if(!(ViewerManager.CustomizeType.indexOf("K2WEB_") == 0)) {
                    	o(a, "top_left", 0), o(a, "indexList", 1), o(a, "header_title", 2);
                    }
                    var r = document.getElementById("bottomMenuTableTr");
                    switch (p("init"), ViewerManager.CustomizeType) {
                        case "MAINAGE":
                            o(a, "mainage_logo", 0), e("#bookmark_container").css("display", "none"), e("#header table").css("margin-top", "6px");
                            break;
                        case "SSG":
                            o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "btn_draw", 4), o(a, "btn_memo", 5), o(a, "btn_winclose", -1);
                            break;
                        case "7MENU2":
                        	//엑셀 viewer
                        case "8MENU2":
                            o(a, "btn_draw", 2);
                            break;
                        case "7MENU3":
                        case "8MENU3":
                            o(a, "btn_draw", 2), o(a, "setApp", -1);
                            break;
                        case "8MENU4":
                        	// 기본 viewer
                            o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "btn_draw", 4), o(a, "btn_memo", 5), String(ViewerManager.fileDownloadURL).length > 0 && o(a, "btn_filedownload", -1), String(location.href).match("titanbooks.co.kr") && o(a, "btn_login", -1), o(r, "setApp", 0);
                            break;
                        case "8MENU6":
                            o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "btn_draw", 4), o(a, "btn_memo", 5), o(a, "setApp", -1);
                            break;
                        case "K2WEB_DEFAULT":
                        case "K2WEB_EXCEL":
                        	ViewerManager.GetData.USE.share === "1"?
                        			(o(a, "top_left", 0), o(a, "btn_share", 1), o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "header_title", 4), o(a, "btn_fullScreen", 5)) : 
                        			(o(a, "top_left", 0), o(a, "zoomIn", 1), o(a, "zoomOut", 2), o(a, "header_title", 3), o(a, "btn_fullScreen", 4));
                        	break;
                    }
                    o(a, "top_right", -1)
                } else {
                    i("Desktop Computer!"), e("#topMenuTableTr").css("display", "table-row"), e("#header_toggle").css("display", "block").css("left", "50%").css("left", "-=27px"), ViewerManager.eventSelector = {
                        downEvent: "mousedown",
                        moveEvent: "mousemove",
                        upEvent: "mouseup"
                    };
                    var a = document.getElementById("topMenuTableTr");
                    switch (o(a, "top_left", 0), ViewerManager.CustomizeType) {
                        case "NASARET":
                            o(a, "indexList", 1), o(a, "searchList", 2), o(a, "zoomIn", 3), o(a, "zoomOut", 4), o(a, "btn_fullScreen", 5), o(a, "header_title", 6), e("#header_toggle").css("display", "none"), _(), ViewerManager.pageMODE = "SINGLE";
                            break;
                        case "MAINAGE":
                            o(a, "zoomIn", 1), o(a, "zoomOut", 2), o(a, "btn_fullScreen", 3), o(a, "btn_pageMode", 4), o(a, "header_title", 5), o(a, "mainage_logo", 0), e("#header_toggle").css("display", "none"), e("#bookmark_container").css("display", "none"), _();
                            break;
                        case "DAEGUNAVI":
                            o(a, "zoomIn", 1), o(a, "zoomOut", 2), o(a, "btn_draw", 3), o(a, "btn_fullScreen", 4), o(a, "btn_pageMode", 5), o(a, "header_title", 6), e("#bookmark_container").css("display", "none");
                            break;
                        case "SSG":
                            o(a, "indexList", 1), o(a, "searchList", 2), o(a, "zoomIn", 3), o(a, "zoomOut", 4), n.ie8 || n.ie9 || n.ie10 ? (o(a, "btn_fullScreen", 5), o(a, "btn_pageMode", 6), o(a, "header_title", 7)) : (o(a, "btn_draw", 5), o(a, "btn_memo", 6), o(a, "btn_fullScreen", 7), o(a, "btn_pageMode", 8), o(a, "header_title", 9));
                            break;
                        case "7MENU1":
                        case "7MENU2":
                        	//엑셀 viewer
                        	o(a, "btn_share", 1), o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "btn_fullScreen", 4), o(a, "btn_print", 5);
                            break;
                        case "7MENU3":
                            o(a, "indexList", 1), o(a, "searchList", 2), o(a, "zoomIn", 3), o(a, "zoomOut", 4), n.ie8 || n.ie9 || n.ie10 ? (o(a, "btn_fullScreen", 5), o(a, "btn_pageMode", 6), o(a, "header_title", 7)) : (o(a, "btn_draw", 5), o(a, "btn_fullScreen", 6), o(a, "btn_pageMode", 7), o(a, "header_title", 8));
                            break;
                        case "8MENU2":
                        case "8MENU3":
                        case "8MENU4":
                        	// 기본 viewer
                        	o(a, "indexList", 1), o(a, "searchList", 2), o(a, "zoomIn", 3), o(a, "zoomOut", 4), n.ie8 || n.ie9 || n.ie10 ? (o(a, "btn_fullScreen", 5), o(a, "btn_pageMode", 6), o(a, "header_title", 7)) : (o(a, "btn_draw", 5), o(a, "btn_memo", 6), o(a, "btn_fullScreen", 7), o(a, "btn_pageMode", 8), o(a, "header_title", 9));
                            break;
                        case "8MENU6":
                         
                        case "9MENU4":
                            o(a, "indexList", 1), o(a, "searchList", 2), o(a, "zoomIn", 3), o(a, "zoomOut", 4), n.ie8 || n.ie9 || n.ie10 ? (o(a, "btn_fullScreen", 5), o(a, "btn_pageMode", 6), o(a, "header_title", 7)) : (o(a, "btn_draw", 5), o(a, "btn_memo", 6), o(a, "btn_link", 7), o(a, "btn_fullScreen", 8), o(a, "btn_pageMode", 9), o(a, "header_title", 10));
                            break;
                        case "K2WEB_DEFAULT":
                        	// 2017.10 UI개선 기본 viewer
                        	ViewerManager.GetData.USE.share === "1"?
                        			(o(a, "indexList", 1), o(a, "searchList", 2), o(a, "btn_memo", 3), o(a, "btn_draw", 4), o(a, "btn_filedownload", 5), o(a, "btn_share", 6), o(a, "zoomIn", 7), o(a, "zoomOut", 8), o(a, "header_title", 9), o(a, "btn_pageMode", 10), o(a, "btn_fullScreen", 11), o(a, "btn_print", 12)) : 
                        			(o(a, "indexList", 1), o(a, "searchList", 2), o(a, "btn_memo", 3), o(a, "btn_draw", 4), o(a, "btn_filedownload", 5), o(a, "zoomIn", 6), o(a, "zoomOut", 7), o(a, "header_title", 8), o(a, "btn_pageMode", 9), o(a, "btn_fullScreen", 10), o(a, "btn_print", 11));
                        	break;
                        case "K2WEB_EXCEL":
                        	// 2017.10 UI개선 excel viewer
                        	ViewerManager.GetData.USE.share === "1"?
                        			(o(a, "btn_share", 1), o(a, "zoomIn", 2), o(a, "zoomOut", 3), o(a, "header_title", 4), o(a, "btn_fullScreen", 5), o(a, "btn_print", 6)) : 
                        			(o(a, "zoomIn", 1), o(a, "zoomOut", 2), o(a, "header_title", 3), o(a, "btn_fullScreen", 4), o(a, "btn_print", 5));
                    }
                    if(!(ViewerManager.CustomizeType.indexOf("K2WEB_") == 0)) {
                    	String(ViewerManager.fileDownloadURL).length > 0 && o(a, "btn_filedownload", -1);
                    }
                    String(location.href).match("titanbooks.co.kr") && o(a, "btn_login", -1), 
                    o(a, "btn_winclose", -1), 
                    o(a, "top_right", -1)
                }
            },
            w = function(a, i) {
                switch (a) {
                    case "#adpage_iframe":
                        "http://titanbooks.co.kr" == document.domain && (document.domain = "http://titanbooks.co.kr");
                        break;
                    case "#components":
                        var n = .8;
                        e(a).css({
                            "-ms-transform": "scale(" + (n > i ? n : i) + "," + (n > i ? n : i) + ")",
                            "-webkit-transform": "scale(" + (n > i ? n : i) + "," + (n > i ? n : i) + ")",
                            transform: "scale(" + (n > i ? n : i) + "," + (n > i ? n : i) + ")",
                            "transform-origin": "0% 0%",
                            "-webkit-transform-origin": "0% 0%",
                            "-ms-transform-origin": "0% 0%"
                        })
                }
                ViewerManager.zoomRate = i
            },
            l = function() {
                if (n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone || n.isMobile.androidTablet) i("@ Mobile Device!"), e("#header_toggle").css("display", "block").css("left", "50%").css("left", "-=27px"), e("#chapter").hide(), p("resize");
                else {
                    if (i("Desktop Computer!"), window.innerWidth / window.innerHeight >= 1) {
                        /*if (e("#header_container").css("width", "100%"), e("#footer_container").css("width", "100%"), ViewerManager.pageMODE = "DOUBLE", e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png"), parseInt(ViewerManager.PAGE_CURRENT_NUMBER) % 2 == 0) {
                            var a = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;
                            ViewerManager.PAGE_CURRENT_NUMBER = a
                        }*/
                        ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER)
                    } else 
                    	e("#header_container").css("width", s + " px"), 
                    	e("#footer_container").css("width", s + " px"), 
                    	(ViewerManager.VIEWER_TYPE!="EXCEL" && (ViewerManager.pageMODE = "SINGLE", e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png"))), 
                    	ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER),
                    	(ViewerManager.VIEWER_TYPE!="EXCEL" && e("#chapter #scrollBox ul").children("li").size()<1 && u.slideThumbnailList());
                    "none" == e("#header").css("display") && (e("#btn_menu").attr("src", "images/topArrowDown_btn_01.png"), e("#header_toggle").css("display", "block")), e("#header_toggle").css("left", "50%").css("left", "-=27px")
                }
                (ViewerManager.VIEWER_TYPE=="EXCEL" && u.sheetList())
            },
            c = function(a, r) {
                i("@ first iframeContentsWidth : " + ViewerManager.iframeContentsWidth), i("@ first iframeContentsHeight : " + ViewerManager.iframeContentsHeight);
                var t, o;
                switch (ViewerManager.pageMODE) {
                    case "SINGLE":
                        t = e(r).contents().find("body").width(), o = e(r).contents().find("body").height();
                        var s, M = window.innerWidth / t - (!(n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone) && "EXCEL"!=ViewerManager.VIEWER_TYPE? 0.3 : 0),
                            l = window.innerHeight / o;
                        if (window.innerWidth / window.innerHeight < 7 / 3 ? (s = M, (window.innerHeight - o * s) / 2 < 0 && (s = l)) : s = l, n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone || n.isMobile.androidTablet)
                            if ((n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone) && (d = 0, g = 180), !n.isMobile.androidPhone && n.isMobile.androidTablet && (d = 90, g = -90), window.orientation === d || window.orientation === g) {
                            	var c;
                                if (c = ViewerManager.iframeContentsWidth * ViewerManager.bookContainerHeight > ViewerManager.iframeContentsHeight * ViewerManager.bookContainerWidth ? ViewerManager._zoom_horizontal : ViewerManager._zoom_vertical, w(a, s), w("#adpage_iframe", s), n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone || n.isMobile.androidTablet) {
                                    (e(window).innerWidth() - e(a).contents().find("body").width() * s) / 2, (e(window).innerHeight() - e(a).contents().find("body").height() * s) / 2
                                }
                            } else {
                                var c;
                                if (c = ViewerManager.iframeContentsWidth * ViewerManager.bookContainerHeight > ViewerManager.iframeContentsHeight * ViewerManager.bookContainerWidth ? ViewerManager._zoom_horizontal : ViewerManager._zoom_vertical, w(a, s), w("#adpage_iframe", s), n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone || n.isMobile.androidTablet) {
                                    (e(window).innerWidth() - e(a).contents().find("body").width() * s) / 2, (e(window).innerHeight() - e(a).contents().find("body").height() * s) / 2
                                }
                            }
                        else ViewerManager.iframeContentsWidth * ViewerManager.zoomRate > ViewerManager.bookContainerWidth ? (w(a, s), w("#adpage_iframe", s)) : (w(a, s), w("#adpage_iframe", s));
                        e("#pages").css({
                            "margin-top": parseInt((window.innerHeight - o * ViewerManager.zoomRate) / 2) + "px",
                            "margin-left": parseInt((window.innerWidth - t * ViewerManager.zoomRate) / 2)  + (!(n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone) && ViewerManager.VIEWER_TYPE!="EXCEL"? 200 : 0) + "px"
                        }), 
                        !(n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone) && ViewerManager.VIEWER_TYPE!="EXCEL" && e("#chapter").css("display", "block"), 
                        e("#gras .graLeft").css("display", "none"), 
                        e("#gras .graRight").css("display", "none");
                        break;
                    case "DOUBLE":
                        t = e(r).contents().find("body").width(), o = e(r).contents().find("body").height();
                        var s, M = window.innerWidth / (2 * t),
                            l = window.innerHeight / o;
                        window.innerWidth / window.innerHeight >= 4 / 3 ? (s = l, (window.innerWidth - 2 * t * s) / 2 < 0 && (s = M)) : s = M, w(a, s), w("#adpage_iframe", s), e("#rightPageFrame").css({
                            "margin-left": e(r).contents().find("body").width() +  "px"
                        }), ViewerManager.VIEWER_TYPE!="EXCEL" && e("#chapter").hide(), e("#content").css("padding-left", "0"), 
                        	e("#pages").css({
                            "margin-top": (window.innerHeight - o * ViewerManager.zoomRate) / 2 + "px",
                            "margin-left": (window.innerWidth - 2 * t * ViewerManager.zoomRate) / 2 + "px"
                        }), 1 == ViewerManager.PAGE_CURRENT_NUMBER ? (e("#gras .graLeft").css({
                            display: "none"
                        }), e("#gras .graRight").css({
                            display: "block"
                        })) : (e("#gras .graLeft").css({
                            display: "block"
                        }), e("#gras .graRight").css({
                            display: "block"
                        }), ViewerManager.PAGE_CURRENT_NUMBER >= ViewerManager.PAGE_TOTAL_NUMBER && ViewerManager.PAGE_TOTAL_NUMBER % 2 == 0 && e("#gras .graRight").css({
                            display: "none"
                        }))
                }
                if (r.setAttribute("width", e(r).contents().find("body").width()), r.setAttribute("height", e(r).contents().find("body").height()), "none" == e("#bookmark_container").css("display") && e("#bookmark_container").css("display", "block"), e("#pages").css({
                        transform: "scale(" + s + ")",
                        "-o-transform": "scale(" + s + ")",
                        "-webkit-transform": "scale(" + s + ")",
                        "-moz-transform": "scale(" + s + ")",
                        "-ms-transform": "scale(" + s + ")"
                    }), e("#adpage_iframe")) {
                    var p = e("#adpage_iframe_iframe");
                    p.css({
                        width: ViewerManager.iframeContentsWidth * ViewerManager.zoomRate + "px",
                        height: ViewerManager.iframeContentsHeight * ViewerManager.zoomRate + "px",
                        "margin-top": "0",
                        "margin-left": "0"
                    })
                }
                var _ = (parseInt((ViewerManager.bookContainerHeight - ViewerManager.bookContainerHeight / ViewerManager.zoomRate * ViewerManager.zoomRate) / 2), parseInt((ViewerManager.bookContainerWidth - ViewerManager.bookContainerWidth / ViewerManager.zoomRate * ViewerManager.zoomRate) / 2));
                e("#gras .graLeft img").css({
                    width: ViewerManager.Settings.graWidth + "px"
                }), e("#gras .graRight img").css({
                    width: ViewerManager.Settings.graWidth + "px"
                }), e("#gras .graLeft").css({
                    height: e("#leftPageFrame").height() + "px",
                    left: e("#leftPageFrame").width() + _ - ViewerManager.Settings.graWidth + "px"
                }), e("#gras .graRight").css({
                    height: e("#rightPageFrame").height() + "px",
                    left: e("#leftPageFrame").width() + _ + "px"
                });
                var b = "SINGLE" == ViewerManager.pageMODE ? 1 : 2;
                e("#components").css({
                    left: (window.innerWidth - t * b * ViewerManager.zoomRate) / 2 + "px",
                    top: (window.innerHeight - o * ViewerManager.zoomRate) / 2 + "px"
                })
            },
            p = function(a) {
                document.getElementById("topMenuTableTr");
                if ((0 == window.orientation || 90 == window.orientation || 180 == window.orientation || -90 == window.orientation) && ((n.isMobile.iPhone || n.isMobile.iPod || n.isMobile.iPad || n.isMobile.androidPhone) && (d = 0, g = 180), !n.isMobile.androidPhone && n.isMobile.androidTablet && (d = 90, g = -90), window.orientation == d || window.orientation == g ? (i("@ portrait mode ..."), ViewerManager.pageMODE = "SINGLE", e("#btn_pageMode").parents("td").css("display", "none"), e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png"), ViewerManager.PAGE_CURRENT_NUMBER = 1 === parseInt(ViewerManager.PAGE_CURRENT_NUMBER) ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1, ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER) : (i("@ landsacpe mode ..."), ViewerManager.pageMODE = "DOUBLE", e("#btn_pageMode").parents("td").css("display", "block"), e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png"), 1 === parseInt(ViewerManager.PAGE_CURRENT_NUMBER) ? ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1, ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER) && (ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1), ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER), "resize" === a && ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER)), window.screen.orientation) {
                    var r = window.screen.orientation.type.split("-")[0];
                    if (ViewerManager.VIEWER_TYPE == "EXCEL" || "portrait" == r ? (i("@ portrait mode ..."), ViewerManager.pageMODE = "SINGLE", e("#btn_pageMode").parents("td").css("display", "none"), e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png"), ViewerManager.PAGE_CURRENT_NUMBER = 1 === parseInt(ViewerManager.PAGE_CURRENT_NUMBER) ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1, ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER) : "landscape" == r && (i("@ landscape mode ..."), ViewerManager.pageMODE = "DOUBLE", e("#btn_pageMode").parents("td").css("display", "block"), e("#btn_pageMode").attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png"), 1 === parseInt(ViewerManager.PAGE_CURRENT_NUMBER) ? ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1, ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER) && (ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1), ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER), "resize" === a) {
                        if (!ViewerManager || !ViewerManager.pageLoading) return void setTimeout(function() {
                            p("resize") 
                        }, 500);
                        setTimeout(function() {
                        	ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER),
                        	(ViewerManager.VIEWER_TYPE == "EXCEL" && u.sheetList());
                        }, 500);
                    }
                }
            },
            _ = function() {
                (n.ie9 || n.ie10 || !n.chrome && n.safari) && topMenuTableTr.deleteCell(5);
                var a = 60;
                e("#container").append("<div id='over_top' style='position:absolute; left:0; top;0; width:" + e("#header_container").width() + "px; height:" + (e("#header_container").height() + 30) + "px; background:#000; z-index:11; opacity:0;'></div>"), e("#over_top").bind("mousemove", function(i) {
                    i.pageY < a && "none" == e("#header").css("display") ? (e("#header").slideDown(ViewerManager.Settings.menuSpeed), ViewerManager.swipeStatus("off")) : i.pageY >= a && "block" == e("#header").css("display") && (e("#header").slideUp(ViewerManager.Settings.menuSpeed), ViewerManager.indexList_click("showmove"), ViewerManager.swipeStatus("on"))
                }), e("#container").append("<div id='over_bottom' style='position:absolute; left:0; bottom:0; width:" + e("#footer_container").width() + "px; height:" + (e("#footer_container").height() + 30) + "px; background:#000; z-index:11; opacity:0;'></div>");
                var i, r;
                e("#over_bottom").bind("mousemove", function(n) {
                    i = window.innerHeight, r = i - n.pageY, a >= r && "none" == e("#footer_container").css("display") ? (e("#footer_container").slideDown(ViewerManager.Settings.menuSpeed), ViewerManager.swipeStatus("off")) : r > a && "block" == e("#footer_container").css("display") && (e("#footer_container").slideUp(ViewerManager.Settings.menuSpeed), ViewerManager.swipeStatus("on"))
                }), e(document).on("mouseleave", function(a) {
                    "block" == e("#header").css("display") && (e("#header").slideUp(ViewerManager.Settings.menuSpeed), ViewerManager.indexList_click("showmove"), ViewerManager.swipeStatus("on")), "block" == e("#footer_container").css("display") && (e("#footer_container").slideUp(ViewerManager.Settings.menuSpeed), ViewerManager.swipeStatus("on"))
                })
            },
            b = {
                setResponsiveMobileUI: M,
                resizeResponsiveUI: l,
                setResponsiveScale: c
            };
        return b
    }
});